2010-08-16  Morten Welinder <terra@gnome.org>

	* Release 1.10.9

2010-07-30  Morten Welinder <terra@gnome.org>

	* Release 1.10.8

2010-07-28  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* excel-xml-read.c (xl_xml_font): add UNDERLINE_*_LOW
	* ms-excel-read.c (xls_uline_to_gnm_underline): new
	(excel_get_style_from_xf): use xls_uline_to_gnm_underline
	(ms_wb_get_font_markup): use gnm_translate_underline_to_pango
	(excel_read_CF): use xls_uline_to_gnm_underline
	* ms-excel-write.c (map_underline_to_xl) rename
	  to map_style_underline_to_xl and use new map_underline_to_xl,
	  change all callers
	(map_underline_to_xl): new
	(excel_font_to_string): add UNDERLINE_*_LOW
	(excel_font_overlay_pango): use gnm_translate_underline_from_pango
	(excel_font_from_go_font): fix typo
	(excel_write_FONT): use map_underline_to_xl
	* xlsx-read.c (xlsx_font_uline): add UNDERLINE_*_LOW
	(xlsx_font_valign): fix typo

2010-07-27  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-read.h (ExcelFont): change underline field from PangoUnderline 
	  to MsBiffFontUnderline
	* ms-excel-read.c (excel_read_FONT): underline field of ExcelFont is not
	  a GnmUnderline but (now) a MsBiffFontUnderline
	(excel_get_style_from_xf): convert underline from MsBiffFontUnderline
	  to GnmUnderline

2010-07-26  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (write_arrow): Fix argument type for "id".

2010-07-13  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (chart_write_AREAFORMAT): fixed the auto flag. [see
	#624263]

2010-07-10  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (end): do not crash when a chart has more than one
	plot. [#623960]

2010-07-09  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_SETUP): Avoid right-shift bigger
	than type.

2010-06-28  Morten Welinder <terra@gnome.org>

	* Release 1.10.7

2010-06-23  Morten Welinder  <terra@gnome.org>

	* xlsx-read.c (xlsx_CT_RowsCols_end): New function.
	(xlsx_CT_Col): Delay applying the style so we can merge areas.
	Fixes #622365.

2010-06-16  Morten Welinder <terra@gnome.org>

	* Release 1.10.6

2010-05-30  Morten Welinder <terra@gnome.org>

	* Release 1.10.5

2010-05-20  Morten Welinder <terra@gnome.org>

	* Release 1.10.4

2010-05-07  Morten Welinder <terra@gnome.org>

	* Release 1.10.3

2010-04-29  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_DOPER): Fix saving of integers.
	(excel_write_AUTOFILTERINFO): Fix swapped "and" and "or".

2010-04-23  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (supbook_get_sheet): Return "deleted sheet" for
	exernal references so we don't end up with sheet-local refs.
	(excel_read_SUPBOOK): Clean up using new docs.

2010-04-21  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (ai), (objectlink), (end), (ms_excel_chart_read): import
	chart title when it is actually the series label. [#616262]

2010-04-16  Morten Welinder <terra@gnome.org>

	* Release 1.10.2

2010-04-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_textbox_or_widget_v8): Take
	bp->length into account too.

2010-04-14  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_workbook): write 1900/1904 date base
	info

2010-04-14  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-read.c (xlsx_CT_WorkbookPr): new
	(xlsx_workbook_dtd); hook up xlsx_CT_WorkbookPr

2010-03-31  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (chart_write_AREAFORMAT): export transparent patterns as
	no filling.

2010-03-29  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (write_funcall): Guess argument types for
	functions that the excel format doesn't know about.
	(guess_arg_types): New function.

	* ms-excel-write.c (excel_write_externsheets_v7,
	excel_write_externsheets_v8): Fix letter case for extername
	records.

2010-03-08  Morten Welinder <terra@gnome.org>

	* Release 1.10.1

2010-02-18  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_cells): use value_get_as_gstring
	  rather than value_get_as_string. [#610372]

2010-02-13  Morten Welinder <terra@gnome.org>

	* Release 1.10.0

2010-01-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-excel-write.c (excel_write_textbox_or_widget_v8): export transparency
	for filled objects.

2010-01-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-excel-read.c (ms_sheet_realize_obj): really import transparent objects.

2010-01-19  Morten Welinder <terra@gnome.org>

	* Release 1.9.18

2009-12-29  Jody Goldberg <jody@gnome.org>

	* xls-read-pivot.c (xls_read_SXVI) : new stub.  Currently only notices
	  when XL wants to hide things.
	(xls_read_SXVD) : used from here.

2009-12-24  Jean Brefort  <jean.brefort@normalesup.org>

	* xlsx-read-pivot.c (xlsx_CT_Number),
	(xlsx_CT_pivotCacheDefinition): fixed double/gnm_float issues.
	* xlsx-read.c (xlsx_axis_bound), (elem_color), (xlsx_CT_Row),
	(xlsx_CT_Col), (xlsx_CT_SheetFormatPr), (xlsx_CT_PageMargins),
	(xlsx_CT_Top10), (xlsx_CT_Pane), (xlsx_CT_FontSize): ditto.

2009-12-21  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (lineformat), (chart_write_LINEFORMAT): fix import export
	of line type in scatter plots. [#605043]

2009-12-15  Morten Welinder <terra@gnome.org>

	* Release 1.9.17

2009-12-09  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (end): always initialize matrix bounds. [#593937]

2009-11-29  Morten Welinder <terra@gnome.org>

	* Release 1.9.16

2009-11-01  Morten Welinder <terra@gnome.org>

	* Release 1.9.15

2009-10-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_DIMENSIONS): Store dimensions for
	clipboard use.

2009-10-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_line_v8): Fix handling of
	direction.
	(excel_write_textbox_or_widget_v8, excel_write_line_v8): Export
	line styles.

2009-10-14  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_read_OPT): Don't arbitrarily add 1 to
	MS_OBJ_ATTR_OUTLINE_STYLE's value.

	* ms-excel-read.c (ms_sheet_realize_obj): Read dash style
	correctly.
	(xl_pattern_to_line_type): Fix mapping.

	* ms-excel-write.c (excel_write_line_v8): Export line start arrow
	head too.

2009-10-13  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (excel_write_array_formula): Set
	allow_sheetless_ref to avoid t8001 failure.

	* ms-obj.c (ms_objv8_write_spinbutton, ms_objv8_write_adjustment):
	New functions.

2009-10-12  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (excel_write_formula): Handle new
	EXCEL_CALLED_FROM_OBJ.
	(CTXT_NAME_OBJ): Rename from CTXT_NAME.

	* ms-obj.c (ms_objv8_write_macro_fmla): Use EXCEL_CALLED_FROM_OBJ.

	* ms-excel-write.c (excel_write_textbox_v8): Don't write macro
	records yet.

	* ms-obj.c (ms_objv8_write_checkbox_fmla,
	ms_objv8_write_macro_fmla): Pad length; use NAME context.
	(ms_objv8_write_checkbox_link): Take extra "active" argument.  All
	callers changed.

2009-10-11  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_textbox_v8): Call
	ms_objv8_write_radiobutton_data when appropriate.

	* ms-obj.c (ms_objv8_write_radiobutton_data): New function.

	* ms-escher.c (ms_escher_clientdata): Drop argument that turned
	out to be not useful.

2009-10-11  Morten Welinder <terra@gnome.org>

	* Release 1.9.14

2009-10-09  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_autofilter_names): Initialize
	nexpr.pos completely.

	* ms-excel-read.c (excel_read_NAME): Fix FMR in debug code.

	* ms-obj.c (ms_obj_read_biff8_obj): Read the macro reference too.

2009-10-08  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_opt_add_bool): New function.

	* ms-excel-write.c (excel_write_line_v8): Simplify using
	ms_escher_opt_add_bool.

2009-10-07  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_textbox_v8): Export
	checkbox/radiobutton link and current value.

	* ms-obj.c (ms_objv8_write_checkbox_fmla,
	ms_objv8_write_checkbox_data): New functions.

	* ms-escher.c (ms_escher_opt_add_color): New function.

	* ms-excel-write.c (excel_write_textbox_v8): Make sure the textbox
	gets to be part of the container.  Export line and background
	colours.  Export outline width.
	(excel_write_line_v8): Export line colour and width.

	* ms-escher.c (ms_escher_opt_end): Docs were wrong.  Do not
	include own header in length.
	(ms_escher_opt_add_str_wchar): Fix type error.

2009-10-06  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (ms_sheet_realize_obj): Restore colour reading.
	(ms_sheet_map_color): Add new "pauto" argument.  All callers
	changed.

2009-10-05  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_textbox_v8): Export
	object name.
	(excel_sheet_new): Prepare for handling lines.
	(blipinf_new): Plug leak.
	(extract_txomarkup): Plug leak.
	(xf_init, cb_cell_pre_pass, cb_accum_styles,
	excel_write_ClientTextbox): Plug leak.
	(excel_write_line_v8): Export lines and arrows.

	* ms-biff.h (_BiffPut): Change type of streamPos to gsf_off_t.

	* ms-chart.c (chart_write_axis): Don't dump uninitialized memory
	into file.
	(map_1_5d_type): Plug leak.

	* ms-biff.c (ms_biff_put_len_next): Make sure we don't mix _var_
	and _len_ calls.  Make sure we commit.

2009-10-04  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_textbox_v8): Attempt to handle
	rectangles and ovals.

	* ms-escher.c (ms_escher_get_inst, ms_escher_set_inst,
	ms_escher_spcontainer_start, ms_escher_spcontainer_end,
	ms_escher_sp, ms_escher_opt_start, ms_escher_opt_end,
	ms_escher_opt_add_simple, ms_escher_clientanchor,
	ms_escher_clientdata): New functions.

	* ms-excel-write.c (excel_write_textbox_v8): Use new Escher output
	utilities.

2009-10-02  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_new): Display name of sheet
	objects we cannot export.

	* ms-excel-read.c (ms_sheet_realize_obj): Set object name if we
	have it.

	* ms-escher.c (ms_escher_read_OPT): Assume pointers are UTF-16
	strings, not UTF-8.  Fits objs.xls

	* ms-excel-write.c (excel_sheet_new): Don't complain over filter
	combos.  They are handled, but differently.

2009-10-01  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_new): Exclude GNM_SO_FILLED_TYPE
	objects with no text as we do not export them right.  [#596886]

2009-09-20  Morten Welinder <terra@gnome.org>

	* Release 1.9.13

2009-09-05  Morten Welinder <terra@gnome.org>

	* Release 1.9.12

2009-09-05  Jean Brefort  <jean.brefort@normalesup.org>

	* all files: renamed go-color.h macros.

2009-09-05  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (end): don't use z values as x or y when there are no
	labels or categories. [See #593937]

2009-09-04  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (axis), (xl_axis_get_elem), (valuerange): use gnm_go_data
	instead of simple go_data [#594068],
	(end): don't require x and y values for surfaces.

2009-09-01  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: renamed GOColor macros.
	* ms-excel-read.c: ditto.
	* ms-excel-write.c: ditto.
	* xlsx-read.c: ditto.
	* xlsx-write.c: ditto.

2009-08-31  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (lineformat), (ms_excel_chart_read),
	(style_is_completely_auto), (chart_write_style),
	(chart_write_DROPBAR): replace GOStyle::outline.
	* ms-excel-read.c (ms_sheet_realize_obj): ditto.
	* ms-excel-write.c (extract_gog_object_style): ditto.
	* xlsx-read.c (xlsx_draw_line_dash): ditto.

2009-08-30  Morten Welinder <terra@gnome.org>

	* Release 1.9.11

2009-08-15  Morten Welinder <terra@gnome.org>

	* Release 1.9.10

2009-06-20  Morten Welinder <terra@gnome.org>

	* Release 1.9.9

2009-06-17  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_breaks): Quiet enum handling

2009-06-16  Morten Welinder  <terra@gnome.org>

	* boot.c: Quiet pivot debugging.

2009-06-11  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-read.c (excel_parse_name): If it looks like the print area
	  could have been one of our old "whole sheet" areas, set it to nil.

2009-06-09  Jody Goldberg <jody@gnome.org>

	* xls-read-pivot.c (xls_read_SXIVD) : ignore magic index of 0xfffe.
	  Need to figure out what it does.

2009-06-07  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (excel_write_PAGE_BREAK): don't save automatic
	  page breaks

2009-05-23  Morten Welinder <terra@gnome.org>

	* Release 1.9.8

2009-05-19  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_WINDOW1): Normalize bools, or else
	gobject will complain.

2009-05-18  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_WINDOW1): Use g_object_set instead
	of poking directly into a WorkbookView.

2009-05-14  Jon K Hellan  <hellan@acm.org>

	* ms-excel-util.c (init_xl_font_widths): Add DejaVu fonts with
	same metrics as Bitstream Vera.

2009-05-10  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_cols): and don't commit debugging code

2009-05-10  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_cols): fix off-by-one error [#569862]

2009-05-10  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* xlsx-write.c (xlsx_write_sheet): write the tags in schema ordering

2009-05-06  Morten Welinder <terra@gnome.org>

	* Release 1.9.7

2009-05-06  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_init): Use the GnmFunc's case in the
	hash.

2009-05-05  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_write_block): Add one-element
	cache.  Fixes #581378.

2009-05-02  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (get_style), (ms_excel_chart_read): use reimplemented
	gog_style_new().

2009-04-28  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c : initial work on reading external refs.   Still broken
	  for refs to sheets with spaces in their names '[1]A Space!A1' thanks
	  to massively silly quoting conventions.  This will take a parser
	  re-org to handle.

2009-04-26  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_extent): Fix off-by-one when we
	overflow the area available.

2009-04-25  Morten Welinder <terra@gnome.org>

	* Release 1.9.6

2009-04-22  Morten Welinder  <terra@gnome.org>

	* ms-container.c (ms_container_read_markup): Fix badly
	misunderstood field.  Fixes #579835.

2009-04-16  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (get_style): create a GogStyle object, not a GOStyle.

2009-04-15  Morten Welinder  <terra@gnome.org>

	* ms-obj.c (ms_read_TXO): Fix text problem.  [#578878]

2009-04-10  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: fixed after GogStyle -> GOStyle rename.
	* ms-excel-read.c: ditto.
	* ms-excel-write.c: ditto.
	* xlsx-read.c: ditto.

2009-04-11  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : get rid of bogus .sml suffix now that we have
	  probing.
	* excel-xml-read.c : accept title and description in metadata
	(xl_xml_col_start) : only assign width > 0.
	(xl_xml_num_fmt) : fix previous patch.

2009-04-02  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_new): Limit maxcols to what we
	actually have.  Fixes #577758.

2009-04-01  Morten Welinder  <terra@gnome.org>

	* xlsx-write.c (xlsx_write_sheet): Fix access to ->sheet.
	(xlsx_write_objects): Plug leak.

2009-03-31  Morten Welinder  <terra@gnome.org>

	* xlsx-write.c: Partial fix for #168875.
	* ms-excel-read.c: Ditto.
	* ms-excel-write.c: Ditto.

	* ms-obj.c (read_pre_biff8_read_name_and_fmla): Add sanity checks.
	(ms_obj_read_pre_biff8_obj): Add and fix sanity checks.  Fixes
	#577504.

	* ms-excel-read.c (excel_read_MERGECELLS): Fix sanity check.
	Fixes #577503.

	* ms-chart.c (ms_excel_chart_read): Leak less on errors.
	(BC_R(scatter)): Add sanity check for V8 case.  Fixes #577400.

	* ms-excel-read.c (excel_read_CF): Add sanity checks.  Fixes
	#577399.

	* ms-biff.c (ms_biff_query_next): If the read fails, make sure
	->length is zero to match the NULL ->data.

2009-03-30  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (ms_excel_chart_read): Add sanity check.  Fixes
	#577351.

	* ms-excel-read.c (excel_read_IMDATA): Add sanity check.  Fixes
	#577348.

	* ms-container.c (ms_container_get_blip): Add sanity check.  Fixes
	#577260.

	* ms-excel-read.c (excel_read_MULBLANK): Add sanity checks.  Fixes
	#577259.

2009-03-29  Morten Welinder  <terra@gnome.org>

	* ms-obj.c (ms_read_TXO): Add sanity check.

	* ms-biff.c (ms_biff_query_peek_next): Read the length field too
	and make sure there's enough left to read the data.  Fixes
	#577205.

	* ms-chart.c (lineformat): Add sanity check.  Fixes #577208.

2008-12-10  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c (xl_xml_probe_start_element) : new.
	(excel_xml_file_probe) : use the new gsf_xml_probe.

	* plugin.xml.in : SpreadsheetML has a probe function now.

2009-03-22  Morten Welinder <terra@gnome.org>

	* Release 1.9.5

2009-03-20  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_LABEL_markup): Fix sanity check
	off-by-one.

	* ms-container.c (ms_container_read_markup): Fix termination
	condition.  #576112.
	(ms_container_read_markup): Fix sanity check off-by-one.

	* ms-excel-read.c (excel_read_init): Use magic formats for 0x0e,
	0x0f, and 0x16.  Keep the nameless magic for 0x10.

2009-03-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_LABEL_markup): Verify that offsets
	are sane.
	(excel_read_LABEL_markup): Ditto.  Fixes #575452.

2009-03-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_init): Reinstate, but without
	looking at go_format_builtins.

2009-03-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_init): Do not localize formats 14,
	15, 16, and 22.

	* ms-chart.c (ms_excel_chart_read_NUMBER,
	ms_excel_chart_read_LABEL): Add extra sanity check.  Fixes #575393.

2009-03-14  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_font_from_go_font): Don't crash if the
	font descriptor lacks a family.  Part of #575318.
	(cb_NOTE_v8): If there is no author, just use the empty string.

2009-03-10  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (ms_biff_bof_data_new): Handle BIFF_BOF_v8
	records indicating MS_BIFF_V2/MS_BIFF_V3/MS_BIFF_V4 files.  (And
	indicating broken tools too, of course.)

2009-02-22  Morten Welinder <terra@gnome.org>

	* Release 1.9.4

2009-02-20  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (chart_create_obj): Bullet proof.

2009-02-18  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (do_excel_write_prep_expr): Use
	excel_func_by_name hash table instead of linear search.

	* ms-excel-read.c (excel_read_init): Set up new hash table
	excel_func_by_name.

2009-02-17  Morten Welinder  <terra@gnome.org>

	* ms-formula-read.c (excel_func_desc): Rename entry 92 back to
	"SERIES" hoping that won't break anything.  Fixes #572127.

2009-01-31  Morten Welinder  <terra@gnome.org>

	* ms-formula-read.c (excel_parse_formula1): Use
	gnm_expr_new_range_ctor, not build_binop.

2009-01-23  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_write_block): Handle the case of a
	missing cell better.  Partially fixes #568929.

2009-01-16  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_AI): support GOData simple
	instances [#567953],
	(chart_write_axis_sets): do not write invalid AXESUSED field, see
	#567823.

2009-01-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_DELTA): Check tolerance.  Fixes
	#567823.
	(excel_read_CALCCOUNT): Check count.

2009-01-15  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axesused): Don't use g_return_val_if_fail for data
	dependent errors. 

2009-01-11  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (write_node): Don't introduce parentheses
	around explicit parentheses.  Fixes #567380.

2008-12-15  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (BC_R): Don't use g_return_val_if_fail for data
	dependent errors.  Fixes #564499.

2008-12-12  Morten Welinder  <terra@gnome.org>

	* ms-excel-util.c (two_way_table_move): Make sure we keep
	unique_keys correct.  See #564078.

2008-12-11  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (map_pattern_to_xl): Throw in some translations
	of Gnumeric-specific patterns.  Fixes #564078.

2008-12-08  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (3d): use an int for an integer property, not a double.

2008-11-11  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (3d), (chart_write_plot): some work on 3d import/export,
	(ms_excel_chart_write): fixed segfault when exporting an empty contour
	plot. [#557027]

2008-10-21  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (BC_R(end)): Don't look first series if there are no
	series.  Fixes #557077.

2008-10-18  Jody Goldberg <jody@gnome.org>

	* Release 1.9.3

2008-10-02  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_NAME): Don't write a formula for
	place-holders.

2008-10-01  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_foreach_name): Use new
	workbook_foreach_name.

2008-10-13  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_read_OBJ) : standalone OBJ records outside escher
	  groups appear to use the old style. [#546887]

2008-10-09  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_pattern_fg_bg) : merge _fg and _bg and
	  restore/comment on why there seems to be a need for magic in the
	  case of conditional formats.

2008-10-09  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (indexed_color) : return a GOColor.
	(themed_color) : new.  Has some magic to use the theme indicies as
	  lookups into a hard coded map.d 
	(xlsx_draw_color_themed) : simplified, the theme_colors_by_name is always defined.
	(hue_to_color) : new.
	(apply_tint) : new.  Could be moved into goffice.
	(elem_color) : handle tints, and themes.
	(xlsx_get_style_xf) : new.
	(xlsx_pattern_fg) : drop the magic pattern based inversion.
	(xlsx_pattern_bg) : ditto.
	(xlsx_border_end) : add protection.
	(xlsx_xf_begin) : merge parent styles when available.
	(xlsx_cell_style) : it is an index into the style_xfs, not the cell_xfs.
	(xlsx_file_open) : read themes before styles.

2008-09-11  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_TAB_COLOR) : no sense checking for NULL.
	  [Coverity #197]

2008-09-02  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_file_open) : store VBA if it is available
	    *
2008-08-29  Jody Goldberg <jody@gnome.org>

	* Release 1.9.2

2008-08-29  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_wb_get_fmt): Handle broken 1.6 formats.

2008-08-02  Jean Brefort  <jean.brefort@normalesup.org>

	* xlsx-read.c: Fixed axis position.

2008-08-01  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axis), (valuerange): set the "cross-axis-id" property.

2008-07-28  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ai): add a warning, (tick): import text orientation,
	(chart_write_AI): fix AI export (reverses 2008-02-29 change),
	(chart_write_axis): export text orientation [#544935].

2008-07-02  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_worksheet) : new.  Looks for related pivot
	  tables.  If the gsf extension necessary is available.
	(cb_find_pivots) : new.

2008-06-30  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_PivotCache) : new, read a cache.
	* xlsx-read-pivot.c : New.
	* Makefile.am : dist xlsx-read-pivot.c

2008-02-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (chart_write_AI): Do not export non-existing values
	(fixes some criticals, see #519788).

2008-06-29  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (xl_chart_import_error_bar): More checks on parent.
	Fixes #540697.

2008-06-25  Jody Goldberg <jody@gnome.org>

	* Release 1.9.1

2008-06-22  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_query_next) : don't return anything if the record
	  looks suspicious. [#539666]

2008-06-22  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (chart_realize_obj) : throw in a warning (not used yet).
	(chart_create_obj) : call out to the container.

2008-06-19  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (end): Fix corrupted-file crash.  [#539178]

2008-06-13  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_expr) : handle empty expressions without a
	  calc id.
	(ms_obj_read_biff8_obj) : drop the debug spew.

	* ms-excel-read.c (excel_read_EXTERNNAME) : rework the logic to
	  differentiate between name/DDE/OLE, and always load the name itself
	  even if we do not support DDE/OLE.
	(excel_read_EXTERNSHEET_v7) : hush.
	(excel_read_HEADER_FOOTER) : drop the size checks (they were wrong for
	  older sheets) they are unnecessary.  The biff_text handles it better.
	(excel_biff_text_1) : use the same structure as the logic in ...
	(excel_biff_text_2) : ... here.  And make it clear that we only need
	  two bytes.

	* ms-chart.c (BC_R(surf)) :  This is only 2 bytes, not 6.

2008-06-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (gnm_xl_importer_free) : don't free a name that
	  failed to import.
	(excel_parse_name) : Do not free the name string here.
	(excel_read_EXTERNNAME) : get the name string even for DDE and OLE.
	  Fix the test for DDE links.
	  Improve the warning for unsupported types, and win32 proof them.
	  free the name string here.
	(excel_read_NAME) : and free it here too.
	(excel_read_SUPBOOK) : relax the size check to <=.  If there are no
	  sheets in the external link (e.g. DDE links) then this is the whole
	  record.  Remove the warning about unknown encoding.  There is no
	  requirement that the first character be one of the magic encoding
	  flags.

2008-06-11  Morten Welinder  <terra@gnome.org>

	* ms-excel-util.c (two_way_table_put): If we free the key because
	it is a duplicate, continue with the valid version, not the freed.
	Fixes #537625.

2008-05-07  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (ExcelStyleVariant): New type.
	(xf_init): Create cell_style_variant hash.  Change domain type of
	xf.two_way_table to ExcelStyleVariant.  All users changed.
	(xf_free): Destroy cell_style_variant.
	(cb_cell_pre_pass): If a string cell needs quoting, mark it as
	variant 1.
	(excel_sheet_write_block): Use proper variant.
	(build_xf_data): Set ->format properly.
	(excel_write_XF): Propagate ->format into XF.  Fixes #530704.

2008-05-04  Jody Goldberg <jody@gnome.org>

	* Release 1.9.0

2008-05-04  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c : Add stub for 'functionGroup'

2008-05-02  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_XF): Dump more of the xf when debugging.

2008-05-02  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_biff_bof_data_new) : make the version info spew
	  optional.

2008-04-27  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_sheet_insert_val): Don't set formats for
	blanks and bools.  Fixes #530259.

2008-03-29  Morten Welinder  <terra@gnome.org>

	* ms-formula-read.c (excel_parse_formula1): Fix swapped length
	checks.  Fixes #524926.

2008-03-12  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_wb_get_fmt): Replace invalid formats by
	General.

2008-03-07  Jean Brefort  <jean.brefort@normalesup.org>

	* xlsx-read.c: (xlsx_chart_text): create GnmGOData instead
	of GOData, (xlsx_axis_cleanup): do not unref a non deletable axis.

2008-02-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ms_excel_chart_read): do not leak the default lot style,
	(store_dim): accept vectors with nul length,
	(chart_write_axis): fix export of invisible axis.

2008-02-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (BC_R(end)): Drop axes that the plot cannot handle.
	Fixes a number of criticals from #518939.

2008-02-27  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (set_radial_axes): If clearing the parent fails, the
	ref-count is not as expected to stop messing with the object.
	Fixes #518939.  Mostly.

2008-02-23  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_externsheet_v8): Take guint16 argument to
	prevent negative lookups.

2008-02-19  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_get_data): Add a few checks before Sum1
	finds this.

2008-02-17  Morten Welinder  <terra@gnome.org>

	* ms-obj.c (ms_read_OBJ): Return error indicator.
	* ms-escher.c (ms_escher_read_ClientData): Handle errors from
	ms_read_OBJ.  Fixes #517106.

2008-02-15  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (ms_excel_chart_read): Check record length here for
	all chart record types.  (Derived from Jean's patch to #515343.)
	Fixes #514513, #515343, #515873, #515876.
	(BC(register_handlers)): Fix the minimum length of siindex
	records.

2008-02-08  Morten Welinder  <terra@gnome.org>

	* ms-chart.c: Sprinkle some length checks.  Fixes #515269,
	#515275, and #515335.

	* ms-excel-read.c (excel_read_SUPBOOK): Add length checks.  Fixes
	#515155.

2008-02-07  Morten Welinder  <terra@gnome.org>

	* ms-biff.c (ms_biff_query_bound_check): Return (guint32)-1 on
	error so we can tell.

	* ms-excel-read.c (gnm_xl_importer_free): Be more careful when
	freeing sst.
	(sst_read_string): Be more careful.  This code is a mess.

	* ms-chart.c (xl_chart_import_error_bar): Avoid crash in missing
	parent-series case.  Fixes #514630.

	* ms-formula-read.c (excel_parse_formula1, excel_parse_formula):
	Grow a maxlen argument and make sure we do not read more.  Fixes
	#514637.

	* ms-excel-read.c (excel_read_string_header, excel_get_text): Grow
	an array_length argument and make sure we do not read more array
	data than call.  All callers changed.
	(excel_biff_text, excel_biff_text_1, excel_biff_text_2): New
	Biff-record based wrappers for excel_get_text.
	(excel_formula_shared): Make sure to copy the data behind the
	expression too.

2008-02-05  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_read_Blip): Don't construct bogus blip.
	Fixes #514510.

	* ms-excel-read.c (excel_read_FONT): Add length checks.  Fixes
	#514506.

2008-02-04  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_biff_text, excel_biff_text_1,
	excel_biff_text_2): New functions.  Use these where possible to
	add length checks.

	* ms-chart.c (ai): Handle missing series.  Fixes #514435.
	(fontx): Add length checks.  Fixes #514436.
	* ms-biff.c (ms_biff_query_set_decrypt): Handle empty record.
	Fixes #514437.

	* ms-excel-read.c (excel_read_FORMULA): When we see multiple
	expressions for a single cell, don't leak.  Fixes #514295.
	(excel_cell_fetch): New function.
	(excel_read_FORMULA, excel_read_LABEL, excel_sheet_insert_val):
	Use excel_cell_fetch so we range check cell position.

	* ms-chart.c (ms_excel_chart_read): Factor the rest of cases out
	into functions so XL_CHECK_CONDITION can be used.  Fixes #514229
	and several other similar issues.

	* ms-excel-read.c (excel_read_DEF_ROW_HEIGHT): Add length checks.
	Fixes #514230.

2008-02-03  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_sheet): Factor the rest of cases out
	into functions so XL_CHECK_CONDITION can be used.  Fixes #513963
	and several other similar issues.

2008-02-02  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_workbook) [BIFF_DSF]: Properly check
	record length.  Fixes #513835.
	(excel_read_HLINK): Be even stricter about record lengths.

2008-02-01  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_NAME): Properly check record length.
	Fixes #513608.
	(excel_read_FORMAT): Ditto.  Fixes #513608.
	(excel_read_ROW): Ditto.  Fixes #513787.

	* ms-chart.c (BC_R): Ditto.  Fixes #513790.

2008-01-31  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_BOOLERR): Properly check record
	length.
	(excel_read_HEADER_FOOTER): Ditto.
	(excel_read_REFMODE): Ditto.  Fixes #513364.
	(excel_read_PAGE_BREAK): Ditto.  Fixes #513361.
	(excel_set_xf): Ditto.  Fixes #513551.

2008-01-30  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_EXTERNNAME): Fix the error case.
	Fixes #513005.
	(excel_read_LABEL): Properly check record length.  Fixes #513313.
	(excel_read_SELECTION): Properly check record length.  Fixes #513317.

2008-01-29  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_string): Fix length written for
	the unicode case (with length measured in characters).

2008-01-29  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_EXTERNSHEET_v8): Check q->length
	properly.  Fixes #512984.

2008-01-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_HLINK): Improve error checks.
	Fixes 505330.

2008-01-12  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ms_excel_chart_write): save graph title if any and
	if the first chart has no title. [#301720]

2007-12-21  Jody Goldberg <jody@gnome.org>

	* Release 1.8.0

2007-12-12  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (lineformat), (ms_excel_chart_read),
	(chart_write_LINEFORMAT), (chart_write_axis),
	(ms_excel_chart_write): fix import / export of lines format. [#502968]
	* ms-excel-read.c: (xl_pattern_to_line_type),
	(ms_sheet_realize_obj): ditto.
	* ms-excel-read.h: ditto.

2007-12-07  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (ms_excel_chart_read): Copy list of contributors
	because it will change underneath us.  [#501656]

2007-12-03  Jody Goldberg <jody@gnome.org>

	* Release 1.7.91

2007-11-28  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat): always set the style, even for
	invisible axes,
	(objectlink): started work on series labels import,
	(set_radial_axes),(radar), (radararea), load radar plot axes. [#499349]
	(end): a better auto marker test for #344950,
	(ms_excel_chart_read), reparent invisible axis children before
	deleting the axis.
	(chart_write_axis_sets): write radar plots axes. 
	* ms-excel-read.c: (excel_read_BOF): reverse objects stack order.

2007-11-23  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_PageMargins) : enable top/bottom.
	  Convert header/footer from inches to pts.

2007-11-19  Jody Goldberg <jody@gnome.org>

	* Release 1.7.90

2007-11-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_HLINKs) : implement.
	* ms-excel-read.c (excel_read_HLINK) : enable file and unc links.
	* plugin.xml.in : prefer biff8 to biff7 when matching by suffix.

2007-11-17  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (write_funcall): Fix error message.

2007-11-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_free): Plug leaks.  [#497191]

2007-11-12  Morten Welinder  <terra@gnome.org>

	* xlsx-read.c (xlsx_CT_Selection): Plug leak.

2007-11-15  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (areaformat): set fill.auto_fill to FALSE for
	transparent backgounds,
	(XL_gog_series_set_dim), (ms_excel_chart_read): fix compiler warnings.

2007-11-12  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat), (ms_excel_chart_read),
	(chart_write_axis): use the "invisible" property for axis when
	appropriate.

2007-11-06  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (xl_axis_get_elem): don't set cross auto each
	time there is an auto parameter, just for cross.

2007-11-04  Morten Welinder <terra@gnome.org>

	* Release 1.7.14

2007-11-01  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_ClientTextbox): Survive NULL
	label.  Patches over #492377.
	(excel_write_string): Handle NULL txt here, just in case.

2007-10-29  Morten Welinder  <terra@gnome.org>

	* ms-chart.c: use g_printerr where appropriate.
	(objectlink): Plug another leak.

2007-10-29  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (ms_excel_chart_read): Avoid freeing a value when
	trying to copy it.
	(seriestext): Fix leak.

2007-10-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat): set s->xaxis to NULL after deletion,
	 (ms_excel_chart_read): initialize state.interpolation. [#491131]

2007-10-27  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (cb_write_macro_NAME): Don't delete
	efunc->macro_name here.  That won't work when we write the
	dual-format.
	(free_excel_func): New function.
	(excel_write_state_new): Install free_excel_func as value
	destructor for the hash.  Fixes #490828.

2007-10-27  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: enhance axes labels import, export them, and fix
	export of line patterns.

2007-10-24  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (excel_formula_write_NAME_v7): Use a
	sequential id instead of casting the expression address to a
	number.

2007-10-21  Morten Welinder <terra@gnome.org>

	* Release 1.7.13

2007-09-28  Emmanuel Pacaud <emmanuel.pacaud@lapp.in2p3.fr>

	* ms-chart.c (ms_excel_chart_write): remove unused zoom argument in
	gog_renderer_update call.

2007-09-28  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: do not use WITH_GOFFICE_0_4 anymore.

2007-09-27  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c : Fix import of existing conditional format types.
	  We can not handle the computed range formats yet.

2007-09-24  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(end)) : Don't leak a style when faced with an empty
	  label.

2007-09-21  Morten Welinder  <terra@gnome.org>

	* md5.c: Switch to GPL2 version, see  bug #478398.  (Patch by
	  Hans de Goede)

2007-09-16  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_plot_area_start) : new.
	(xlsx_plot_area_end) : new.
	(xlsx_chart_logbase) : new.
	(xlsx_draw_line_dash) : new.
	(xlsx_chart_marker_symbol) : new.
	(xlsx_chart_marker_end) : assign the marker symbol here, so that we
	  can get handle auto
	(xlsx_chart_gridlines) : new.
	(xlsx_chart_pop) : new.

2007-09-16  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_plot_area_start) : new.
	(xlsx_plot_area_end) : new.
	(xlsx_chart_logbase) : new.
	(xlsx_draw_line_dash) : new.
	(xlsx_chart_marker_symbol) : new.
	(xlsx_chart_marker_end) : assign the marker symbol here, so that we
	  can get handle auto
	(xlsx_chart_gridlines) : new.
	(xlsx_chart_pop) : new.

2007-09-16  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_plot_area_start) : new.
	(xlsx_plot_area_end) : new.
	(xlsx_chart_logbase) : new.
	(xlsx_draw_line_dash) : new.
	(xlsx_chart_marker_symbol) : new.
	(xlsx_chart_marker_end) : assign the marker symbol here, so that we
	  can get handle auto
	(xlsx_chart_gridlines) : new.
	(xlsx_chart_pop) : new.

2007-09-16  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (attr_rgb) : new.
	(xlsx_chart_push_obj) : new.
	(xlsx_chart_pop_obj) : new.
	(simple_bool) : new.
	(xlsx_vary_colors) : use it.
	(simple_int) : new.
	(xlsx_chart_pie_sep) : use it.
	(xlsx_chart_bar_overlap) : ditto.
	(xlsx_chart_bar_gap) : ditto.
	(simple_float) : new.
	(simple_enum) : new.
	(xlsx_chart_bar_dir) : use it.
	(xlsx_chart_add_plot) : new.
	(xlsx_chart_pie) : use it.
	(xlsx_chart_ring) : use it.
	(xlsx_chart_bar) : use it.
	(xlsx_chart_area) : use it.
	(xlsx_chart_line) : use it.
	(xlsx_chart_xy) : use it.
	(xlsx_chart_bubble) : use it.
	(xlsx_chart_radar) : use it.

	(xlsx_axis_info_free) : new.
	(xlsx_plot_axis_id) : new.
	(xlsx_axis_id) : new.
	(xlsx_axis_start) : new.
	(xlsx_axis_delete) : new.
	(xlsx_axis_orientation) : new.
	(xlsx_axis_pos) : new.
	(xlsx_axis_bound) : new.
	(xlsx_axis_crosses) : new.
	(xlsx_axis_end) : new.
	(xlsx_chart_ser_f) : handle series names.

	(xlsx_chart_pt_start) : new.
	(xlsx_chart_pt_end) : new.
	(xlsx_chart_pt_index) : new.
	(xlsx_chart_pt_sep) : new.
	(xlsx_chart_style_start) : new.
	(xlsx_chart_style_end) : new.
	(xlsx_style_line_start) : new.
	(xlsx_style_line_end) : new.
	(xlsx_chart_no_fill) : new.
	(xlsx_chart_solid_fill) : new.
	(xlsx_draw_color_themed) : new.
	(xlsx_draw_color_rgb) : new.
	(xlsx_draw_color_alpha) : new.
	(xlsx_draw_color_end) : new.
	(xlsx_chart_marker_start) : new.
	(xlsx_chart_marker_end) : new.
	(xlsx_chart_text) : new.
	(xlsx_chart_text_content) : new.

	(cb_axis_set_position) : new.
	(xlsx_axis_cleanup) : new.
	(xlsx_read_chart) : set up the extensions to handle styles, and
	  connect up the axis after parsing.

	* ms-chart.c (excel_font_from_go_font) : take a XLExportBase.
	(chart_write_text) : fix call to excel_font_from_go_font.
	(chart_write_axis) : ditto.

	* xlsx-write.c (xlsx_write_series_dim) : silence a warning.

2007-09-15  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_axis_sets): use "Backplane" instead of
	"Grid" when goffice is 0.5,

2007-09-15  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (end): use "Backplane" instead of "Grid" when goffice is 0.5,
	(chart_write_text), (ms_excel_chart_write): made some work on titles
	position export. 

2007-09-13  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (end), (chart_write_text), (chart_write_axis),
	(ms_excel_chart_write): export text with style and import chart
	titles [#301720].
	* ms-excel-write.c: (excel_font_from_go_font),
	(extract_gog_object_style): export fonts used in charts.
	* ms-excel-write.h: ditto.

2007-09-08  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_vary_colors) : new.

	* ms-chart.c (chart_write_LEGEND) : new code split from.
	(chart_write_axis_sets) : here.
	* ms-chart.c (BC_R(boppop)) : place holder to at least get the pie.

2007-09-04  Jody Goldberg <jody@gnome.org>

	* Release 1.7.12

2007-09-01  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c (xlsx_write_init_row) : new.
	(xlsx_write_cells) : add a simple compression mechanism to avoid
	  producing an empty row element if there is no useful content.
	(xlsx_write_hlink) : fix the namespace of the "id" attr.
	(xlsx_write_hlinks) : yay consistency!  No count for this collection.
	(xlsx_write_chart_bool) : always generate a val, ignore the supposed
	  default value. (fixes pie varyColor)
	(xlsx_write_chart) : vary pie color is not the default.  We need to
	  generate it.
	(xlsx_write_objects) : nvGraphicFramePr and xfrm are required.
	(xlsx_write_sheet) : re-order placement of protection element.

2007-08-25  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (gelframe): should now compile with goffice-0.4

2007-08-25  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (gelframe): return if type is less that 5, otherwise
	  set fill type and colors not auto.

2007-08-25  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_chart_legend) : new.

2007-08-24  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_DataValidation_begin) : don't lose the input
	  messages.

2007-08-24  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c (xlsx_write_validation) : LTE and GT were swapped.
	* xlsx-read.c (xlsx_CT_DataValidation_begin) : ditto.

2007-08-24  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_chart_pie) : new.
	(xlsx_chart_ring) : new.
	(xlsx_chart_bar) : new.
	(xlsx_chart_area) : new.
	(xlsx_chart_line) : new.
	(xlsx_chart_xy) : new.
	(xlsx_chart_bubble) : new.
	(xlsx_chart_radar) : new.
	(xlsx_plot_end) : new.
	(xlsx_chart_ser) : new.
	(xlsx_chart_ser_f) : new.
	(xlsx_ser_type_start) : new.
	(xlsx_ser_type_end) : new.
	(xlsx_drawing_twoCellAnchor) : new.
	(xlsx_drawing_twoCellAnchor_end) : new.
	(xlsx_drawing_pos) : new.
	(xlsx_read_chart) : create the chart.

2007-08-23  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c (xlsx_write_merges) : split into a function for
	  cleanliness.
	(xlsx_write_validation) : new partial implementation.
	(xlsx_write_validations) : new.  Uses excel_collect_validations.
	(xlsx_write_sheet) : call the new routines.

	* xlsx-read.c (xlsx_parse_sqref) : normalize the ranges to be extra
	  careful, and document that they are in reverse order.
	(xlsx_CT_DataValidation_begin) : finish, and cache the top left corner
	  of the 1st sqRef.
	(xlsx_validation_expr) : parse relative to the first corner, not A1.

	* ms-excel-write.c (excel_write_DV) : split extraction code out into.
	(excel_collect_validations) : here.

2007-08-03  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_HLINK) : fix import of local links.

2007-08-05  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_series), (chart_write_plot): free
	strings returned by g_object_get.

2007-08-04  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: fixed interpolation mode import/export after
	  the change in goffice.

2007-07-27  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (end) : don't leak a style of the legend doesn't have a
	  frame.

2007-07-26  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_expr) : new.
	(read_pre_biff8_read_expr) : use it here.
	(ms_obj_read_pre_biff8_obj) : here.
	(ms_obj_map_forms_obj) : and here.  Also check for source ranges for
	  combos and lists. [#451384]

2007-07-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_SHEETPROTECTION) : size check was too
	  detailed.

2007-07-24  Jody Goldberg <jody@gnome.org>

	* Release 1.7.11

2007-07-13  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_biff8_obj) : send the actual record, not
	  the 4 byte header that loses 4 trailing bytes.
	(ms_obj_map_forms_obj) : Use existing tools to properly handle
	 longer names and objects with data sources (combos/lists).

	* xlsx-write.c (xlsx_write_calcPR) : new.

2007-07-09  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_CalcPr) : new. Read the iterate and recalc
	  properties.  Need to add the refmode.
	* xlsx-write.c (xlsx_write_calcPR) : ditto.
	(xlsx_write_workbook) : called from here.

2007-07-14  Jody Goldberg <jody@gnome.org>

	Report form coverity.
	* ms-obj.c (ms_read_TXO) : remove failure modes for items we do not
	  actually use.  alignments are enumerated from 1, not 0.

2007-06-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.h : delete MsBiffFontUnderline, there was no need for
	  an intermediate type.

	* ms-excel-write.c (excel_write_PAGE_BREAK) : just hard code the
	  min/max.  The values seem constant in all my tests.

	* ms-excel-biff.h : Start some cleanup, and begin to follow the naming
	  convention 'XLS_...' for binary and 'XLSX_...' for oox.
	  Define some Maximas.

2007-06-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_PAGE_BREAK) : new.
	(excel_read_sheet) : called from here.

	* ms-excel-write.c (excel_write_PAGE_BREAK) : new.
	(write_sheet_head) : called from here.

	* xlsx-read.c (xlsx_CT_PageBreak) : new.
	(xlsx_CT_PageBreaks_begin) : new.
	(xlsx_CT_PageBreaks_end) : new.

	* xlsx-write.c (xlsx_write_breaks) : new.
	(xlsx_write_print_info) : called from here.

2007-06-06  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : add Calibri.

2007-06-12  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in  : Use 'Office 2007' as the description for the writer
	  too.

2007-06-10  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c : Move the OpenPkg support out of here and into libgsf.
	* xlsx-read.c : ditto.
	(xlsx_parse_rel_by_id) : new wrapper to handle errors from
	  gsf_open_pkg_parse_rel_by_id.

2007-06-10  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_CT_SheetProtection) : new.
	* xlsx-write.c (xlsx_write_protection) : new.
	(xlsx_write_sheet) : called from here.

	* ms-excel-read.c (excel_read_SHEETPROTECTION) : new.
	(excel_read_sheet) : called here.

	* ms-excel-write.c (excel_write_SHEETPROTECTION) : new.
	(excel_write_sheet) : called here after the validations.

2007-06-01  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: do not delete a valid axis.

2007-05-25  Morten Welinder  <terra@gnome.org>

	* plugin.xml.in: Add mime types for most of the savers.

2007-05-16  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (fontx), (tick), (end): import legend and
	axis labels font. [#437858]

2007-05-07  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (excel_write_SETUP): adjust for new
	  arguments of print_info_get_margins
	(excel_write_WSBOOL): ditto
	* ms-excel-read.c (excel_init_margins): use print_info_set_edge_to_*
	(excel_read_sheet): use print_info_set_edge_to_*
	* xlsx-write.c (xlsx_write_print_info): adjust for new
	  arguments of print_info_get_margin

2007-05-07  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axis), (catserrange), (lineformat), (valuerange),
	(end), (ms_excel_chart_read), (chart_write_axis),
	(chart_write_axis_sets), (ms_excel_chart_write): fix import/export
	of axis sets. [#318610]

2007-05-03  Morten Welinder <terra@gnome.org>

	* Release 1.7.10

2007-05-02  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (write_sheet_head): change PrintUnit content
	* ms-excel-read.c (excel_print_unit_init_inch): deleted
	(excel_init_margins): use GO_IN_TO_PT
	(excel_read_sheet): ditto
	* xlsx-write.c (xlsx_write_print_info): change PrintUnit content

2007-04-29  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : remove duplicate xlsx entry

2007-04-24  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (excel_write_SETUP): use
	  print_info_get_paper_orientation
	(write_sheet_head): print_info might be modified
	* ms-excel-read.c (excel_read_SETUP): use 
	  print_info_set_paper_orientation

2007-04-21  Morten Welinder <terra@gnome.org>

	* Release 1.7.9

2007-04-03  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (write_sheet_head): use print_info_get_margins
	* ms-excel-read.c (paper_size_table): use PWG 5101.1-2002
	(excel_read_SETUP): use modified paper_size_table
	* xlsx-write.c (xlsx_write_print_info): use print_info_get_margins

2007-03-19  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c (xlsx_write_cells) : keep f before v, but do not try to
	  export an attribute of c once we have started the f or v.
	(xlsx_write_cells) : export array formulas.
	(xlsx_write_cells) : export bool values a "1" "0" rather than
	  value_get_as_string.

2007-03-18  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_file_open) : Visible error if no workbook is
	  found.

	* xlsx-write.c (xlsx_write_sheet) : Define some new constants for the
	  spreadsheet, and relationship namespaces.  Then update them to the
	  versions used in the official 2007 release.
	(xlsx_write_shared_strings) : ditto.
	(xlsx_write_styles) : ditto.
	(xlsx_write_workbook) : ditto.
	(xlsx_write_col) : up the accuracy of width export to match XL 2007.
	  put hidden before other flags to ease visual inspection of xml.
	(xlsx_write_cols) : skip initial empty cols, and include the last col. 

2007-03-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_FONT): In case we get a NULL
	fontname, assume "Arial".  Fixes #418868.

2007-03-05  Jody Goldberg <jody@gnome.org>

	* xlsx-utils.c (xlsx_cellref_as_string) : no need to use the
	  convention for the sheet_sep, hard code it.
	(xlsx_rangeref_as_string) : ditto.
	(xlsx_expr_conv_new) : adapt to changes.

2007-01-11  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (ms_escher_read_OPT_bools) : improve debug stream.
	(ms_escher_read_OPT) : add a few more properties based on the results
	  of the test file that fills in as many properties as I could find
	  samples/excel/objs.xls.
	(ms_escher_sp_new) : new. unused as yet.
	(ms_escher_sp_free) : ditto.
	(ms_escher_sp_len) : ditto.
	(ms_escher_sp_add_OPT) : ditto.
	(ms_escher_sp_set_anchor) : ditto.
	(ms_escher_sp_write) : ditto.

	* ms-obj.c (ms_obj_read_biff8_obj) : do not generate a warning for
	  combos with no link, or the special autofilter combos.
	(ms_obj_read_biff8_obj) : include the id in the debug spew.
	(ms_obj_read_biff8_obj) : Do not warn about unknown flags that we know
	  are unknown :-)
	(ms_objv8_write_note) : new basic stub.

	* ms-excel-write.c (excel_write_textbox_v8) : cheap hack to handle
	  comments somewhat at an invented anchor.
	(cb_NOTE_v8) : new.
	(excel_write_objs_v8) : keep track of the number of comments too.
	(excel_sheet_new) : count comments too.  General tidyup in prep for
	  moving to generated escher.

2007-03-04  Morten Welinder <terra@gnome.org>

	* Release 1.7.8

2007-02-16  Morten Welinder <terra@gnome.org>

	* Release 1.7.7

2007-01-06  Morten Welinder  <terra@gnome.org>

	* xlsx-read.c (xlsx_cell_val_end): Use gnm_strto, not strtod.

2006-12-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_autofilter_objs) : minor
	  simplification.

2006-12-19  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_get_num_fmt) : handle the standard builtins
	  and paste over the unicode variants of the documented locale
	  specific variants.

2006-12-18  Jody Goldberg <jody@gnome.org>

	* ms-container.c (ms_container_parse_expr) : handle 0 length
	  expressions as NULL.  Looks like combos & lists with no links are
	  exported with length 0.

2006-12-17  Jody Goldberg <jody@gnome.org>

	* Release 1.7.6

2006-12-17  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (lineformat): use auto color for series only when
	the color index is equal to the series index. [#166820]

2006-12-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_COLINFO) : silence warning due to
	  kludge.

2006-12-16  Jody Goldberg <jody@gnome.org>

	Start work on autofilters, only Top10 is implemented for in or out.
	* xlsx-read.c (xlsx_CT_Filters_begin) : new.
	  Massive renaming to use '_begin' rather than '_start' just because I
	  like the sound better.
	* xlsx-write.c (xlsx_write_autofilters) : new.

2006-12-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_realize_obj) : link in the content
	  expression, and the linked cell for combo and list objects.
	* ms-obj.c (ms_obj_read_biff8_obj) : read ListboxData which seems to
	  contain the content expression.

2006-12-11  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (log_put_color): Remove "inline" -- it's
	pointless and triggers a gcc bug.  (gcc bug #30153)

2006-12-04  Jody Goldberg <jody@gnome.org>

	* Release 1.7.5

2006-11-24  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_attr_get_ptr) : change signature to better
	  distiguish between NULL and not-specified.
	* ms-excel-read.c (ms_sheet_realize_obj) : Using NULL as the default
	  was a bad idea.  We could not differentiate between empty text which
	  got stored as NULL, and not specified which should use the default.
	  Use the new signature to ms_obj_attr_get_ptr to handle this
	  correctly. (test case : checkboxes in 375620 with no labels)

2006-11-24  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c (xlsx_write_col) : set 'bestFit' if the column has a
	  size different from the default and it has _not_ been set by the
	  user.
	* ms-excel-write.c (excel_write_COLINFO) : ditto.  Set the
	  undocumented flags customWidth and bestFit based on the OfficeOpen
	  docs.
	* ms-excel-read.c (excel_read_COLINFO) : the undocumented bestfit and
	  customwidth flags are not a perfect match with our hard_size.  Use
	  customwith && !bestfit == hard_size.  That should match even the
	  mis-exported xls from older gnumeric's and OOo.
	* xlsx-read.c (xlsx_CT_Col) : ditto, but there are no worries about
	  older gnumeric's or OOo mis-generating.

2006-11-20  Jody Goldberg <jody@gnome.org>

	* Release 1.7.4

2006-11-19  Morten Welinder <terra@gnome.org>

	* Release 1.7.3

2006-11-09  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_file_open) : use the new
	  gnm_push_C_locale/gnm_pop_C_locale utils.
	* xlsx-write.c (xlsx_file_save) : ditto.

2006-10-27  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_MERGECELLS): Accept overlapping
	merges, as Excel does.

2006-10-24  Jon K Hellan  <hellan@acm.org>

	* ms-obj.c (ms_read_TXO): Handle UTF-16, and switching between
	single byte and UTF-16 between CONTINUE records [#340293].

2006-10-17  Jody Goldberg <jody@gnome.org>

	* Release 1.7.2

2006-10-12  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (serfmt): add missing braces.

2005-07-06  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_sheet_realize_obj): Realize Excel 95 images 
	[#155696].

	* ms-obj.h: Add MS_OBJ_ATTR_IS_GOBJECT_MASK and
	MS_OBJ_ATTR_IMDATA. Widen MS_OBJ_ATTR_MASK.

	* ms-obj.[ch] (ms_obj_attr_new_gobject,
	ms_obj_attr_get_gobject): New. Add support for GObject attributes.
	(ms_obj_attr_destroy): Handle GObject attributes.
	(ms_obj_read_pre_biff8_obj): Save Excel 95 image as attribute.

2006-10-09  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_HLINK): Fix bug with URLs having
	target frames.

2006-10-02  Jody Goldberg <jody@gnome.org>

	* Release 1.7.1

2006-09-30  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (end): Don't use auto_shape or auto_dash when plot has
	no marker/line and series have while importing from excel. [#319727]


2006-09-29  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (serfmt), (chart_write_SERFMT),
	(style_is_completely_auto), (chart_write_style): implemented serfmt
	to import/export interpolation type for splines. [#349457].

2006-09-24  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c : Some initial work at parsing charts.
	  Only an outline of a parser for now, no actual work.

2006-09-23  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_SETUP) : Do not warn of print scale of
	  0, according to the OfficeOpen docs that means 'auto' we treat it as
	  100.

	* ms-excel-write.c (cb_check_names) : We no longer write placeholders,
	  no need to check for them.
	(excel_foreach_name) : Ditto.
	(excel_write_NAME) : Do not export place holders.
	(excel_write_autofilter_names) : Add a hook to warn of multiple
	  autofilters in one sheet.	[#346217]

2006-06-30  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-formula-read.c (parse_list_pop): use %p for pointers #346045
	* ms-formula-write.c (sheet_pair_hash): extinguish warning #346045

2006-06-22  Andreas J. Guelzow <aguelzow@pyrshep.ca>

	* ms-excel-write.c (excel_sheet_extent): use ngettext #123860

2006-06-03  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c (xlsx_ns) : add the namespace for beta2.
	(xlsx_shared_strings_dtd) : s/sstItem/si/ for beta2.
	* xlsx-write.c (gsf_outfile_open_pkg_close) : move to the new
	  spreadsheetml namespace.
	(xlsx_write_styles) : ditto.
	(xlsx_write_shared_strings) : ditto.
	(xlsx_write_sheet) : ditto.

2006-05-31  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (gather_styles) : Use sheet_cell_foreach, rather
	  than accessing Sheet::cell_hash directly.  This will make it easier
	  to jump to the quad tree later.
	(excel_write_workbook) : use the new sheet_cells_count rather than
	  accessing Sheet::cell_hash.

2006-05-22  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula1) : disable the long lived
	  warning about extended attr 0 with 3 and 0xA.  It has something to
	  do with singleton arrays, but does not seem important.

2006-05-25  Jean Brefort  <jean.brefort@normalesup.org>

	* boot.c: replaced gi18n.h by gi18n-lib.h.
	* excel-xml-read.c: ditto.
	* ms-excel-read.c: ditto.
	* ms-excel-write.c: ditto. 
	* ms-formula-read.c: ditto.
	* ms-formula-write.c: ditto.
	* xlsx-read.c: ditto.
	* xlsx-write.c: ditto.

2006-05-19  Morten Welinder  <terra@gnome.org>

	* ms-formula-read.c (excel_parse_formula): Avoid critical on array
	formulas.
	* ms-excel-read.c: Add more checks for corrupted files.

2006-05-18  Morten Welinder  <terra@gnome.org>

	* ms-formula-read.c (excel_parse_formula): Reinstate the call for
	expression sharing.

	* ms-excel-read.c: Don't use g_return_if_fail and
	g_return_val_if_fail for condition relating to file contents.  (They
	produce CRITICALS and Jon Kaare will complain one day.)

2006-05-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_MULRK): Add some bullet-proofing.
	[#341917]

2006-05-08  Jody Goldberg <jody@gnome.org>

	* Release 1.7.0

2006-04-29  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WINDOW2) : merge excel_write_PANE into
	  here and fix export of H or V only freezes.

2006-04-23  Jody Goldberg <jody@gnome.org>

	* xlsx-write.c : new.  Basic export and some code that will move to
	  libgsf for 'Open Package' support.
	* plugin.xml.in : Add xlsx export.
	* Makefile.am : ditto.

2006-04-23  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_EXTERNSHEET_v7) : patch
	  tweak to import broken quoted sheetname from gnumeric-1.0.x eg
	  Libro1.xls.

2006-04-23  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_chart_read) : Don't set the graph and chart
	  styles to blank unless this is a full sheet object.  Fixes the
	  import of older charts that are not wrapped in BOF records eg
	  ms699.xls.

2006-04-18  Morten Welinder  <terra@gnome.org>

	* boot.c (excel_file_open): Don't leak the meta_data object.

2006-04-16  Jody Goldberg <jody@gnome.org>

	* xlsx-read.c : new.  Basic import and some code that will move to
	  libgsf for 'Open Package' support.
	* plugin.xml.in : Add xlsx import.
	* Makefile.am : ditto.

2006-04-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (halign_to_excel) : add HALIGN_DISTRIBUTED.
	* ms-excel-read.c (excel_read_TAB_COLOR) : office 12 seems to add some
	  bytes.

2006-04-09  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (xl_chart_import_trend_line), (ms_excel_chart_read),
	(chart_write_trend_line), (chart_write_series): fix import/export
	of trend lines (only those supported by xl).

2006-04-08  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (xl_chart_import_reg_curve): import power regression
	and moving average lines.

2006-04-07  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=336858
	* ms-excel-read.c (excel_read_EXTERNNAME) : be more careful about
	  bounds checking.  Looks like 'miniCalc' generates EXTERNNAME with no
	  expressions at all for it's external functions.

2006-03-30  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (write_node): Add missing table entry for
	array elements.  Write the right PTG for data tables.
	(excel_write_array_formula): New function.
	(excel_write_formula): Change to take a texpr.  All callers
	changed.

	* ms-formula-write.h (ExcelFuncContext): Elminate
	EXCEL_CALLED_FROM_ARRAY which is now implicit.

2006-03-22  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(lineformat)) : store the format in outline as well
	  as line.  We do not know where it's going to be used.

2006-03-19  Morten Welinder  <terra@gnome.org>

	* ms-formula-write.c (write_node): Handle integers in VALUE_FLOAT
	records better.

2005-12-28  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_file_open) : use the new workbook_set_meta_data rather
	  than kludging GObject data.

2006-03-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_get_style_from_xf): Even though the third
	argument of style_border_fetch isn't used yet, get it right.

2006-03-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_EXTERNNAME): Use NULL, not 0.
	* ms-biff.c (ms_biff_query_next): Ditto.
	(ms_biff_query_destroy): Ditto.
	(ms_biff_put_new): Ditto.
	(ms_biff_put_len_next): Ditto.
	(ms_biff_put_len_commit): Ditto.

2006-03-13  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (write_sheet_head): Write protection flags.
	* ms-excel-read.c (excel_read_sheet_PROTECT): Store falg.
	(excel_read_workbook_PROTECT): New function.
	(excel_read_workbook): Read protection flags.
	Patch from Klokan Petr Pridal.  [#330129]

2006-03-13  Morten Welinder  <terra@gnome.org>

	* ms-container.h (MSContainerClass): Make the parse_expr method
	return a texpr.  All users changed.

	* ms-formula-read.c (excel_parse_formula): Make this return a
	texpr.  All users fixed.
	* ms-container.c (ms_container_parse_expr): Ditto.
	* ms-obj.c (ms_obj_attr_new_expr): Ditto.

2006-03-10  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : back port handling of
	  AttrChoose and AttrGoto

2006-03-10  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : don't forget to re-push
	  the new set with the extra element.

2006-02-27  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (blipinf_new): Fix potential 64-bit issue.

2006-02-21  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (ms_excel_chart_write): Plug minor leak.

2006-01-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_FORMULA) : adjust to new
	  GNM_EXPR_OP_ARRAY handling
	* ms-formula-write.c (excel_write_prep_expr) : ditto.
	(write_node) : ditto.

2006-01-17  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (chart_write_AI): Allocate right amount of memory.

2005-12-22  Stepan Kasal  <kasal@ucw.cz>

	* ms-excel-write.c (excel_write_externsheets_v8): Use the actual
	  number of sheets in the magic self referential SUPBOOK record.
	* ms-excel-read.c (supbook_get_sheet): Use EXCEL_SUP_BOOK_SELFREF
	  to recognize the self referential SUPBOOK record.
	(excel_read_EXTERNSHEET_v8): Simplify the read of sup_index.
	* ms-excel-read.h (ExcelExternSheetV8): Remove the unused member wb.

2005-12-05  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat): do not set style before setting parent,
	(object_swap_children): new helper function,
	(end): also swap axis children for bar charts and do not access
	directly GOMarker fields (now a private structure),
	(xl_chart_import_error_bar): fixed some import issues,
	(chart_write_error_bar): implement error bars export,
	(chart_write_reg_curve): fix an indexation bug,
	(chart_write_series): export error bars,
	(ms_excel_chart_write): use go_marker_set_shape.

2005-11-27  Jean Brefort  <jean.brefort@normalesup.org>

	* biff-types.h: add new custom biff code for goffice regression curves.
	* ms-chart.c: (ai), (serauxtrend), (trendlimits),
	(register_handlers), (xl_chart_import_reg_curve),
	(style_is_completely_auto), (chart_write_style),
	(chart_write_error_bar), (chart_write_reg_curve),
	(chart_write_series), (ms_excel_chart_write): export regression
	curves and enhance import.

2005-11-18  Jean Brefort  <jean.brefort@normalesup.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=321678
	* ms-chart.c: (ms_excel_chart_read): do not import series without
	chart group as error bars or regrssion curves for MS_BIFF_V4 or earlier.

2005-11-16  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=321678
	* ms-chart.c (xl_chart_import_reg_curve) : if the parent has no series
	  there is not much we can do.

	http://bugzilla.gnome.org/show_bug.cgi?id=321677
	* ms-chart.c (BC_R(gelframe)) : don't crash when faced with an
	  unsupported plot type that has a gradient.

2005-11-14  Jody Goldberg <jody@gnome.org>

	* Release 1.6.1

2005-11-08  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (blipinf_new): Don't crash if blip->type ends
	up NULL.  Fixes crash from #321009.

2005-11-05  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c : Support DateTime values

2005-10-23  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c (xl_xml_col_start) :
	  - add hidden.
	  - support spans
	  - support styles
	  - support sizes (still off by what seems like a constant factor ??
	    of 12.5% ??)
	(xl_xml_row_start) : ditto.
	(xl_xml_pane) : init edit pos to A1.
	(xl_xml_selection) : new. handle selection
	(xl_xml_editpos_col) : new. handle edit position
	(xl_xml_editpos_row) : new. ditto.
	(xl_xml_data_start) : load Data::Type here
	(xl_xml_cell_start) : not here.  Store the expr.
	(xl_xml_data_end) : store exprs and values.
	(xl_xml_named_range) : new.  No entirely functional.
	  It does not handle implicit fwd declatation of names.

2005-10-12  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : Ignore the data for Attr
	  CHOOSE that specifies which element to select.  We do not need it.
	* ms-excel-read.c (excel_read_FORMULA) : Use val_offset consistently

2005-10-10  Jody Goldberg <jody@gnome.org>

	* Release 1.6.0

2005-10-03  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c : Implement based on inspection of exported result
	  of a test xls (Did not read or download the schemas).  No support
	  for expressions or names yet.

2005-10-02  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : enable SpreadsheetML importer

	* excel-xml-read.c : implement

	* ms-formula-write.c (write_funcall) : handle macros.
	  exporting Analysis.xls

	* ms-formula-read.c (excel_parse_formula) : REF_3D, and AREA_3D for
	  biff7 seem to use the shared flag to define whether to sign extend.

	* ms-excel-read.c (excel_parse_name) : name expressions are parsed as
	  shared.  Not sure about this.  This seems to work for the oo name
	  and relref tests.  Do more validation.
	(ms_wb_get_font_markup) : suppress warning.
	(excel_read_BOOLERR) : new split from.
	(excel_read_sheet) : here.

	* ms-chart.c (BC_R(alruns)) : do not leak content. [#157059]
	(BC_R(pieformat)) : The magic 0xfffd in dataformat seems to do
	  something here too.  Without it plots that had a default separation
	  were thinking that it was just for 1 pt.

2005-09-30  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (text), (xl_chart_import_error_bar): fixed style leaks.

2005-09-30  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (xl_chart_import_reg_curve): set the correct value to the
	"affine" property.

2005-09-28  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (xl_chart_import_reg_curve) : split out from
	  ms_excel_chart_read.
	(xl_chart_import_error_bar) : ditto.

	* ms-excel-write.c (excel_font_overlay_pango) : check super/sub scripts.
	(excel_font_hash) : ditto.
	(excel_font_equal) : ditto.
	(excel_font_new) : init the super/sub status
	(map_underline_to_xl) : new.
	(map_script_to_xl) : new.
	(cb_write_condition) : handle super/sub script.
	(excel_write_FONT) : ditto.
	(excel_font_new) : ditto.

	* ms-excel-read.c (ms_wb_get_font_markup) : The super/subscript
	  distances were broken.  Use 5000 not 500.  Seems like we may want a
	  scale in there too.
	(excel_read_FONT) : Use GOFontScript
	(excel_get_style_from_xf) : store the script (super/sub)
	(excel_read_CF) : handle scripts.

2005-09-26  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat): read the areaformat for type 3
	to avoid a style leak.

2005-09-21  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_MARKERFORMAT): don't use style if NULL.

2005-09-21  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (markerformat): enhance markers import for MS_BIFF_V8
	(chart_write_MARKERFORMAT): enhanced export as well.

2005-09-18  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(radar)) : XL defaults to having markers, goffice
	  does not.
	* ms-chart.c (chart_write_plot) : check marker status for radar plots.

2005-09-14  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ms_excel_chart_read): import polynomial, exponential and
	logarithmic regression curves.

2005-09-08  Jody Goldberg <jody@gnome.org>

	* Release 1.5.90

2005-09-06  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_formula_shared) : finish TABLE importer.
	* ms-excel-write.c (excel_write_FORMULA) : finish TABLE exporter.

2005-09-04  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_ClientTextbox) : property is called
	  'text' not 'label'

2005-09-04  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (chart_write_AI) : Move logic from #152317 here.
	  If we are writing an expression with only a string constant do not
	  quote it.

2005-08-29  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : support data tables.
	* ms-excel-read.c (excel_formula_shared) : ditto.
	* ms-formula-write.c (write_node) : ditto.
	* ms-excel-write.c (excel_write_FORMULA) : ditto.

2005-08-27  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_map_forms_obj) : no need to warn about record with
	  no expressions. (Wallenbach/Formulas-2003/chap05/character\ set.xls)

2005-08-28  Morten Welinder <terra@gnome.org>

	* Release 1.5.5

2005-08-28  Morten Welinder <terra@gnome.org>

	* Release 1.5.4

2005-08-25  Stepan Kasal  <kasal@ucw.cz>

	* ms-chart.c (BC_R(text)): Comment out declarations of variables for
	commented out code.

2005-08-24  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_font_new) : typo. [#314206]

2005-08-17  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (ms_excel_chart_write): fix a compilation warning
	introduced yesterday and also a multiple chart export problem
	(#310967).

2005-08-15  Morten Welinder <terra@gnome.org>

	* Release 1.5.3

2005-08-15  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ms_excel_chart_write): unref state.root_view.

2005-08-05  Stepan Kasal  <kasal@ucw.cz>

	* ms-excel-write.c (excel_write_string): Fix warning.

2005-08-04  Jody Goldberg <jody@gnome.org>

	From Nick Lamb <njl98r@ecs.soton.ac.uk>
	* ms-excel-read.c (excel_read_XF_OLD) : improve alignment and
	  rotation handling.

2005-08-04  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_XF) : Add HALIGN_DISTRIBUTED. no idea
	  what that does.

	* ms-obj.c (ms_read_OBJ) : no docs for OBJ before biff5.  Ignore to
	  avoid problems.

	* ms-excel-util.c (init_xl_font_widths) : make the font hash case
	  insensitive.

2005-08-02  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c (ms_excel_chart_read): fixed import x error bars.

2005-08-01  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_WINDOW2) : Don't crash if there is no
	  view.
	(excel_read_SELECTION) : ditto.
	(excel_read_PANE) : ditto. #309544

	* ms-excel-read.c (excel_palette_get) : add the tooltip colour
	  ordinals

2005-07-29  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(objectlink)) : store the style for labels
	(BC_R(fontx)) : lookup the font and assign it to a style.  Need to
	  finish GOFont to store the remaining attributes.
	* ms-excel-read.c (excel_font_get_gofont) : new.
	(excel_read_FONT) : init the gofont member.
	(excel_font_free) : unref it here.

2005-07-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_SETUP) : remove unecessary scaling.

2005-07-15  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (excel_write_SETUP): Fix typo.

2005-07-06  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(objectlink)) : fix leak. [#157058]

2005-07-15  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_read_TXO) : handle CONTINUES for text
	(read_pre_biff8_read_text) : renamed from read_pre_biff8_read_str.
	  Handle continues in text and markup.  The layout is _very_ odd.
	  It seems that XL can write things it can not read.
	(read_pre_biff8_read_name_and_fmla) : handle the name reading inline,
	  that is different from read_text.  The CONTINUE handling is very
	  different.

	* ms-excel-write.c (excel_write_SETUP) : rewrite to handle the new
	  flags.
	(write_sheet_head) : export value for BIFF_PRINTHEADERS and only
	  export the left/right margins if they are set.

	* ms-excel-read.c : Store the ver in the importer rather than the
	  container.
	  s/ExcelWorkbook/GnmXLImporter/
	  s/ewb/importer/
	(excel_get_chars) : renamed from ms_biff_get_chars.  Take an importer
	  and use it's iconv rather than a global.
	(excel_get_text) : renamed from biff_get_text.  Take an importer
	  rather than a ver.
	(excel_read_BOUNDSHEET) : new need for a ver arg, just use the importer.
	(esheet_ver) : new.
	(gnm_xl_importer_set_version) : new.
	(gnm_xl_importer_set_codepage) : rename from
	  excel_iconv_open_for_import and store the iconv in the importer rather
	  than as a global.  Add improved fallback and debug info.
	(excel_palette_get) : merge default palette handing into here and add
	  0x7fff as a synonym for black.  We need a better solution for themed
	  colours eventually.  Change signature to take an importer rather
	  than the palette object directly.  That keeps us from digging into
	  the import object directly.
	(excel_get_default_palette) : delete.
	(excel_read_XF_OLD) : use ver from importer, no need for arg.
	(excel_read_XF) : ditto.
	(excel_read_FORMULA) : clarify up the debug info.
	(ms_wb_get_font_markup) : better fallback for invalid fonts.
	(gnm_xl_importer_new) : renamed from excel_workbook_new and remove the
	  version tag.  The importer is now created without a version, and we
	  init that later.  It also has a larger life cycle with the plan to
	  extend that and have gnumeric create it for the new in/out framework
	  use gobjects.
	(gnm_xl_importer_free) : renamed from excel_workbook_destroy and close
	  the iconv.
	(excel_read_name_str) : take an importer rather than a ver.
	(excel_read_SETUP) : rewrite to store the new biff8+ properties for
	  comments and errors, and to add n_copies, and start page.
	(excel_read_CF) : turn off some debugging.
	(excel_read_sheet) : add handler for BIFF_PRINTHEADERS.
	(excel_read_BOF) : merge the standalone worksheet handler with the
	  others.  Do not create the importer here, that get's passed in.
	(excel_read_workbook) : no need to set the global iconv here, the
	  importer handles it.  Create the importer much earlier as a step
	  towards gobjectificatin.

	* ms-chart.c (BC_R (ver)) : new to get the version from the importer
	(BC_R(area)) :
	(BC_R(attachedlabel)) :
	(BC_R(bar)) :
	(BC_R(line)) :
	(BC_R(markerformat)) :
	(BC_R(pie)) :
	(BC_R(scatter)) :
	(BC_R(series)) :
	(BC_R(shtprops)) :
	(BC_R(surf)) : Use it in place of passing in the ver
	(ms_excel_chart_read) : no need to pass version around
	(ms_chart_map_color) : adjust to change in excel_palette_get

	* ms-biff.c (ms_biff_password_hash) :
	(ms_biff_crypt_seq) :
	(ms_biff_pre_biff8_query_set_decrypt) :
	(ms_biff_query_set_decrypt) :
	(verify_password) : silence some sign difference warnings

2005-07-11  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_IMDATA) : Read the CONTINUE records
	  associated with the IMDATA even when not debugging. (#127756).

2005-07-11  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (excel_write_SETUP): Export page
	orientation. I.e.: get the meaning of "orientation set" flag
	right, and don't mark it "invalid".

2005-07-09  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_workbook): Read BOF before entering
	record reading loop (#152528).

2005-07-04  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ms_excel_chart_read): correctly import error bars
	for line plots (#309457).

2005-07-01  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (axislineformat): import axis grids,
	(chart_write_axis): export axis grids.

2005-07-01  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: import error bars, (linear) regression curves and stock
	plots, export stock plots.

2005-06-28  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (cb_write_condition) : no need to unmap the kludge
	  to handle overlays with back colours and no pattern.  We handle that
	  in the core now.
	* ms-excel-read.c (excel_read_CF) : rather than kludging it here.  It
	  was breaking when applying a conditional to a base that already had
	  a pattern.

2005-06-27  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_FORMULA) : improve debug output

2005-06-22  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (map_color_to_palette) : simplify
	  and remove the direct comparisons to colours.  Just take an
	  index and return it on NULL or auto.
	(xl_le_set_range) : new.
	(write_border) : new.
	(cb_write_condition) : new.
	(excel_write_conditions) : new.
	(excel_write_DVALs) : renamed from excel_write_DVAL.
	(excel_write_prep_conditions) : new.
	(put_colors) : look in conditional styles too.

	* ms-excel-read.c (excel_read_CF_border) : new.
	(excel_read_CF) : implement.
	(excel_read_CONDFMT) : complete.

2005-06-13  Jody Goldberg <jody@gnome.org>

	* Release 1.5.2

2005-06-02  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : slight improvement of
	  extended ptg parsing.  Use the test workbook to tell which items put
	  something on the stack and which do not.

2006-06-02  Emmanuel Pacaud <emmanuel.pacaud@univ-poitiers.fr>

	* plugins/excel/ms-chart.c (BC_R): use gog_object_set_position_flags.

2005-05-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_sheet) : store the default style after
	  we parse the sheet.  For older xls formats XF records happen after
	  the BOF.

2005-05-24  Morten Welinder  <terra@gnome.org>

	* ms-biff.c (ms_biff_query_destroy): Work harder at not leaving
	passwords in memory.
	(makekey): Ditto.
	(verify_password): Ditto.

	* ms-excel-read.c (excel_read_FILEPASS): Plug leak.

2005-05-18  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=166611
	* ms-formula-read.c (excel_parse_formula) : Create a fwd declaration
	  of a NAME record that has not been read yet being used in a PTG_NAME.

	* ms-excel-read.c (excel_read_NAME) : keep a count of the name
	  records and use fwd declaration if they exist.
	(excel_workbook_destroy) : move the names array into the workbook from
	  the container.
	(excel_workbook_new) : ditto.

2005-05-18  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=304528
	* ms-chart.c (ms_excel_chart_read) : don't leak the array for invalid
	  series (Analysis.xls).  Handle missing siindex record (chap03-1.xls).

2005-05-19  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=304558
	* ms-excel-read.c (excel_read_COLINFO) : we can't draw columns without
	  margins yet so map their width to 4pts rather than hiding them.

2005-05-17  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_chart_read) : add some protection

2005-05-17  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (excel_chart_series_new): Set data[i].series also.

2005-05-16  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (ai): replace a g_assert by a warning,
	(seriestext): add a const to fix a compilation warning,
	(end): fix default-style-has-lines,
	(chart_write_AI): fix a compilation warning and labels export,
	(ms_excel_chart_write): export GogSurfaceSeries.

2005-05-16  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c: Always set ->text_dir.

2005-05-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_XF) : remove debug spew

2005-05-14  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_AI): fixed tests, (chart_write_axis_sets ):
	add a missing break.

2005-05-13  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_AI): don't forget toi export the >AI record
	even for constant labels!

2005-05-13  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (seriestext): use a constant GnmExpr instead of
	a GODataScalarStr, (chart_write_AI): export constant series labels,
	(chart_write_siindex): fix a stupid bug.


2005-05-13  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (chart_write_AI): fix a crash condition. Constant series
	names are not exported yet.

2005-05-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_ROW) : fix debug spew

2005-05-12  Jody Goldberg <jody@gnome.org>

	* ms-pivot.c (excel_read_pivot_caches) : don't produce warnings for
	  files without OLE2 wrapper

2005-05-12  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: export series data when constant;

2005-05-10  Jody Goldberg <jody@gnome.org>

	* Release 1.5.1

2005-05-09  Morten Welinder  <terra@gnome.org>

	* ms-chart.c (chart_write_axis): Fix C99ism.

2005-04-23  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_func_desc) : We do not need the VARARG vs
	  FIXED flags anymore min_args vs max_args is enough.  Replace both
	  with XL_STD.
	(make_function) : No need to generate warnings about VAR vs FIXED
	* ms-formula-write.c (write_funcall) : Use max_args from the func
	  descriptor

2005-05-07  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (excel_chart_series_new), (ai), (series), (siindex),
	(switch), (while), (if): enhanced import of data, and make some work
	on coutour plots export.

2005-05-04  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c : Add ISHYPERLINK

	* ms-excel-write.c (excel_write_COLINFO) : patch a minor leak.

	* boot.c (excel_read_metadata) : close the meta data streams.
	(excel_file_open) : let the summary props overide the document.

2005-04-10  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: (3d), (ai), (axis), (surf), (switch):
	import contours and surfaces plots.

2005-04-09  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_save) : Use the new GsfDocMetaData api
	(excel_read_metadata) : ditto.
	(excel_file_open) : ditto.

2005-03-24  Stepan Kasal  <kasal@ucw.cz>

	* Makefile.am (excel_la_LIBADD): Add an explanation for $(Z_LIBS).

2005-03-23  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_workbook) : add a hook to read pivot
	  table caches.  It doesn't do much yet, but it's a start.
	* ms-biff.c (ms_biff_query_copy_decrypt) : new TODO
	* boot.c : Add a debug hook for pivots, and remove pointless comments
	* biff-types.h : update for the pivot table and cache elements
	* Makefile.am : Add ms-pivot.[ch]

2005-03-23  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_read_OPT): Use g_fopen, not fopen.
	* ms-excel-read.c (excel_read_IMDATA): Ditto.

2005-03-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_workbook) : init n when totaling the
	  number of cells.

2005-03-14  Jean Brefort  <jean.brefort@normalesup.org>

	* ms-chart.c: import/export logarithmic axis.

2005-03-13  Emmanuel Pacaud <emmanuel.pacaud@univ-poitiers.fr>

	* ms-chart.c (BC_R): use gog_chart_get_axes.
	(chart_write_axis_sets): use gog_chart_get_axis_set.
	s/AXIS_ELEM/GOG_AXIS_ELEM

2005-03-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_DV) : Lists also have no use for
	  operators.
	  Invert the use_dropdown flag.  XL stores that as 'suppress combo'
	* ms-excel-write.c (excel_write_DV) : invert user_dropdown

2005-03-11  Jean Brefort <jean.brefort@normalesup.org>

	* ms-chart.c (valuerange): import logarithmix axis mapping.

2005-02-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_workbook) : Use count_io_progress_set
	  so that we can remove workbook_io_progress_set.

2005-02-09  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_BOUNDSHEET) : set the visibility of
	  imported sheets.

2005-02-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_SETUP) : drop debug spew

2005-02-08  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (txomarkup_new): Work around Pango bug #166700.
	Don't compare freed pointer against NULL.  Fixes #166532.

2005-02-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_SETUP) : store the fit to pages width
	  and height.
	(excel_write_WSBOOL) : set the fit to page flag.

	* ms-excel-read.c (excel_read_WSBOOL) : read the fit to page flag.
	(excel_read_SETUP) : read the fit to pages width and height.

2005-02-08  Jody Goldberg <jody@gnome.org>

	* Release 1.5.0

2005-02-07  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_font_overlay_pango): Plug leak.
	[#166561]

2004-12-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WINDOW2) : export sheet level rtl
	  setting (we could move it to SheetView)
	(build_xf_data) : store the text dir.
	(excel_write_XF) : write it.

	* ms-excel-read.c (excel_read_WINDOW2) : read sheet level rtl flag
	(excel_read_XF) : read the text dir.
	(excel_get_style_from_xf) : store the text dir.

2005-01-17  Jody Goldberg <jody@gnome.org>

	* Release 1.4.2

2005-01-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_COLINFO) : fix the breakage

	http://bugzilla.gnome.org/show_bug.cgi?id=163236
	* ms-formula-read.c (excel_func_desc) : Merge in the latest OOo data
	  and some new research

	* boot.c (plugin_init) : add some function table validation tests.
	  We'll want more as the data structures get cleaned up

2005-01-14  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=155719
	* ms-excel-write.c (writer_header_footer) : quick and easy
	  implementation.
	* ms-excel-read.c (xl_hf_strstr) : simple handling of XL's ampersand
	  escaping.
	(excel_read_HEADER_FOOTER) : implement.

2005-01-13  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=163409
	* ms-excel-write.c (excel_write_COLINFO) : handle ci == NULL
	  so that we can export empty cols with formats.  If the format is the
	  same as the sheet default don't bother to export.
	(excel_write_colinfos) : we may need to export empty cols.

2005-01-10  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=163406
	* ms-excel-util.c (init_xl_font_widths) : fix entries for Bitstream
	  Vera and Sans

2005-01-10  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_arrays) : handle booleans and errors in
	  arrays

2004-11-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_realize_obj) : We have a clear separation
	  between create and realize now, we should use it.  This routine sets
	  the content.
	(ms_sheet_create_obj) : this one creates objects for use later.
	  I am not entire happy with this split.  It no longer feels
	  necessary but it is much too close to release to contemplate
	  cleaning it up.

2004-12-17  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=161534
	* ms-excel-read.c (excel_read_DIMENSIONS) : be extra anal with
	  dimension records because they have ordinal zero

2004-11-20  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-excel-read.c (excel_read_SETUP): Also import paper sizes for which
	gnome-print doesn't have names.

2004-12-09  Jody Goldberg <jody@gnome.org>

	* Release 1.4.1

2004-12-09  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(surf)) : prep but leave ifdefed to avoid problems
	  with XL's funky representation of axes.

2004-11-28  Jody Goldberg <jody@gnome.org>

	* Release 1.4.0

2004-11-28  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_WINDOW2) : document rtl
	* ms-excel-write.c (excel_write_WINDOW2) : ditto

2004-11-19  Emmanuel Pacaud <emmanuel.pacaud@univ-poitiers.fr>

	* ms-chart.c (BC_R(radararea)): type of area radar is
	GogRadarAreaPlot.
	(chart_write_plot): ditto.

2004-11-16  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_chart_write) : ultra-basic handling of graphs
	  with multiple charts

2004-11-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_SETUP) : hide some spurious debug spew

2004-11-15  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=157997
	* ms-excel-read.c (ms_sheet_realize_obj) : a temp patch for the object
	  double unrefing.  A more significant patch is waiting for after
	  release.

2004-11-14  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-excel-read.c (excel_read_SETUP): Import paper sizes. This works
	  now that we have delayed instantiation of print configs. For now it
	  only works for paper sizes for which gnome-print has names though.

2004-11-07  Jody Goldberg <jody@gnome.org>

	* Release 1.3.93

2004-10-31  Jody Goldberg <jody@gnome.org>

	* Release 1.3.92

2004-11-01  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (ms_biff_get_chars): Give g_iconv the right kind
	of pointer.

	* ms-excel-write.c (excel_write_string): Ditto.
	(excel_write_string_len): Change second argument to be size_t*.

	* ms-excel-read.h (ms_biff_get_chars): Give g_iconv the right kind
	of pointer.

	* ms-excel-write.h (excel_write_string_len): Change second 
	argument to be size_t*.

	* ms-escher.c (ms_escher_get_data): Fix confusion between
	ptrdiff_t and int.

2004-10-18  Jon K Hellan  <hellan@acm.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj): Unref pixbuf returned by
	excel_read_IMDATA.

	* ms-excel-read.c (excel_read_os2bmp): New. Handle headerless OS/2
	bitmap.
	(excel_read_IMDATA): Call excel_read_os2bmp to handle OS/2
	BMP. Other format may be dumped to file.
	(excel_read_sheet): Unref pixbuf returned by excel_read_IMDATA.

2004-10-15  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_sheet_new): Don't free the same thing
	twice.

2004-10-11  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (ms_sheet_realize_obj): Plug leak.

2004-10-10  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_map_forms_obj) : move here and pull in the linked
	  cell data when available.

2004-10-08  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_biff8_obj) : some simple mapping from Forms
	  objects to things we understand.  No properties imported yet.

	http://bugzilla.gnome.org/show_bug.cgi?id=154734
	* ms-chart.c (BC_R(end)) : cheesy swapping of the formatting
	  associated with X and Y axes for bar plots.

2004-10-05  Jody Goldberg <jody@gnome.org>

	* Release 1.3.91

2004-09-16  Stepan Kasal  <kasal@ucw.cz>

	* Makefile.am (excel_la_LIBADD): New variable, set to $(Z_LIBS).
	(INCLUDES): add $(Z_CPPFLAGS)

2004-09-24  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_attr_new_flag) : add some safety checking
	(ms_obj_read_pre_biff8_obj) : merge up the handling of similar
	  structures to get more consistent import.

	* ms-excel-write.c (excel_write_objs) : now that text boxes and
	  rectangles are the same we need to do more work to figure out which
	  are which.  Make a list and use that in place of repeated lookups.
	(excel_sheet_new) : make the list here.
	(excel_write_state_new) : use the list.
	(excel_sheet_free) : new.
	(excel_write_state_free) : use excel_sheet_free.

	* ms-excel-read.c (ms_sheet_map_color) : rework to use GOColor
	(ms_sheet_realize_obj) : simplify greatly by using GObject properties
	  with common names in the sheet objects and merging the handling of
	  related types (text==rectangle ...)
	(ms_sheet_create_obj) : Use the new object types in a step towards
	  removing this function.

	* ms-escher.c (ms_escher_read_OPT_bools) : new.
	(ms_escher_read_OPT) : read the boolean blocks as a group to avoid
	  kludging around the infrastructure for 1:1 properties.
	 While in here make the debug spew for complex options more useful
	 Store PTR properties

2004-09-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_realize_obj) : default to outline with == 1

2004-09-22  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=153260
	* ms-excel-write.c (excel_write_BOF) : use the versioned ids directly
	(excel_write_FORMULA) : ARRAY is v2 for the versions we can export

	* ms-excel-read.c (excel_unexpected_biff) : tweak the typing for
	  printf
	(ms_biff_bof_data_new) : straight to opcodes.
	(excel_read_PALETTE) : ditto.
	(excel_formula_shared) : ditto.
	(excel_read_DEF_ROW_HEIGHT) : ditto.
	(excel_read_FORMULA) : ditto, but be careful.  Use the BOF version,
	  not the record.  Our export was dropping the version.
	(excel_read_ROW) : better handling for old versions.

	* ms-chart.c (ms_excel_chart_read) : use raw opcodes for non-chart
	  records

	* ms-biff.c : Drop all the ms_op ls_op nonsense and just store opcode
	  a straight 16 bit id.

	* biff-types.h : Rework to include explicit versioning for all records
	  We were hitting too many odd ball records with invalid versioning
	  Not just 0x1<byte>, but also 0x8<byte> even though that is a valid
	  version.

2004-09-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (xl_find_fontspec) : Scale the right direction

2004-09-18  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-excel-read.c: Added comments on how the paper size information can
	  be used once gnome-print's API has been extended. 

2004-09-17  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (ms_escher_read_OPT) : make debug spew slightly easier
	  to read.

2004-09-16  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (xf_init): Register default XF, its font and
	format here.
	(pre_pass): Not here.

2004-09-15  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (txomarkup_new): New. Factored out of
	cb_cell_pre_pass. 
	(cb_cell_pre_pass): See above.
	(excel_write_ClientTextbox): Change first parameter to
	ExcelWriteState. Save markup.
	(excel_write_textbox): See above.
	(extract_txomarkup): New. Extract markup for text object and store
	in hash table.

2004-09-14  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : rework the font table
	  completely to use more closely calibrated size info.

	* ms-excel-read.c (base_char_width_for_read) : delete
	(xl_find_fontspec) : new.
	(excel_read_COLINFO) : rework to simplify by using the new font table,
	  and sync it with the exporter.
	(excel_read_DEF_COL_WIDTH) : ditto.
	(excel_read_sheet) : Store the default style on import.  We have no
	  way of modifying it at run time, so we might as well use it for
	  export.

2004-09-09  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(pieformat)) : Store the separation for singletons
	(cb_store_singletons) : Check for pie separation and use it

2004-09-09  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (excel_chart_series_new) : init singletons
	(excel_chart_series_delete) : free singletons if necessary
	(BC_R(end)) : Create any singletons for the newly created series

2004-09-09  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_PALETTE): Plug leak.

2004-09-08  Jody Goldberg <jody@gnome.org>

	* Release 1.3.90

2004-09-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (palette_init) : Just use biff8 palette.  We're
	  going to dump a custom palette anyway so it does not really matter

2004-09-04  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (excel_write_ClientTextbox,
	excel_write_textbox): Implement simple text box export.
	(excel_write_objs, excel_sheet_new): Export text boxes.

2004-09-03  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (palette_init) : Export the xlp5 colours too

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : remove some unnecssary
	  pre-conditions that got confused when there was no name even when we
	  were not expecting one.
	(excel_get_default_palette) : get a corrected palette for biff7.

	* ms-excel-read.c (ms_sheet_realize_obj) : merge the realization of
	  text/label/rectangle/oval they all inherit from sheet-object-filled.

	* ms-escher.c (ms_escher_read_OPT) : Make some headway understanding
	  booleans and use that to fix outline and fill handling.

2004-09-02  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=151618
	* plugins/excel/ms-chart.c (BC_R(end)) : Add the plot to the chart
	  before setting it up so that the initial setup does not override the
	  formating

2004-08-31  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_crypt_seq) : Add some bounds checking
	  We need more docs in here.

2004-08-30  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_BOUNDSHEET) : Export the sheet types
	  we can import (worksheet, chart, xlm).
	  Export sheet visibility too

2004-08-31  Morten Welinder  <terra@gnome.org>

	* md5.c (wvMD5Init, wvMD5Update): Use ANSI prototypes.

2004-08-29  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : disable the non-functional spreadsheetml importer

2004-08-29  Jody Goldberg <jody@gnome.org>

	* Release 1.3.2

2004-08-29  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=151150
	* ms-chart.c (ms_excel_chart_write) : bar/col plots center axis ticks

2004-08-27  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_chart_write) : MS Xl can not handle plots with
	  no data.  Drop them with a warning.

	* ms-excel-write.c (excel_write_workbook) : We only need a header if
	  we're going to export an image.

2004-08-26  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c: Remove ENABLE_METAFILE ifdef

2004-08-22  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(area,bar,line)) : Use the in_3d placeholders in
	  plot_1_5d, we already export it.

2004-08-21  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_IMDATA): Add comment about OS/2 BMP
	format.

2004-08-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_BOUNDSHEET) : Fix differentiation
	  between sheet and chart, then handle both.
	(excel_read_BOF) : Handle full page charts.

	* ms-chart.c (BC_R(pieformat)) : no need to limit separation here.
	  The plot can handle it.

2004-08-17  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c: Enable WMF/EMF export.
	(blipinf_free): Don't crash if blip is NULL. That's supposed to
	happen.
	(excel_write_vector_blip): Fix off by 8 bytes error.

2004-08-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : adjust the sizes for 'Sans'
	  to conform to XL's notion of an unknown font

2004-08-15  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_node) : get closer to matching the classes
	  for the more obscure variants, OOo is wrong, but I don't have a
	  clear map on what is right yet.

	* ms-excel-write.c (excel_write_BOF) : update the version in the BOF a
	  bit.

	* ms-formula-read.c : tweak the expected return types for SUM,
	  TRANSPOSE, MINVERSE, and MMULT

2004-08-11  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_formula_shared): Simplify using g_memdup.
	(excel_read_IMDATA): Initialize variables.

	* ms-escher.c (ms_escher_blip_new, ms_escher_read_ClientAnchor):
	Ditto.

	* crypt-md4.c: Include crypt-md4.h and make signatures consistent
	with it.

	* crypt-md4.h: Add include guards.

2004-08-11  Jon K Hellan  <hellan@acm.org>

	Export images.

	* Makefile.am (excel_la_SOURCES): Add crypt-md4.[ch]

	* crypt-md4.[ch]. New files. MD4 checksum to use as BLIP
	id. Grabbed from Ethereal, originally from Samba.

	* ms-excel-write.c: 
	(blipinf_new): New function. Initialize a record for image data.
	(blipinf_free): New function. Free an image data record.
	(excel_write_image): New function. Write an image Sp record
	referencing a BLIP.
	(excel_write_objs): Include images in record length. Write images.
	(excel_sheet_new): Save image info.
	(excel_write_image_bytes): New function. Save image in chunks,
	letting the biff layer insert CONTINUE records.
	(excel_write_vector_blip): New function. Save a vector format BLIP.
	(excel_write_raster_blip): New function. Save a raster format BLIP.
	(get_bliptype): New function. Get bliptype record.
	(excel_write_blip): New function. Save an image BLIP.
	(excel_write_blips): New function. Save the images as BLIPs.
	(excel_write_workbook): Get length of BLIP records. Call
	excel_write_blips.
	(excel_write_state_new): Initialize cur_blip.
	(excel_write_state_free): Free BLIP lists from sheets.

	* ms-excel-write.h (struct ExcelWriteSheet): Add blips, num_blips.
	(struct _ExcelWriteState): Add cur_blip.

2004-07-10  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_workbook) : write WINDOW1 for all the views
	(excel_write_sheet) : Drop the WINDOW1 here but expand to write a
	  WINDOW2, PANE, SCL, SELECTION tuple for all views, not just the
	  current

2004-07-19  Jody Goldberg <jody@gnome.org>

	* Release 1.3.1

2004-07-05  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_IMDATA) : Add an optional mechanism for
	  doing something with the data.  Still not entirely sure what format
	  it is.  I'd hoped BMP but that does not appear to work.

	* biff-types.h : Add a few more records

2004-06-29  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_REFMODE) : new.
	* ms-excel-write.c (write_sheet_head) : export REFMODE

2004-06-26  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_read_metadata) : Failure is a warning, not
	  catastrophic

	* ms-chart.c (ms_excel_chart_write) : do not write FBI
	(chart_write_axis_sets) : Handle transposed X-Y (bars)

2004-06-22  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (extract_gog_object_style) : handle no fmt for axis.
	(excel_write_objs) : the count is +1, not the spid

2004-06-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (palette_get_index) : make public
	(excel_write_start_drawing) : new to handle spids across sheets.
	(excel_write_autofilter_objs) : use it.
	(excel_write_chart) : use it.
	(excel_write_objs) : do more detailed obj setup here.
	(put_color) : minor simplification.
	(extract_gog_object_style) : new
	(excel_write_state_new) : use it to collect the colors for the
	  palette.
	(excel_sheet_new) : decide on sheet obejcts to export here.

	* ms-escher.c (-excel_write_MS_O_DRAWING_GROUP) : delete

	* ms-chart.c (}) : First pass at a basicly working chart exporter

2004-06-13  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (excel_write_MS_O_DRAWING_GROUP) : merge the xp and 2k
	  versions and tidy up.  This will likely need some work for blips

	* ms-chart.c (chart_write_plot) : implement the plot types we can
	  import.
	(chart_write_axis) : provide a default for inverted and
	  log-scale so that we only set them if lookup succeeds.
	(ms_excel_write_chart) : more work.  gnumeric and OOo can
	  now import the basic column charts.  XL does not like the colours
	  and gets the formating wrong, but it can at least read a single
	  chart happilly.

	* ms-excel-write.c (excel_write_chart) : put the spid in the write
	  spot I was off by two bytes.
	(excel_write_autofilter_objs) : Move the container wrapper from here
	(excel_write_objs) : to this new routine so that it can be shared by
	  filters and charts.  We are now close to bit perfect matches to XP.

2004-06-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_chart) : add and End after the common

	* ms-chart.c (chart_write_color) : write.

2004-06-08  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_FILEPASS): Use gnm_destroy_password.

2004-06-05  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_chart) : sync the sizes when exporting
	  the anchor and object id.

2004-06-01  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(end)) : patch style leak

2004-05-31  Jody Goldberg <jody@gnome.org>

	* ms-chart.c : more fill in the blanks work towards export.
	(BC_R(seriestext)) : Use the simpler GODataScalarStr

2004-05-26  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_AUTOFILTERINFO) : Use the right buffer

2004-05-24  Jody Goldberg <jody@gnome.org>

	* ms-chart.c : more work towards chart export

	* ms-biff.c (ms_biff_put_2byte) : fix.

2004-05-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_WSBOOL) : add more comments.

	* ms-chart.c (ms_excel_write_chart) : start filling in some of the
	  blanks.  No where near functional, but at least we can operate in
	  'paint by numbers' mode for a while.

	* ms-biff.c (ms_biff_put_empty) : new util
	(ms_biff_put_2byte) : ditto.

	* ms-excel-write.c : Use the new utilities to clarify the code.
	(excel_write_SETUP) : make public for use in chart export
	(excel_write_SCL) : make public for use in chart export

2004-05-20  Morten Welinder  <terra@gnome.org>

	* ms-escher.c (ms_escher_read_Blip): We were reading 8 bytes too
	few.

2004-05-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_BOF) : init the len for bifftypes
	  before biff8.
	http://bugzilla.gnome.org/show_bug.cgi?id=103054
	(write_sheet_head) : put externsheet tables in every sheet for biff7
	(excel_write_externsheets_v8) : The self reference is for the addin,
	  not the others.  Fixes 103054 for XL97
	(excel_write_workbook) : NAME records start at 0, not at the end of
	  the externname table

	* boot.c (excel_file_open) : 95 in should export as 95
	(find_content_stream) : keep track of what type of stream this is.

	* ms-chart.c (BC_R(axislineformat)) : deleted axis still exist, and
	  they hide their labels here rather than in tick.  Don't apply grid
	  line styles to the axis.

2004-05-10  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(end)) : doh!  Use the ExcelSeries::has_legend to
	  set the GogSeries not the GogSeries on itself.

2004-05-09  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_WINDOW2) : It seems like there can be
	  multiple WINDOW2, SCL, PANE, SELECTION blocks when there are
	  multiple windows.  For now we don't support importing multiple views
	  so we need to at leat not break if a previous view was frozen.

2004-05-07  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_put_var_write) : Quick and simple support for
	  continue.  It will not split a block of content, but it will split
	  between blocks (attempted writes).

2004-05-06  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_attr_get_*) : Take an attrbag rather than an obj to
	 be more useful.

	* ms-escher.c (ms_escher_read_container) : add a
	  'return_attrs_in_container' kludge parameter.
	(ms_escher_parse) : make the return of the attributes optional and
	  actually make it work.
	(ms_escher_read_OPT) : load properties for gradients.

	* ms-chart.c (BC_R(gelframe)) : support gradients
	(BC_R(legend)) : store the legend object.
	(BC_R(legendxn)) : notice deleted legend elements.
	(BC_R(text)) : import the text colour.
	(BC_R(end)) : support legend styles and clarify the grid vs plotarea
	  distinction.

2004-05-03  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c : some tweaks to get a layout that will support
	  richtext.

2004-05-04  Morten Welinder  <terra@gnome.org>

	* ms-excel-write.c (excel_write_DV): Map VALIDATION_OP_NONE to
	VALIDATION_OP_BETWEEN on save.

	* ms-excel-read.c (excel_read_DV): Make sure
	VALIDATION_TYPE_CUSTOM is paired with VALIDATION_OP_NONE.

2004-04-29  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_font_overlay_pango) : new.
	(excel_write_RSTRING) : new.
	(cb_cell_pre_pass) : merge cb_collect_value_fmts, sst_collect_str
	  add support for richtext
	(excel_write_cell) : export RSTRINGS for richtext

2004-04-22  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=136086
	* ms-excel-write.c (excel_sheet_write_DBCELL) : optimization was a bit
	  optimistic.  Even if there are no values, we still need to export
	  rows with visible formating (borders, backgrounds, ...)

2004-04-21  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (excel_read_LABEL): Plug leak.

2004-04-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (sst_read_string) : Use the right string when
	  calculating offsets.

2004-04-19  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(end)) : graph style wants outline not line
	(ms_excel_read_chart) : there is not 'Graph' concept in xls, remove
	  it's style.  Charts default to blank too.

2004-04-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_sheet_insert_val) : fix the fix.
	  We do need to apply the style, even if we're not going to assigned
	  the format to the value.

2004-04-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (sst_read_string) : don't forget the last markup
	  element.  Leave some debug in here to figure out what's going on
	  with quick test.

2004-04-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_sheet_insert_val) : only assign a format if
	  there is no existing markup.
	(sst_bound_check) : do some extra checking to ensure the existence of
	  unbroken region of desired length.
	(sst_read_string) : handle rich text.

2004-04-18  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : fix the name offset for
	  polygons

	* ms-excel-read.c : convert global_string char * array into an
	  ExcelStringEntry sst array with strings and markup in preparation
	  for reading richtext from an SST.

2004-04-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_HEADER_FOOTER) : new to handle biff8 vs
	biff7
	(excel_read_LABEL_markup) : new.  Handle biff[57] and biff8 RSTRING
	  markup

2004-04-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_str_name) : new.
	(excel_read_str_name) : split from here.
	(excel_read_EXTERNNAME) : used here too.

	* ms-excel-read.c (excel_read_XF_OLD) : differentiate biff2 vs biff3
	  and biff4.

2004-04-15  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_read_chart_BOF) : ignore the version in the BOF
	  it lies.  Use the container's version.

	* ms-excel-read.c (excel_read_NAME) : rework to handle unicode
	  suffixes and to some general cleanup.

2004-04-14  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_DEF_ROW_HEIGHT) : handle biff2
	(excel_read_WINDOW2) : ditto.
	(excel_read_EXTERNSHEET_v7) : be smarter about handling the buggy
	  files from 1.0.7 that exported quoted sheet names.

2004-04-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c : Use GO_UNIT in place of inches_to_points.

2004-03-28  Jody Goldberg <jody@gnome.org>

	* Release 1.3.0

2004-03-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WINDOW2) : We only support frozen
	  panes.  Set the flag indicating that this was only a freeze, not a
	  split too.
	(excel_write_PANE) : docs are wrong.  The field indicates what type of
	  freezing.
	(excel_write_selections) : rework to match XL.
	(excel_write_SCL) : Only write the record if zoom != 100%
	(excel_write_BOF) : update BOF to XP sp2

	* ms-excel-read.c (excel_read_SELECTION) : Allow the active pane from
	  the PANE record to override the default of 3.
	(excel_read_PANE) : store the active pane.

2004-03-16  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=137377
	* ms-obj.c (ms_read_TXO) : init markup even if there is no string.

2004-03-11  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=136730
	* ms-excel-read.c (excel_get_xf) : be more flexible and handle xls
	  generated with no XF records.
	(excel_get_style_from_xf) : ditto.
	(excel_sheet_insert_val) : ditto.

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : despite the name
	  PangoAttributes::end_index is exclusive, not inclusive.

2004-03-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_XF) : throw in a simple heuristic for
	  when to set a valueformat.  At issue is that we want to display
	  dates/times formatted, but do not want to display accounting
	  formats.  This kludge disables the application for any format that
	  has more than one condition.  It's not strictly a solution, but it
	  will solve the common problems.

2004-03-06  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : handle outline width for text
	  boxes.
	* ms-excel-read.c (ms_sheet_create_obj) : ditto.

2004-03-06  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_attr_new_markup) : new.
	(ms_obj_attr_get_markup) : new.
	(ms_obj_attr_destroy) : teach about PangoAttrList
	(append_txorun) : new.
	(ms_obj_read_pre_biff8_obj) : font colours come with the FONT info in
	  txoruns.  The docs are wrong the colour in the record is useless.
	  Remove some extra debug spew.

	* ms-excel-read.c (excel_wb_get_fmt) : no point using pointers to
	  ints.  Just use G_INT_TO_POINTER.
	(ms_sheet_get_fmt) : ditto.
	(excel_read_BOUNDSHEET) : ditto.
	(excel_workbook_new) : ditto.
	(excel_workbook_reset_style) : ditto.
	(base_char_width_for_read) : ditto.
	(excel_read_FORMAT) : ditto.
	(excel_read_FONT) : ditto.
	(excel_get_font) : ditto.
	  Also no need for this to take a sheet, take a workbook.
	(biff_font_data_destroy) : free the new optional attr lists.
	(ms_sheet_create_obj) : Use markup rather than a single colour.
	(biff_guint16_hash (guint16 const *d)
	(biff_guint32_hash (guint32 const *d)
	(biff_guint16_equal) : delete.
	(biff_guint32_equal) : delete.
	(excel_get_style_from_xf) : remove some useless code now that font
	  substitution is handled at the app level.
	(add_attr) : new.
	(ms_wb_get_font_markup) : new.  build a PangoAttrList from a FONT record.

	* ms-container.c (ms_container_get_fmt) : automatically chain up
	(ms_container_get_markup) : new.

	* ms-chart.c (chart_get_fmt) : delete.

2004-03-03  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_formula_parses_ref_sheets) : extend to
	  handle local 3d references properly.

2004-02-22  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(end)) : We're using GogRadar rather than GogRadial.
	  Set the no-marker state using the right name.
	(BC_R(radararea)) : set the area flag to indicate filled.

2004-02-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (two_way_table_new) : store the destroy func.
	(two_way_table_put) : patch leak and use the destroy func on things
	  that are already in the table.

	* ms-chart.c (BC_R(radar)) : connect the new engine
	(BC_R(radararea)) : ditto.

2004-02-09  Morten Welinder  <terra@gnome.org>

	* ms-biff.c (ms_biff_query_next): Change to return gboolean and
	fix the g_return_val_if_fail results.

2004-02-04  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_CODENAME) : new routine to store the
	  codename for later use while round tripping.
	(excel_read_sheet) : use it here.
	(excel_read_workbook) : use it here.

	* ms-excel-write.c (excel_write_CODENAME) : new routine to use the
	  stored codename rather than generating one on the fly.
	(excel_write_sheet) : use it here.
	(excel_write_workbook) : and here.

2004-01-29  Jody Goldberg <jody@gnome.org>

	From Nick Lamb <njl98r@ecs.soton.ac.uk>
	* ms-excel-read.c (excel_read_FILEPASS) : new.
	(excel_read_sheet) : use it here.
	(excel_read_workbook) : and here.

2004-01-28  Jean Brefort  <jean.brefort@ac-dijon.fr>

	* plugins/excel/ms-chart.c: (scatter):add import of bubble plots

2004-01-28  Andreas J. Guelzow <aguelzow@taliesin.ca>

	* ms-excel-read.c (excel_read_SETUP): use print_info_set_orientation
	* ms-excel-write.c (excel_write_SETUP): ditto                  

2004-01-16  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (ms_escher_get_data) : as pointed out by Nick Lamb
	  some gelframe records can get rather big.

2004-01-14  Jody Goldberg <jody@gnome.org>

	From Nick Lamb <njl98r@ecs.soton.ac.uk>
	* ms-biff.c : Merge in patch to support xor based 'encryption'

2004-01-12  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=130791
	* ms-formula-write.c (excel_write_prep_expr) : fix cut-n-paste-o in
	  change for 1.2.2 that added macros and broke plugin functions.

2004-01-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_SELECTION) : disable some debug spew.

2004-01-07  Jon K Hellan  <hellan@acm.org>

	* ms-chart.c (BC_R(legend)): Initialize pos for XL_pos = 7.

2004-01-05  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=130577
	* ms-excel-write.c (excel_write_SELECTION) : generalize a bit.
	(excel_write_selections) : new wrapper to handle selectins for each pane

	http://bugzilla.gnome.org/show_bug.cgi?id=130579
	* ms-excel-read.c (excel_read_SELECTION) : we only care about
	  selections in the primary pane.

2003-12-24  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WRITEACCESS) : don't free memory we do
	  no own.
	(excel_write_COUNTRY) : init both fields.
	(write_sheet_head) : pre biff8 it was part of the sheet record.  Its
	  hard to tell if this should be part of every sheet or just the first.
	  I've seen both.
	(write_workbook) : biff8 puts the COUNTRY record in the workbook area.

2003-12-23  Jody Goldberg <jody@gnome.org>

	* Release 1.2.3

2003-12-22  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(ifmt)) : pull in axis value format.

2003-12-19  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (excel_write_WRITEACCESS): Use
	gnm_get_real_name to get user name.

2003-12-18  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (XL_gog_series_set_dim) : Don't leak data we're not
	  expecting.
	(BC_R(get_style)) : new.  creates the style as necessary, and flags it
	  to ignore the object's default settings.

2003-12-13  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=127625
	* ms-excel-read.c (excel_sheet_destroy) : kludge around autofilters in
	 XL97 that have no related drop downs (eg guia.xls)

2003-11-26  Jody Goldberg <jody@gnome.org>

	* Release 1.2.2

2003-11-25  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (excel_write_prep_expr) : handle macros.
	(write_funcall) : ditto.

	* ms-formula-read.c : add specs for the text_B_ functions
	(excel_parse_formula) : improve debug info.
	  Fix unicode strings.

	* ms-excel-write.c (write_workbook) : unsigned does not go < 0
	(cb_enumerate_macros) : new.
	(cb_write_macro_NAME) : new.
	(excel_write_names) : new.
 
	* ms-excel-read.c (get_xtn_lens) : add a limiter on the rich text
	  warning.
	(excel_formula_shared) : add some debug.
	(excel_read_NAME) : register macro functions.
	(excel_read_ROW) : disable debug spew.
	(excel_read_CF) : ditto.
	(excel_read_DIMENSIONS) : ditto.
	(excel_read_GUTS) : ditto.
	(excel_read_HLINK) : target frame is first (according to 
	  xls-export-crash.xls) and the docs.
	(excel_read_SUPBOOK) : handle external workbooks with unicode names.

	* ms-escher.c (ms_escher_parse) : return the property bag.

2003-11-20  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(radar)) : Add a note.

2003-11-20  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (make_function) : Take a Workbook to allow for
	for book local function lookup.

2003-11-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_sheet_new) : Include row/col info in the
	  extent calculation.

	* ms-excel-write.c (excel_write_GUTS) : max col/row outline levels are
	  one based.

2003-11-19  Andreas J. Guelzow  <aguelzow@taliesin.ca>

	* ms-excel-read.c (excel_read_SETUP): use print_info_set_n_copies

2003-11-18  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(lineformat)) : Handle 'invisible'
	(BC_R(markerformat)) : none is never auto.
	(BC_R(end)) : Set the plot defaults for line and XY.

2003-11-17  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=127204
	* ms-chart.c (ms_excel_read_chart) : remove any grids that were
	  automaticly created if there were none in the input stream.

	* plugins/excel/ms-chart.c (BC_R(areaformat)) : we need to consider
	  pattern = 0 as NONE only if it is not autoformat.  Our theme engine
	  does not change fill types, so it would ignore styles with fill=NONE

2003-11-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (write_sheet_head) : save the manual recalc flag.

2003-11-14  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=126908
	* ms-excel-read.c (ms_sheet_create_obj) : gnumeric defaults to
	  different outline and background colours.  Set them if the file does
	  not so that things look xl-ish.

2003-11-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_sheet) : store a CODENAME
	(write_workbook) : ditto.

	* boot.c (excel_save) : store the saved properties if we have them
	(excel_file_open) : store CompObj and properties.
	(excel_read_metadata) : its easier to blob the stream.

2003-10-27  Jody Goldberg <jody@gnome.org>

	* boot.c (find_content_stream) : Move this logic here.
	(excel_file_open) : from here.
	(excel_file_probe) : so that this can share it.

2003-10-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_SELECTION) : doh!

2003-10-18  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=124244	[unable to open group]
	* ms-excel-read.c (excel_read_COLINFO) : set collapsed even if level == 0
	(excel_read_ROW) : ditto.

2003-10-13  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_query_next) : fail if we run out of data part way
	  through a record.

	* ms-excel-read.c (excel_read_XF_OLD) : init all flags to FALSE.

2003-10-08  Jody Goldberg <jody@gnome.org>

	* Release 1.2.1

2003-10-08  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (conditional_set_double) : Use the new const val GOData
	  to support manual axis bounds and invert the logic to be correct.
	(BC_R(seriestext)) : store the text associated with axis and chart
	  labels.
	(BC_R(end)) : free strings associated with text records if they
	  haven't been used yet.

2003-09-30  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_HLINK) : typo 0x80 rather than 0x8 was
	  breaking import of local workbook links (Thanks to Tim for noticing)

2003-09-29  Jody Goldberg <jody@gnome.org>

	From Nick Lamb <njl195@zepler.org.uk>
	* boot.c (excel_file_probe) : bug in libgsf < 1.8.3 that would not
	  seek back to 0 on failed gsf_infile_msole_new.

2003-09-27  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_funcall) : Use the last specified type for
	 the remainder of the args in a vararg function.

	* ms-formula-read.c : AND,OR, and IF args appear to be V not R

2003-09-27  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_SST) : be extra careful about unicode
	  characters > 0xfeff

2003-09-25  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (ms_escher_read_OPT) : dump the complex data too so that
	  we don't forget it exists.

	* ms-chart.c (excel_chart_series_new) : init style.
	(excel_chart_series_delete) : unref style if necessary.
	(BC_R(color)) : DOH!  they use bgr no rgb.
	(BC_R(areaformat)) : handle none, and start work on pattern map.
	(BC_R(begin)) : make prettier with newline.
	(BC_R(dataformat)) : don't create the style here.  Do it on demand in
	  {area,line,marker}format.
	(BC_R(frame)) : notice the difference between a chart and a grid.
	(BC_R(markerformat)) : create the styles on demand.
	(conditional_set_double) : prep for importing manual axis bounds.
	(BC_R(valuerange)) : ditto.  Still need a static GOData.
	(BC_R(end)) : hook the series and plot default styles in.
	  Enable styles for charts and grids.

2003-09-23  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(lineformat)) : fix import of axis line styles.

2003-09-13  Nick Lamb <njl195@zepler.org.uk>

	* ms-excel-read.c (excel_sheet_new) : typo fix
	(excel_read_FORMAT) : Early BIFF uses smaller datatypes
	(excel_read_FONT) : Implement for early BIFF
	(excel_get_xf) : More early BIFF hacks
	(excel_read_XF_OLD) : New function, read OLD XF structures
	(excel_workbook_add_XF) : Obsoleted, removed
	(excel_formula_shared) : Early BIFF uses smaller datatypes
	(excel_workbook_reset_style) : New function, needed for XLW files
	(excel_read_EXTERNNAME) : typo fix, Early BIFF fixes
	(excel_read_NAME) : Early BIFF uses smaller datatypes
	(excel_read_sheet) : Style is per-sheet in XLW files, what default?
	 Use excel_read_XF_OLD instead of excel_workbook_add_XF
	(excel_read_BOF) : Stop using excel_workbook_add_XF,
	 report XL4 workbooks to stderr just like all other file types

	* ms-formula-read.c (excel_parse_formula) :
	 Handle PTG_SHEET and PTG_SHEET_END, at least for known examples
	 Also early BIFF as usual has smaller datatypes

2003-09-21  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : disable debug spew.

2003-09-21  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (xl_map_char_to_type) : new util.
	(xl_get_op_class) : wrapper to help calculate the result class.
	(write_cellref_v7) : handle operand classes.
	(write_cellref_v8) : handle operand classes.
	(excel_formula_write_CELLREF) : ditto and operator mapping.
	(excel_formula_write_AREA) : ditto.
	(write_funcall) : ditto.
	(excel_formula_write_NAME_v8) : ditto.
	(excel_formula_write_NAME_v7) : ditto.
	(write_node) : ditto.
	(excel_write_formula) : collect more information on the calling context

2003-09-18  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (excel_write_MS_O_DRAWING_GROUP) : Add UserDefined to
	  silence some warnings.

2003-09-16  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c : push all the 'shared' arguments into the
	  PolishData that we're passing around anyway.

	* ms-formula-write.c (excel_write_prep_expr) : register functions that
	  exist only in arrays too.

	* ms-excel-util.c (init_xl_font_widths) : add Albany

2003-09-15  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_read_chart) : patch leak.

2003-09-15  Jody Goldberg <jody@gnome.org>

	* Release 1.2.0

2003-09-15  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(legend)) : handle the legend's position.

	* ms-excel-util.c : "Arial Cyr" in addition to "Arial CYR"

2003-09-14  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(pie)) : don't confuse center diameter with
	  separation, use it to distinguish between pie and ring.
	(BC_R(pieformat)) : handle separation here.

2003-09-13  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(tick)) : enable.  Looks like axis label enabling
	  should be here.  Wonder what that flag in lineformat is for ??

2003-09-13  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(lineformat)) : disable axis label setting for now
	  it seems over zealous.

2003-09-13  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(color)) : disable debug spew.
	(BC_R(lineformat)) : impl.
	(BC_R(markerformat)) : impl.

2003-09-10  Jody Goldberg <jody@gnome.org>

	* Release 1.1.90

2003-09-03  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : 128pt does not seem like a
	  good yard stick for Courier, Use 64, and scale it.
	Arial Narrow is even worse, size it based on 32pt

2003-08-22  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_BOF) : fix the warning.  We need the
	  stream pos at the _start_ of the sheet.

2003-08-21  Jody Goldberg <jody@gnome.org>

	* Release 1.1.20

2003-08-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_BOF) : finding a sheet not listed in the
	  right place is a warning not a failure.

	* ms-excel-write.c (excel_write_DV) : handle missing titles and msgs

2003-08-09  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(areaformat)) : use the new GogStyle extensions.

2003-07-31  Andreas J. Guelzow <aguelzow@taliesin.ca>

	* ms-excel-read.c (excel_workbook_destroy): remove last argument
	  in workbook_sheet_reorder

2003-08-01  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : add a bunch of arial
	  encodings.

2003-07-31  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(line)) : connect to the new line plot.
	(BC_R(area)) : connect to the new area plot.

2003-07-28  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (make_function) : dup the name because plugins get
	  removed before symbols do and we would crash referencing a static
	  string from the plugin.
	(PHONETIC) : appears to have 1 arg (optional ?)

2003-07-24  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_pre_biff8_query_set_decrypt) : new placeholder.
	(ms_biff_query_set_decrypt) : take a version so that we can correctly
	  recognize encrypted files for versions before biff8.

2003-07-19  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : Parse scollbars and spinners

	* ms-excel-read.c (ms_sheet_realize_obj) : apparently spinners use
	  scrollbar records.  Pass the current value too.

	* ms-excel-write.c (excel_write_SST) : simplify a bit to avoid a
	potential corner case that would generate an empty CONTINUE.

2003-07-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_SST) : handle strings > 8224 bytes.
	(excel_sheet_write_block) : improve warning message and fallback to
	  the default style when there is a problem.

2003-07-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : add Bitstream Vera, and its
	  alias 'Sans'

	* ms-formula-read.c (parse_list_push) : be more
	  resilient in the face of missing args.

2003-07-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_biff_get_chars) : make public.
	* ms-obj.c (ms_read_TXO) : use ms_biff_get_chars.

2003-07-16  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_read_OBJ) : always register the object.

	* ms-container.c : Make the obj_queue a GSList.
	(ms_container_get_obj) : new.
	(ms_container_realize_objs) : only realize MSObjs that have gnumeric
	  objects.

	* ms-escher.c (ms_escher_header_init) : init new 'release_attrs' flag
	  to allow us to pass management of an attr bag to an object, but still
	  retain access to it.
	 (ms_escher_header_release) : honour the flag.
	 (ms_escher_read_ClientData) : set the flag.

	* ms-excel-read.c (excel_read_NOTE) : Discover an undocumented flag.
	  0x100 == no indicator visible
	  While we're here store the author, and the inidcator position.
	(excel_read_HLINK) : frames are 0x80 not 0x8
	(ms_sheet_realize_obj) : cheat to handle cell comments.  In xl97 and
	  up the comment objects store the possition of the display box, not the
	  position of the indicator.  We need a better comment object.
	(ms_sheet_realize_obj) : Store the text for text boxes too.
	(ms_sheet_create_obj) : no need to set a blank text, we assign it later.
	(ms_sheet_create_obj) : create comments.

2003-07-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_palette_get) : fix error message.

2003-07-02  Andreas J. Guelzow <aguelzow@taliesin.ca>

	* ems-excel-write.c (xcel_sheet_new): add some spaces in strings

2003-06-21  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(chartformat)) : vary_style_by_element is now in plot
	* ms-excel-write.c : Start work on escher wrapper for exporting charts
	  in XL97.  NOT ENABLED OR FINISHED.

2003-06-11  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_sheet_new) : Capitalize and mark Excel as a
	   trademark.

2003-06-11  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (ms_excel_read_chart) : handle NULL sogs.  That currently
	  indicates an attempt to read a chart in its own notebook tab.

2003-06-07  Jody Goldberg <jody@gnome.org>

	* Release 1.1.19

2003-06-07  Jody Goldberg <jody@gnome.org>

	* Release 1.1.18

2003-05-30  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (excel_chart_series_delete) : unref the data if nothing
	  has used it.
	(BC_R(end)) : if we use the series clear the pointer.

2003-05-25  Jody Goldberg <jody@gnome.org>

	* ms-chart.c : remove xml, jump to goffice and disable anything that
	  does not obviously connect to GOG for now.  All we get are plot
	  types and series for now, no formating.

2003-05-21  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(gelframe)) : enable debugging when dumping
	  gelframes.

	* ms-escher.c (ms_escher_parse) : accept gelframes.
	(ms_escher_read_OPT) : the length _includes_ the header, don't try to
	  read that too.
	(ms_escher_read_Blip) : ditto.
	  weaken size restriction for uncompression.
	  test-xls/billeterie2000-6.xls has a blip that is larger than its
	  compressed content, dunno why.

2003-05-20  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c: Adapt to StyleColor changes.
	* ms-excel-write.c: Adapt to StyleColor changes.

2003-05-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_CF) : tone down the amoutn of debug spew.

	* ms-excel-read.c (excel_read_XCT) : work around more undocumented xls crack.
	  What the #$!@#&%!@ do negative counts mean.

2003-05-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_FORMULA) : set the alwaysCalc flag for
	  cells with dynamic depends.

2003-05-11  Jody Goldberg <jody@gnome.org>

	* Release 1.1.17

2003-04-28  Morten Welinder  <terra@gnome.org>

	* ms-excel-read.c (biff_string_get_flags): Fix 0/FALSE confusion.
	(biff_xf_data_destroy): Ditto.

2003-04-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_MERGECELLS) : handle too many merges
	  for a single biff record.
	* ms-biff.c (ms_biff_max_record_len) : new.

2003-04-09  Morten Welinder  <terra@gnome.org>

	* boot.c (excel_file_probe): Guard against gsf read error.
	(excel_file_open): Ditto.
	(excel_file_open): 

2003-03-26  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_tab_color) : no need to operate on the
	  pixel directly.  Use the rgb in the StyleColor.
	(excel_read_WINDOW2) : ditto.

2003-03-18  Jody Goldberg <jody@gnome.org>

	* boot.c : suppress warning

2003-03-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_EXTERNSHEET_v7) : work around a bug in
	  1.0.x export that quoted names in EXTERNSHEET.
        (excel_read_workbook) : recognize 1.0.x files.
	(excel_workbook_new) : init the new flag.

2003-03-07  Morten Welinder  <terra@diku.dk>

	* ms-chart.c (register_handlers): Use G_N_ELEMENTS.

	* ms-obj.c (ms_read_OBJ): Ditto.

	* ms-excel-write.c (excel_write_builtin_name): Ditto.
	(excel_write_FORMATs): Ditto.
	(map_pattern_index_to_excel): Ditto.

	* ms-excel-read.c (excel_map_pattern_index_from_excel): Ditto.

2003-03-05  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_query_next) : more Morten warnings.
	(ms_biff_query_peek_next) : ditto.

	* ms-obj.c (ms_obj_read_biff8_obj) : TRUE on error in precondition

2003-02-05  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_FORMAT) : biff8 formats have 2 byte
	  lengths, biff7 has 1 byte.

	* ms-excel-read.c (excel_read_FORMULA) : Add a quick size check.

2003-02-04  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_file_probe) : actually return the flag, and support
	  non-ole formats.

2003-01-28  Jody Goldberg <jody@gnome.org>

	* Release 1.1.16

2003-01-25  Jody Goldberg <jody@gnome.org>

	* excel-xml-read.c (xl_xml_wb) : quick framework to parse xml from
	  Office XP.  Just a descriptor for now no real work.

2003-01-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_foreach_name) : doh!

2003-01-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_sheet_new) : fix the text of the warning
	  messages.
	(excel_foreach_name) : loop over the gnumeric data structures rather
	  than the ExcelState wrappers so that we can do things before the
	  ExcelSheets are created.

	* ms-biff.c (MAX_BIFF7_RECORD_SIZE) : increase this a smidge to match
	  the actual limit and allow export to handle all 16k rows in xl95.

2003-01-06  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_state_new) : bp is not valid yet
	  take biff7 and biff8 flags directly.

2003-01-02  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_1904) : Enable 1904 support.
	* ms-excel-write.c (write_workbook) : Set 1904 flag as necessary.

2002-12-31  Jody Goldberg <jody@gnome.org>

	* Release 1.1.15

2002-12-30  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WRITEACCESS) : patch small leak, and
	  add a sanity failsafe.

2002-12-29  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_put_new) : Use the canonical name that is
	  available in glibc, and libiconv.

2002-12-30  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_workbook): Pass filename to
	cmd_context_get_password.

2002-12-30  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (excel_formula_shared): Return NULL on failure,
	not FALSE.

2002-12-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_state_new) : register sheets with
	  filters.  check validation exppressions for sheets.
	(excel_write_prep_validations) : new.
	(excel_sheet_new) : init validation lists here if necessary.
	(excel_write_DVAL) : not here.

2002-12-24  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_NAME) : arrrggghh MS kills me.

	* ms-formula-read.c (excel_parse_formula) : disabled a bit too much
	  debug info and broke the code.

2002-12-24  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_create_obj) : cut-n-paste-o in line creation
	  support font color for text boxes.
	  (excel_palette_get) : just call colour 64 black if it gets this far.
	    It only happens for shet objects and we need to do more research
	    on how to handle these.
	(excel_read_DV) : fix double free

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : be more picky about what we
	  call an arrow head.  Fix the directions for lines.  Find the
	  undocumented flag to fix named objects.

2002-12-22  Jody Goldberg <jody@gnome.org>

	* Release 1.1.14

2002-12-22  Jody Goldberg <jody@gnome.org>

	* Release 1.1.13

2002-12-21  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (excel_write_MS_O_DRAWING_GROUP) : new.
	* ms-excel-write.c (excel_write_AUTOFILTERINFO) : write the biff8
	  combos.  Thats it we're done.

2002-12-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_AUTOFILTERINFO) : write the fields
	  to handle the last 1/4 of the puzzle.  The only thing missing now is
	  exporting the combos for biff8.
	(excel_write_DOPER) : new.

2002-12-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_AUTOFILTERINFO) : new.
	(write_sheet_head) : use it here to export the 1st 1/4 of autofilters.
	(excel_write_NAME) : support hidden names.
	(excel_write_autofilter_names) : create pretend names for the 1st
	 filter in each sheet.
	(write_workbook) : use excel_write_autofilter_names to generate the
	  next 1/4 of autofilters.
	(excel_write_autofilter_objs) : generate simple biff7 style objects
	  for the filter combos.
	(excel_write_sheet) : Use excel_write_autofilter_objs for the next 1/4.

2002-12-17  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (excel_write_prep_expr) : make it public.
	(excel_write_prep_expressions) : just do the initialization not the
	  dep walking.
	(excel_formula_write_NAME_v8) : new.
	(write_node) : handle names for biff8.

	* ms-excel-write.c (excel_write_BOF) : no need to clone XL2k bug that
	  erroneously calls XL95 XL97.
	(excel_write_externsheets_v7) : we also export the selfref magic.
	(excel_write_NAME) : renamed from excel_write_NAME_v7 and extended to
	  support biff8.
	(write_workbook) : export names for BIFF8 too.
	(cb_check_names) : new.
	(excel_write_state_new) : prep the expressions in names too.

2002-12-16  Morten Welinder  <terra@diku.dk>

	* ms-excel-write.c (excel_write_map_errcode): Base on
	value_error_classify.

2002-12-16  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (biff_get_error): Rename from
	biff_get_error_text and return a full error instead.  Add evalpos
	argument.  All callers changed.

2002-12-15  Jody Goldberg <jody@gnome.org>

	* ms-container.c (ms_container_finalize) : cull out unused
	  placeholders.

2002-12-13  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c : Tack on a 'shared' flag in alot of places to
	control the use of _REF/_AREA vs _REFN/_AREAN

	* ms-excel-write.c (excel_write_BOF) : bump generated BOF to look like
	  MS excel 2k.
	(vip_hash) : new.
	(vip_equal) : new.
	(excel_write_DV) : new.
	(excel_write_DVAL) : new.
	(excel_write_NAME_v7) : export names using shared formula conventions.
	(excel_write_sheet) : export validation.
	(write_workbook) :  add a XL9FILE flag.

	* ms-excel-read.c (excel_read_DV) : several small tweaks
	  1) string lengths are 2 bytes
	  2) Use the option flags to enable/disable input msg and validation
	  3) Parse expressions relative to the top left of the first range
	  4) Parse as shared expressions

2002-12-13  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (excel_read_HLINK): Fix typo.

2002-12-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_prepare_autofilter) : don't fully register
	  the magic filter name.

2002-12-06  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_AUTOFILTER) : don't forget the unicode
	  header for biff8.

2002-12-03  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (excel_print_unit_init_inch): Convert to
	GnomePrintUnit.
	(excel_init_margins): Ditto.
	(excel_read_SETUP): Ditto.
	* ms-excel-write.c (excel_write_margin): Ditto.
	(excel_write_SETUP): Ditto.

2002-11-30  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_AUTOFILTER) : finish.
	(read_DOPER) : finish.

2002-11-29  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WINDOW1) : make view const
	(excel_write_state_new) : ditto.

	* ms-excel-read.c (excel_prepare_autofilter) : new.
	(excel_read_NAME) : handle autofilters.

	* ms-escher.c (ms_escher_read_ClientTextbox) : store the text.

	* plugins/excel/boot.c (excel_save) : make the view const not the
	  output.
	(excel_dsf_file_save) : ditto.
	(excel_biff8_file_save) : ditto.
	(excel_biff7_file_save) : ditto.

2002-11-26  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_create_obj) : use the new label setting
	  utilities.

2002-11-28  Jon K Hellan  <hellan@acm.org>

	* boot.c (excel_save, excel_dsf_file_save, excel_biff8_file_save)
	(excel_biff7_file_save): Receive gsf output stream from higher
	layer rather than creating and closing it here.

2002-11-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_set_xf) : remove bogus optimization.
	(excel_set_xf_segment) : ditto.  We can not assume that the default is
	  the current format.  See 'Tax2001-23.xls'

2002-11-24  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_formula_parses_ref_sheets) : fix typo.
	  check the source not the destination.

2002-11-24  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : add some fun.

2002-11-20  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (excel_formula_write_NAME_v7) : support qualified
	  names.

	* ms-excel-read.c (excel_read_EXTERNSHEET_v7) : fix handling of the
	  sheet local names.

	* boot.c (excel_file_open) : Try the output even more and assign the
	  savers as level AUTO.
	* plugin.xml.in : ditto.

2002-11-17  Jody Goldberg <jody@gnome.org>

	* biff-types.h : s/SXVX/SXVS/ ancient typo

2002-11-15  Jody Goldberg <jody@gnome.org>

	* Release 1.1.12

2002-11-15  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c : tidy up sheet hanlding in references.

	* ms-excel-write.c (excel_write_NAME_v7) : new.
	(excel_foreach_name) : ditto.
	(write_workbook) : produce names for biff7 including sheet local and
	  placeholders.

2002-11-14  Jon K Hellan  <hellan@acm.org>

	* plugin.xml.in: Remove "open" and "import" attributes.

2002-11-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_comments_biff7) : fix. #$^! libxml had
	  poluted the global name space with function 'comment' which I
	  accidentally used as a variable name without defining it.

2002-11-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_sheet_write_block) : speedup empty rows.
	  And use the undocumented optimized form for the DBCELL (#rows == 0)
          when dealing with sparse regions.
	(excel_write_ROWINFO) : ignore empty rows.

2002-11-13  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : fix typo that broke 3d
	  references.

	* ms-formula-write.c (sheet_pair_add_if_unknown) : new.
	(excel_write_prep_expr) : use it for refs and regions.

	* ms-excel-write.c (excel_write_state_free) : release the function and
	  sheet pair tables.
	(excel_write_SCL) : new. Clean up and support zoom > 100
	(cb_write_sheet_pairs) : new.
	(excel_write_externsheets_v8) : generate sheet pairs for the
	  externsheet.  Still no support for external links.
	(excel_write_get_externsheet_idx) : implement.

2002-11-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c : Don't use StyleFont.  In the case where a font
	  does not exist on the display system it does the wrong thing.
	  MStyle can contain an invalid font.  StyleFont gets remapped to the
	  default.

2002-11-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (palette_get_index) : add a warning if we are going
	  to lose a colour.
	(gather_palette) : improve debug.

	* ms-excel-util.c (two_way_table_move) : rename from
	  two_way_table_replace and fix.

2002-11-11  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_cellref_v7) : fix signature.
	(write_cellref_v8) : ditto.
	(write_ref) : fix biff8 case.

	* ms-excel-write.c (gather_styles) : we already gathered the most
	  common styles earlier.
	(excel_sheet_new) : most common style in a column does not extend the
	  column.

	* ms-biff.c (ms_biff_put_len_next) : handle correct max biff record
	  sizes for biff7 vs biff8.  Looks like they teaked things so that the
	  dbcell records will always fit in 1 biff record.
	(ms_biff_put_len_commit) : ditto.

2002-11-10  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_put_new) : take a codepage as an argument.
	* ms-excel-write.c (excel_write_v7) : pass in the code page we stored
	  on import.
	(excel_write_v8) : ignore the codepage. biff8 uses unicode.

	* ms-excel-read.c (excel_read_workbook) : store the codepage we
	  imported with.

2002-11-10  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_arrays) : rewrite.

2002-11-10  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_string) : Use excel_write_string.
	(write_arrays) : Use it here, but this code is suspect.

	* ms-excel-write.c (excel_write_string_len) : new routine to find char
	  and byte lengths of strings.
	(current_workbook_iconv) : delete.
	(biff_convert_text) : delete.
	(biff_put_text) : delete.
	(excel_write_string) : new replacement for biff_put_text that does the
	  conversion and writting inline rather than from a buffer, has
	  smarter unicode handling and a more useful set of flags.
	(excel_write_externsheets_v7) : Use it here.
	(excel_write_externsheets_v8) : Use it here.
	(excel_write_NAME_v7) : Use it here.
	(excel_write_BOUNDSHEET) : Use it here.
	(excel_write_FONT) : Use it here.
	(excel_write_FORMAT) : Use it here.
	(excel_write_value) : Use it here.
	(excel_write_FORMULA) : Use it here.
	(excel_write_comments_biff7) : Use it here.
	(excel_write_SST) : Handle the unicode caes.
	(excel_write_WRITEACCESS) : new to handle biff7 vs biff8
	(excel_utf8_has_multibyte) : delete.
	(write_workbook) : Use excel_write_WRITEACCESS and clean up the
	  codepage handling to conform to
	  biff7 == single byte vs biff8 == unicode.

	* ms-excel-biff.h (EX_SETSTRLEN) : delete.

	* ms-biff.c (ms_biff_put_new) : Add a buffer and iconv handler to
	  simplify string handling.  excel95 gets locale specific handler.
	  excel97 and up goes to utf16-le.
	(ms_biff_put_destroy) : cleanup.

2002-11-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_state_new) : merge biff7 and biff8
	  versions.
	(excel_write_externsheets_v8) : basic initial implementation handles
	  externnames.

	* ms-excel-read.c (excel_read_workbook) : add a flag to indicate dual
	  stream file.

	* boot.c (excel_file_open) : set the saver reasonably intellifently.
	(excel_save) : support dual stream files.
	(excel_dsf_file_save) : new.
	* plugin.xml.in : enable dual stream files

2002-11-05  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : enable excel97

	* ms-excel-write.c (excel_write_value) : use BIFF8 SST records.
	(excel_write_state_free) : clean up SST here.
	(excel_write_state_new) : shared routine for biff7 and biff8.
	(excel_utf8_has_multibyte) : quicky utility.
	(excel_write_SST) : initial basic implementation still needs unicode
	  support.
	(excel_write_BOF) : renamed from biff_bof_write and sync versions with
	  XL 2k.

2002-11-04  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_save) : prep for biff8 save, and double stream files.

	* ms-excel-read.c (excel_read_XF) : fix rotation.
	(excel_read_SST) : improve debug info.

	* ms-excel-write.c (write_xf_record) : write the BIFF8 support.
	(rotation_to_excel) : new.

2002-11-04  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-biff.c, ms-escher.c, ms-excel-read.c, ms-excel-write.c,
	  ms-formula-write.c, ms-obj.c: Included headers for some standard
	  library functions.

2002-11-04  Nick Lamb <njl98r@ecs.soton.ac.uk>

	* biff-types.h: Add BIFF_INTEGER
	* ms-excel-read.c: More non-OLE Excel file support.

2002-11-02  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-obj.h: Added declaration of ms_obj_new .

2002-11-01  Jody Goldberg <jody@gnome.org>

	* Release 1.1.11

2002-10-31  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : adjust the name and
	  externname handling.

	* ms-excel-read.c (excel_workbook_new) : make supbook an array rather
	  than a ptr array.
	(excel_workbook_destroy) : cleanup the new data structures.
	(excel_read_EXTERNNAME) : revamp handling for biff8 to store in a
	  distinct structure from the NAMEs, and associate that with the
	  SUPBOOK even though the docs claim otherwise.  I suspect the docs
	  were written for Biff7 and not updated.  This is the only thing that
	  makes sense based on the record ordering.
	(excel_read_NAME) : merge in the ms_container_add_name code.
	(excel_externsheet_v8) : simplify the interface and return the structure
	(supbook_get_sheet) : adjust to the new data structures.
	(excel_read_SUPBOOK) : be more expressive.  We're ready to handle
	  externals now.  Just need to write a parser for the links.

	* ms-container.c (ms_container_get_name) : No sense having it here.
	  The code is specific to the PTG handler.  move it there.
	(ms_container_add_name) : also more specific to the NAME and
	  EXTERNNAME handlers.  Move it there.

2002-10-30  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_NAME) : handle unicode names.

2002-10-28  Morten Welinder  <terra@diku.dk>

	* ms-escher.c (ms_escher_read_ClientTextbox): Don't leak text even
	though we haven't implemented the feature.  (I'm tired of hunting
	this leak down.)

2002-10-28  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_WINDOW2) : go back to selecting the
	  current sheet.
	(excel_write_WINDOW1) : store the currently selected sheet here too.

	* ms-excel-read.c (excel_read_EXTERNSHEET_v7) : kludge around screw up
	  in opencalc exporter.

2002-10-27  Nick Lamb <njl98r@ecs.soton.ac.uk>

	* ms-excel-read.c: Factor out some code into new functions, more
	  support for non-OLE Excel files, especially formulae.

2002-10-27  Jody Goldberg <jody@gnome.org>

	* Release 1.1.10

2002-10-26  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c : Start rationalizing things.
	* ms-formula-write.c : ditto.  Lots of adjustments.
	- start handling biff7 externsheets correctly
	- fix handling of non builtin functions

	* ms-excel-read.c (excel_add_name) : delete.
	(excel_workbook_get_name) : ditto.

	* ms-formula-read.c : Hopefully the last major tweak to names and
	  externsheets for biff7.  This now loads all test cases smoothly.
	  It seems that biff7 stores per bof sets of externsheets.

	* ms-container.c (ms_container_init) : Add a version and a workbook
	  pointer.  Init the new biff7 extern handling data structures.
	(ms_container_finalize) : and release them here.
	(ms_container_get_name) : new to handle biff7 or biff8 magic.
	(ms_container_add_name) : ditto.

	* ms-chart.c (BC_R(ai)) : parse the expression as ourselves, not the
	  container.
	(chart_parse_expr) : implement.
	(ms_excel_chart) : handle EXTERNSHEET and EXTERNCOUNT for biff7 style
	  storage with per BOF EXTERN*.

	* ms-biff.c (ms_biff_put_destroy) : take responsibility for the output
	  stream.

	* boot.c (excel_save) : check that we can open the output file before
	  we bother collecting things for export.

2002-10-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_read_XF) : init shrink to fit in the non
	  biff8 case.

2002-10-24  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (excel_parse_name) : patch leak.

2002-10-25  Morten Welinder  <terra@diku.dk>

	* ms-biff.c (skip_bytes): Make scratch buffer static to ensure
	it's initialised.  Add assert, just in case.

2002-10-24  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (excel_read_XCT): Fix typo, I think.

2002-10-21  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (excel_parse_formula) : Ok. take a 2nd crack at
	  the externsheet handling in area3d and ref3d for biff7.  It seems
	  like XL2k generates different indicies when exporting as XL95 than
	  XL95 did.  So have a fall back.  If the theory that
	    a+1 == -ixals, a, b are 0 based
	  fails.  Go back to 
	    a   == ixals, and a, b are 1 based

2002-10-21  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : improve readability of
	  debug spew and send thing to stderr.
	Fix handling of extern names and refrences.  This time I think we've
	finally got it.

2002-10-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c : tidy up naming conventions
	    excel_read_<BIFFTAG>
	  - Use fprintf to keep g_warning and printfs in sync
	  - Use esheet for ExcelSheets and ewb for ExcelWorkbooks
	  - Use Sheet and wb for the gnumeric variants
	(ms_excel_sheet_new) : check to see if the sheet already exists
	  in case it was implicitly created in a SUPBOOK or EXTERNSHEET.
	  This will be useful when we start restoring external links shortly.
	(ms_excel_workbook_attach) : delete.
	(ms_excel_workbook_detach) : delete.
	(ms_excel_sheet_destroy) : clear out the sheet local extensheet
	  records for biff5.
	(excel_read_BOUNDSHEET) : use ms_excel_sheet_new.
	(excel_externsheet_v8) : rewrite to handle self ref.  Only partially
	  done.
	(supbook_get_sheet) : ditto.
	(excel_read_EXTERNSHEET_v8) : ditto.
	(excel_externsheet_v7) : fix to use local externsheets.
	(excel_read_EXTERNSHEET_v7) : rewrite and prep for external
	  references.
	(excel_workbook_get_name) : work around 'self ref' records for biff8.
	(excel_parse_name) : work on scoping.  works for biff7 not biff8.
	(ms_excel_handle_delayed_NAMEs) : delete.  the externsheet records are
	  enough.
	(excel_read_EXTERNNAME) : builtin names are just short forms for
	  names, they have special meanings to XL but no special behavior.
	(excel_read_NAME) : ditto.  Use the new externsheet setup and drop all
	  of the delayed parsing goo.
	(excel_read_XCT) : new.  prep for external references.
	(excel_read_CALCMODE) : new.  now that we support manual recalc.

2002-10-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_parse_NAME) : It looks like some
	  builtinnames are just names, no definitions. eg 'Database'
	  It also looks like these sheet_indexes apply to externsheet records
	  for <= biff7 (see pivot.xls) rather than boundsheets.

2002-10-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_pane) : the sizes are only valid if
	  there is a freeze in that direction.

	* ms-excel-read.c (ms_excel_read_dv) : Fix handling of empty strings
	  and improve validation.  NOTE : This is likely to come up again.
	  We need to know when there is always a 1 byte header, and when there
	  isn't in biff_get_text.

2002-10-09  Morten Welinder  <welinder@rentec.com>

	* ms-obj.h (struct _MSObj): Avoid "gboolean ... : 1".
	* ms-excel-read.h (struct _ExcelSheet): Avoid "gboolean ... : 1".

2002-10-10  Nick Lamb <njl98r@ecs.soton.ac.uk>

	* plugin.xml.in: Excel 4.x had .XLW workbooks as well as .XLS
	* boot.c: Try to load non-OLE files too

2002-10-09  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_workbook_destroy): Don't leak
	->supbooks.

2002-10-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (write_names) : Fix leak by not inserting copies of
	  of the name string.
	  1) no need to copy
	  2) no need to do a string compare

2002-10-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_workbook) : handle workbook protected
	  files (thanks jpablo).

2002-10-04  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_parse_NAME) : ahhh, I understand now.
	  names with expr_len == 0 represent the placeholders used for unknown
	  names.

2002-10-02  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (BC_R) : handle empty text.

	* boot.c : simplify now that IOContext inherits from CommandContext
	  Move the metadata export here for symetry with the import.

2002-09-30  Jody Goldberg <jody@gnome.org>

	* plugin.xml.in : disable 97 until it is ready for widespread use

2002-09-30  Jody Goldberg <jody@gnome.org>

	* Release 1.1.9

2002-09-30  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_file_open) : typo

2002-09-27  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_save) : restore macros.

	* boot.c (excel_file_open) : handle confused files that misname the
	  streams.  Store macros if they exist.

2002-09-26  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : fix handling of 26 & 27. 
	  The docs are confusing.  The cached data is appended not to the the
	  subexpression but to the entire string.  While we're here add a stub
	  for tables.

2002-09-26  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : supply handling of
	  pgts 26 & 27.  We can ignore them but they frequently wrap the
	  intersection operator, the export will be a pain in the butt.

2002-09-25  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (binary_ops) : enable intersection
	  still needs work.
	* ms-formula-write.c (ms_formula_build_pre_data) : ditt.
	(write_node) : ditto.

2002-09-15  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (const) : DateDif takes 3 arguments.

2002-09-10  Morten Welinder  <terra@diku.dk>

	* ms-escher.c: Make shade_ParamMask be within int's range by
	casting it.
	* ms-escher.c: Avoid trailing commas in enums.

2002-09-05  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (ms_formula_write_pre_data) : remove some obvious
	  silliness

2002-09-04  Jody Goldberg <jody@gnome.org>

	* *.c : remove ifdef WITH_BONOBOization of graphs

2002-08-30  Jody Goldberg <jody@gnome.org>

	* boot.c (excel_read_metadata) : new.
	(excel_file_open) : read the doc and summary meta info streams.
	  Don't do anything with the data yet, but start the ball rolling.

2002-08-30  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_read_formula): Avoid copying of
	string.
	(ms_excel_parse_formula): Ditto.

2002-08-29  Morten Welinder  <terra@diku.dk>

	* ms-excel-util.c (two_way_table_new): Take an extra arg for
	getting rid of keys.  All callers changed.

	* ms-excel-write.c (formats_init): Supply an unreffer to
	two_way_table_new.

2002-08-29  Morten Welinder  <terra@diku.dk>

	* ms-excel-write.c (free_workbook): Plug leaks.

2002-08-28  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_workbook) :
	  excel_iconv_open_for_import moved to libgsf.

2002-08-28  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_workbook) : gnm_iconv_close moved to
	  libgsf.
	* ms-excel-write.c (write_workbook) : ditto.
	* ms-summary.c (ms_summary_read) : ditto.
	(ms_summary_write) : ditto.

2002-08-25  Jody Goldberg <jody@gnome.org>

	* Release 1.1.8

2002-08-25  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (excel_write_externsheets) : store the unquoted
	  name.
	(excel_write_SELECTION) : swap args to be consistent.
	  Store current pane == 3 rather than 0 to silence the warning when
	  loading our sheets in MS Excel.
	(ms_excel_write_workbook) : add some dummy metadata streams.

2002-08-21  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_new) : add a convenience routine to be safe.
	(ms_read_OBJ) : Use it here.

2002-08-19  Jon K Hellan  <hellan@acm.org>

	* ms-biff.c (ms_biff_query_peek_next, ms_biff_put_var_seekto,
	ms_biff_put_var_commit, ms_biff_put_len_commit): Use glib's seek
	enum instead of the enum which used to be in libgsf.

	* ms-excel-write.c (biff_boundsheet_write_last, write_index): Ditto.

2002-08-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (excel_iconv_open_for_import) : fix unicode codepage
	  to be actual unicode with the high bit lopped off, which I hope is
	  synonymous with 8859-1.  This still needs to be translated into
	  UTF-8.

2002-08-17  Jon K Hellan  <hellan@acm.org>

	* ms-chart.c (BC_R): Fix typos.

2002-08-17  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (get_locale_charset_name) : delete.
	(excel_iconv_open_for_import) : realize that 1200 and 1201 are both
	  unicode and that we only want to convert to UTF-8.
	(excel_wcstombs) : die die die.  We may need this again one day when
	  exporting UTF-8 back to xl 95.  But we'll cross that bridge when we
	  come to it.

	* ms-excel-read.c (get_chars) : internally text should always be UTF-8.
	(ms_excel_read_workbook) : fix the warning.
	  I've found some references for the code pages.

2002-08-16  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_read_SUPBOOK): Shut up warning.

2002-08-15  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (biff_boundsheet_write_last, write_index):
	Change type of oldpos variable to gsf_off_t.

2002-08-13  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : support colours for polygons.

	* ms-excel-read.c (ms_sheet_create_obj) : Add support for polygon
	  colours.
	(ms_sheet_obj_anchor_to_pos) : hmm, our supposition that >= 97 ==
	  1/256 and < 97 == 1024 seems wrong in the face of chap03-1.

2002-08-12  Jody Goldberg <jody@gnome.org>

	* Release 1.1.7

2002-08-12  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_object_attr_new_array) : new.
	(ms_object_attr_get_expr) : ditto.
	(ms_object_attr_destroy) : support arrays.
	(ms_obj_read_pre_biff8_obj) : Parse the coord list for polygons.

	* ms-excel-read.c (ms_excel_read_SUPBOOK) : do a touch more.
	Still need to write the encoded path parser.

	* ms-excel-read.c (ms_excel_read_cf) : don't leak.

2002-08-11  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : add bounds testing to
	  reading const strings.  It will save us from corrupt data, and
	  rescue us from the misexported xls in 1.0.6,1.0.7

	* ms-excel-read.c (biff_xf_data_new) : read shrink to fit.
	(ms_excel_parse_NAME) : Ignore 0 length expressions.

	* ms-formula-read.c (expr_tree_error) : new.
	(parse_list_pop) : use it more loudly here.
	(ms_excel_parse_formula) : and here.

2002-08-09  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_workbook) : silence the warnings
	  caused by reading the padding at the end of files.

2002-08-08  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : improve handling of
	  arrays.

	* ms-excel-read.c (biff_boundsheet_data_new) : improve debug spew.
	(sst_read_string) : no need to pass version an sst is biff8 specific.
	(ms_excel_read_SST) : ditto.
	(ms_excel_read_EXSST) : new convience routine.
	(biff_boundsheet_data_new) : move boundsheet_data_by_index into a ptr
	  array, and store the gnumeric sheets directly.
	(ms_excel_workbook_new) : use g_hash_table_new_full to make cleanup
	  easier.
	(ms_excel_workbook_destroy) : simplify.
	(ms_excel_read_SETUP) : support the 'print comments' flag
	(ms_excel_read_MULRK) : split into its own function.
	(ms_excel_read_MULBLANK) : ditto.
	(ms_excel_read_SCL) : ditto
	(ms_excel_read_sheet) : spew the sheet password in case we need to
	  generate it.
	(ms_excel_SUPBOOK) : I finally understand the self reference magic.
	  More work to do to support external links.
	(ms_excel_workbook_get_externsheet_v8) : improve the warnings on error.
	(ms_excel_externsheet_v8) : those sheet indicies are BOUNDSHEET
	  references if the supbook is a self reference.  We cannot directly
	  access the Gnumeric sheets because XL has hidden elements that skew
	  the index.
	(ms_excel_workbook_get_externsheet_v7) : ditto.
	(ms_excel_externsheet_v7) : store the sheet directly.

	* ms-excel-write.c (write_magic_interface) : biff8 stores the code
	  page in the interface header for some reason.
	(ms_excel_write_EOF) : rename from biff_write_eof.
	(excel_write_SETUP) : new.
	(write_wsbool) : remove duplicate code.
	(excel_write_COUNTRY) : new.
	(write_sheet_head) : tidy.
	(excel_write_sheet_tail) : SCL is not version specific.
	(sst_collect_str) : new.
	(ms_excel_write_SST) : prepare to write an SST (not finished)

2002-08-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (init_base_char_width_for_write) : delete.
	(style_get_char_width) : renamed from get_base_char_width as it is now
	  just a wrapper around the 
	(ms_excel_write_DEFCOLWIDTH) : renamed from write_default_col_width
	  and use the right font in the width calculations.
	(ms_excel_write_COLINFO) : renamed from write_colinfo and use the
	  right font in the width calculations.

2002-08-06  Morten Welinder  <terra@diku.dk>

	* *.c: use gsf_le_get_double and gsf_le_set_double.

2002-08-05  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_put_var_write) : const.

	* ms-excel-write.c (write_magic_interface) : Use the symbolic names.
	(biff_put_text) : no need to write 8byte text 1 byte at a time.

2002-08-06  Morten Welinder  <terra@diku.dk>

	* md5.h (UINT4): Portability fix.

	* rc4.h: Guard.
	* md5.h: Guard.
	* biff-types.h: Guard.
	* escher-types.h: Guard.
	* formula-types.h: Guard.

2002-08-04  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : remove bogisity about
	  'Magic Addin Name'

2002-07-22  Zbigniew Chyla  <cyba@gnome.pl>

	* plugin.xml.in: Set loader type to "Gnumeric_Builtin:module".

2002-08-01  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (biff_put_text) : set the unicode flag on the
	  string header for unicode strings.  This routine needs to be cleaned
	  up to handle UTF-8 -> UTF-16 if necessary.
	(biff_boundsheet_write_first) : tidy and make the name len 1 byte.
	(gather_palette) : convert to new two way table convention.
	(gather_fonts) : ditto.
	(gather_formats) : ditto.
	(xf_free) : ditto.
	(after_put_mstyle) : ditto.
	(put_mstyle) : simplify.
	(xf_init) : delete.
	(cell_used_map_new) : delete.
	(cell_mark_used ) : delete.
	(cell_is_used) : delete.
	(excel_cell_get) : delete.
	(pre_cell) : delete.
	(pre_blank) : delete.
	(pre_blanks) : delete.
	(pre_colstyle) : delete.
	(gather_styles) : greatly simplify by using the knowledge that there
	  is a per sheet hash of the styles in use.
	(cb_accum_styles) : new.
	(write_cell) : Use the gnumeric data structures directly.
	(write_block) : ditto.
	(ms_excel_write_wsbool) : new.
	(write_sheet_head) : use ms_excel_write_wsbool.
	(excel_sheet_new) : no more need for large cell map.
	(excel_sheet_free) : ditto.

	* ms-excel-util.c (two_way_table_new) : Allow for ptr tp ptr
	  comparisons as an optimization.
	(two_way_table_free) : ditto.
	(two_way_table_put) : ditto.
	(two_way_table_replace) : ditto.
	(two_way_table_key_to_idx) : ditto.

	* boot.c (excel_save) : bah!  I forgot to commit this.  export is
	  broken without it.

2002-07-21  Jody Goldberg <jody@gnome.org>

	* Release 1.1.6

2002-07-19  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_hlink) : improve bounds checking.

2002-07-19  Jody Goldberg <jody@gnome.org>

	* plugins/excel/ms-excel-read.c (ms_excel_read_hlink) : tidy up and
	  support custom tool tips.

2002-07-18  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_imdata) : only read the amount of
	  data in the imrecord.  not all continues add infinitum.  Fixes
	  guia.xls.

	* ms-obj.c (ms_read_TXO) : don't expect continue records if there is
	  no text.  Fixes guia2.xls.

2002-07-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_sheet) : reorder 0x1xx entries to be
	  in increasing order and support hlinks.
	(ms_excel_read_hlink) : new.

2002-07-14  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : move the
	  initialization of the prop bag from here.
	(ms_read_OBJ) : to here.  Fixes the guia2 hash warnings.

2002-07-09  Morten Welinder  <terra@diku.dk>

	* boot.c (excel_file_open): Don't leak the stream.

2002-06-27  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_selection) : put the edit_pos in the
	  right place.

	* ms-excel-write.c (write_sheet_tail) : Use stern_brocot to get a
	  reasonable fraction.
	(write_sheet_selection) : split the writing of the selection out into
	  here and implement it.

2002-06-22  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (operations) : export intersection.

	* ms-formula-read.c (ms_excel_parse_formula) : enable mem_func
	  support.
	(binary_ops) : use range_ctor for RANGE.

2002-06-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_workbook_new) : store the workbookview.
	(ms_excel_read_selection) : selection is now in the view.

2002-06-06  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_workbook) : convert to gsf.
	  No need to handle the ole here.  Just take a GsfInput.  That way we
	  can try to parse non ole files too :-)

	* ms-biff.c (ms_biff_query_set_decrypt) : convert to Gsf.
	(ms_biff_query_new) : ditto.
	(ms_biff_query_peek_next) : ditto.
	(ms_biff_query_next) : ditto.

	* boot.c (excel_file_probe) : convert to GsfInput.
	(excel_file_open) : ditto.

	* biff-types.h : add a few under-documented opcodes.

2002-05-28  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_query_peek_next) : we only need the opcode, not
	  the length.

2002-05-14  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=81766
	* ms-excel-read.c (ms_excel_read_formula) : work around undocumented
	  'feature' that will store a 0 length RECORD for empty strings.

2002-05-29  Jody Goldberg <jody@gnome.org>

	* Release 1.1.4

2002-05-15  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (verify_password) : support unicode passwords.

2002-05-15  Andreas J. Guelzow <aguelzow@taliesin.ca>

	* ms-excel-read.c (ms_excel_init_margins) : margins are now in 
	  print_config 
	(ms_excel_read_setup) : ditto
	(ms_excel_read_sheet) : ditto
	* ms-excel-write.c (margin_write) : ditto
	(write_sheet_head) : use modified margin_write

2002-05-05  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_biff8_obj) : tack on a flag to handle the
	  magic associated with combos for filters.
	* ms-excel-read.c (ms_sheet_create_obj) : respect the new flag.

2002-04-29  Jody Goldberg <jody@gnome.org>

	* Release 1.1.3

2002-04-21  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_externsheet_v8) : handle references to
	  deleted sheets.

	* ms-escher.c (ms_escher_read_Blip) : remove some debug cruft.

2002-04-15  Jon K Hellan  <hellan@acm.org>

	* boot.c: s/main.h/libgnumeric.h/

	* ms-excel-write.c: Ditto.

2002-04-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_AUTOFILTER) : start work on filters.
	(ms_excel_read_sheet) : support the filter records.

2002-04-13  Jon K Hellan  <hellan@acm.org>

	* ms-chart.c: s/ENABLE_BONOBO/WITH_BONOBO/

	* ms-excel-read.c: Ditto

2002-03-27  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (ms_biff_query_set_decrypt) : protect against NULL
	  passwords.

2002-03-25  Jody Goldberg <jody@gnome.org>

	* Release 1.1.2

2002-03-26  Jody Goldberg <jody@gnome.org>

	* ms-biff.c (wvMD5StoreDigest) : new from libwv-7.1
	(makekey) : ditto.
	(verify_password) : tweaked from libwv.
	(skip_bytes) : new.
	(ms_biff_query_set_decrypt) : new.
	(ms_biff_query_new) : support encryption.
	(ms_biff_query_next) : ditto.
	(ms_biff_query_destroy) : ditto.

	* ms-excel-read.c (ms_biff_bof_data_new) : Use the un-decoded data.
	(ms_excel_read_sheet) : comment that it seems like bytes 12 & 16 are
	  not encrypted.
	(biff_boundsheet_data_new) : stream start pos seems un encrypted.

2002-03-22  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_get_style_from_xf): Be prepared for
	color 65 as pattern color.

2002-03-20  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_sheet) : 15 is the
	  default fmt for cells.  0 is the default style fmt that is its
	  parent.
	(ms_excel_set_xf) : not strictly correct.  We should apply if the col,
	  row is different.
	(ms_excel_set_xf_segment) : no need to apply if it is the default.

2002-03-18  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.h (_ExcelWorkbook): Add sharer.

	* ms-excel-read.c (ms_excel_workbook_new): Initialize sharer.
	(ms_excel_workbook_destroy): Destroy sharer.

	* ms-formula-read.c (ms_excel_parse_formula): Share resulting
	formulae.

2002-03-16  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_workbook_destroy) : we can have NULL
	  names as place holders.

2002-03-15  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_sheet_destroy) : make deleting the
	  gnum_sheet optional.

	* ms-excel-read.c (ms_excel_parse_NAME) : add a ref.
	(ms_excel_workbook_destroy) : don't leak the sheets, or the names.

2002-03-15  Andreas J. Guelzow <aguelzow@taiesin.ca>

	* ms-excel-read.c : calculate desired tab_text_color upon reading of
	  tab_color

2002-03-14  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_obj_read_pre_biff8_obj) : doh! Fix sense of result so
	  that reading works.

2002-03-11  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_externname) : Store the name for use as a
	  function.

2002-03-10  Jody Goldberg <jody@gnome.org>

	* Release 1.1.1

2002-03-08  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_workbook_new) : store an iocontext.
	  init the delayed name list for xl95.
	(ms_excel_parse_NAME) : split out of.
	(ms_excel_read_NAME) : here.
	(ms_excel_handle_delayed_NAMEs) : new.
	(ms_excel_externsheet_v8) : be quiet.
	(ms_excel_read_workbook) : check for delayed names on EOF.

2002-03-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_externsheet_v8) : don't warn for local
	  name records.
	(ms_excel_read_NAME) : typo.

2002-03-07  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c : revamp extensheet handling and name import.
	  Still does not work for XL95, but things should be ok for >= 97.
	  Getting closer to supporting external references.

2002-03-02  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (write_externsheets) : Use unquoted.  This code
	  needs some love.

2002-03-02  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_formula) : avoid leaking when faced
	  with bad input.
	(ms_excel_read_formula) : ditto.

2002-02-28  Jody Goldberg <jody@gnome.org>

	* ms-formula-write.c (write_area) : write explicitly scoped addreses
	  as area3d not area.  Use tx = 0xffff and warn that we only support
	  locale sheets.

	* ms-excel-write.c (write_bits) : better attribution and dump names.
	(write_workbook) : let write_bits handle the names.

2002-02-26  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (ms_escher_get_data) : clarify the interface.
	(ms_escher_read_BSE) : fix call to ms_escher_get_data.
	(ms_escher_read_Sp) : ditto.
	(ms_escher_read_ClientAnchor) : ditto.
	(ms_escher_read_OPT) : ditto.
	(ms_escher_read_container) : ditto.
	(ms_escher_read_Blip) : support decompress and validate emf & wmf.

	* ms-excel-util.c (excel_iconv_open_for_import) : recognize that
	cp1200 makes no sense in that context and fall back to 8859-1.

2002-02-24  Jody Goldberg <jody@gnome.org>

	http://bugzilla.gnome.org/show_bug.cgi?id=72459
	* ms-formula-write.c (write_node) : fix typo.

2002-02-26  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (biff_get_rk): Improve precision ever so
	slightly on numbers that are scaled by 0.01.

2002-02-25  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_sheet_create_image): New function. Factor
	image creation out of ms_sheet_create_obj and also handle cropping.
	(ms_sheet_create_obj): Call ms_sheet_create_image.

2002-02-23  Jon K Hellan  <hellan@acm.org>

	* plugin.xml.in: Recognize *.xlt extension.

2002-02-21  Morten Welinder  <terra@diku.dk>

	* ms-excel-write.c (init_base_char_width_for_write): Constify.
	(ms_excel_write_workbook): Constify.

	* ms-excel-read.c (get_substitute_font): Constify.
	(ms_excel_get_style_from_xf): Constify.
	(biff_boundsheet_data_new): Constify.

	* ms-summary.c (read_summary_items): Constify.

	* ms-excel-util.c (get_locale_charset_name): Constify.  Remove
	code conditioned on HAVE_ICONV && !HAVE_ICONV.

	* ms-escher.c (ms_escher_read_BSE): Constify.

2002-02-20  Morten Welinder  <terra@diku.dk>

	* ms-excel-write.c (write_value): Fix format.

	* ms-excel-read.c (ms_excel_read_name): Constify.

	* ms-formula-read.c (formula_func_data): Constify.

	* ms-excel-util.c (two_way_table_put): Constify.

2002-02-19  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_palette_get): Update documentation.
	(ms_excel_get_style_from_xf): Remove case 0.
	(biff_xf_data_new): Save difference bits. We don't use them yet,
	though. Documentation is wrong, background color is one bit more
	than documented

	* ms-excel-write.h (struct _ExcelFont): Add is_auto member.
	(PALETTE_BLACK): Change from 0 to 8.
	(PALETTE_WHITE): Change from 1 to 9.
	(PALETTE_AUTO_PATTERN, PALETTE_AUTO_BACK, PALETTE_AUTO_FONT,
	FILL_NONE, FILL_SOLID): Define

	* ms-excel-write.c (write_window2): Write grid / auto pattern
	color.
	(style_color_to_int): Rename to style_color_to_rgb888.
	(palette_put_defaults): Call index 8 'PALETTE_BLACK'. Mark both
	black and white as in use.
	(palette_get_index): Return 8 (PALETTE_BLACK) for black, and 9
	(PALETTE_WHITE) for white.
	(put_color): Call style_color_to_rgb888 with new name.
	(excel_font_new): Call style_color_to_rgb888 with new name. Save
	is_auto flag.
	(excel_font_hash): Include is_auto in hash func, and shift flags
	so they don't just cancel each other.
	(excel_font_equal): Include is_auto in comparison.
	(write_font): Store as auto color when appropriate.
	(fixup_fill_colors): Simplify and merge into build_xf_data.
	(style_color_to_pal_index): New function. Return Excel color
	index, possibly auto, for a style color.
	(get_xf_differences): We have discovered that background color is
	stored with 1 bit more than documented. Use this to improve test
	for pattern difference between XF and parent style. Locking: XL
	default is on, so we're different if locking is off.
	(build_xf_data): Store as auto color where appropriate. Use
	style_color_to_pal_index.
	(write_xf_record): Documentation is wrong - there is no fSxButton
	bit. The bg color uses the bit, making bg field 7 bits wide. Don't
	store data for borders which aren't there.

2002-02-18  Jody Goldberg <jody@gnome.org>

	* Release 1.1.0

2002-02-15  Jody Goldberg <jody@gnome.org>

	* ms-escher.c (write_file) : delete.
	(ms_escher_read_BSE) : remove the bonobo-ness from here it is none of
	  excel's business.  Just use the new SheetObjectImage.  While we're
	  at it avoid a few memory copies of the image.
	* ms-excel-read.c (ms_sheet_create_obj) : ditto.

	* ms-container.c (ms_container_get_blip) : return non-const.

2002-02-08  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_read_window2): No need to unref
	pattern_color, sheet_style_set_auto_pattern_color now does that.

2002-02-05  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (black_or_white_contrast): Burn.
	(ms_excel_palette_get): Simplify to get autocolors right. We used
	to be too clever.
	(ms_sheet_map_color): Use style_color_new_i8 to convert from
	rgb888.
	(ms_excel_read_window2): Update pattern color according to
	icvHdr/rgbHdr grid color if fDefaultHdr flag says so.

2002-02-03  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (pre_cell) : adjust to Cell::format moving into the
	  value.

2002-01-31  Jody Goldberg <jody@gnome.org>

	* ms-excel-util.c (init_xl_font_widths) : add Helv.

	* ms-excel-read.c (ms_sheet_create_obj) : GObject vs GtkObject
	* ms-obj.c (ms_obj_delete) : ditto.
	* ms-chart.c (ms_excel_read_chart) : ditto.

2002-01-30  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : give a warning when
	  dealing with references to external workbooks.

2002-01-29  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_sheet_create_obj) : move to new sheet widget
	  layout.

2002-01-23  Jody Goldberg <jody@gnome.org>

	* ms-summary.c (EXCEL_TO_GNUM_MAPPING_COUNT) : use G_N_ELEMENTS.
	(excel_to_gnumeric) : delete unused.
	(read_summary_items) : suppress warnings.
	(read_summary_items) : fix leak.

	* ms-excel-write.c : s/StyleFont::size/StyleFont::size_pts/

	* ms-excel-util.c (g_unichar_to_utf8) : delete.

2002-01-21  Jody Goldberg <jody@gnome.org>

	* Release 1.0.3

2002-01-21  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_object_attr_get_*) : new.
	(ms_obj_read_biff8_obj) : read scrollbar attributes.

	* ms-excel-read.c (ms_sheet_realize_obj) : Add scrollbars.
	(ms_sheet_create_obj) : ditto.

2002-01-20  jody goldberg <jody@gnome.org>

	* ms-chart.c (BC_R(vector_details)) : use gnm_vector_date.

2002-01-17  Jody Goldberg <jody@gnome.org>

	* ms-obj.c (ms_object_attr_new_expr) : new.
	(ms_object_attr_destroy) : handle expressions.
	(ms_obj_read_biff8_obj) : use the expression parser for
	  GR_CHECKBOX_FORMULA.

	* ms-formula-read.c (getRefV7) : remove the pointless malloc/free.
	(getRefV8) : ditto.
	(make_inter_sheet_ref) : delete.
	(make_inter_sheet_ref_v7) : ditto.

	* ms-excel-read.c (ms_sheet_realize_obj) : add support for a
	  checkbox's link.  Needs to be done here, AFTER being assigned to a
	  sheet.
	(ms_excel_workboot_get_externsheets) : renamed from
	  biff_get_externsheet_name, and simplified.

2002-01-14  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : fix support for
	  importing local 3d references, external 3d is still not supported.

2002-01-15  Jody Goldberg <jody@gnome.org>

	* Release 1.0.2

2002-01-13  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_tab_color) : turn down the debug
	  level.

2002-01-12  Jody Goldberg <jody@gnome.org>

	* ms-excel-read.c (ms_excel_read_dv) : reorg slightly and enable.
	* ms-excel-read.c (ms_excel_read_tab_color) : new function.
	(ms_excel_read_sheet) : called from here.

2002-01-11  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : fix area 3d and its
	  missing break.

2002-01-06  Jody Goldberg <jody@gnome.org>

	* Release 1.0.1

2002-01-04  Jody Goldberg <jody@gnome.org>

	* ms-chart.c (excel_chart_series_write_xml) : more protection for
	  missing series.

2002-01-03  J.H.M. Dassen (Ray) <jdassen@debian.org>

	* ms-escher.c (ms_escher_blip_new) : cast to fix signedness warning.
	* ms-excel-read.c (biff_get_text) : likewise
	* ms-excel-read.c (get_string) : likewise
	* ms-excel-write.c (write_bits) : char -> guint8.
	* ms-excel-write.c (write_value) : ditto
	* ms-chart.c (excel_chart_series_write_xml) : cast / type change
	* ms-chart.c (BC_R) : ditto
	* ms-chart.c (BC_R(*)) : ditto
	* ms-chart.c (ms_excel_chart) : ditto

2001-12-31  Jody Goldberg <jody@gnome.org>

	* Release 1.0.0

2001-12-30  Zbigniew Chyla  <cyba@gnome.pl>

	* plugin.xml.in: Fixed typo.

	Please, DO NOT change strings few hours before the release!

2001-12-29  Andreas J. Guelzow <aguelzow@taliesin.ca>

	* plugin.xml.in : Standardize: MS Excel (tm)

2001-12-27  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : enable support for
	  deleted 3d references.

2001-12-24  Jody Goldberg <jody@gnome.org>

	* Release 0.99.1

2001-12-20  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c (ms_excel_parse_formula) : add support for
	    FORMULA_PTG_REF_ERR.
	    FORMULA_PTG_AREA_ERR.

	* ms-obj.c (ms_read_OBJ) : add protection against missing virtuals.
	  If the object is a graph read it even if we do not support them in
	  this context (embedded in another object) or if we do not support
	  graphs at all.  This enables us to read embedded graphs without
	  throwing off the rest of the parsing.

2001-12-15  Jody Goldberg <jody@gnome.org>

	* Release 0.99.0

2001-12-10  Jody Goldberg <jody@gnome.org>

	* ms-summary.c (read_summary_items) : use iconv.
	(ms_summary_read) : ditto.
	(set_summary_item) : ditto.
	(ms_summary_write) : ditto.

2001-12-05  Jody Goldberg <jody@gnome.org>

	* ms-excel-write.c (write_formula) : handle array formulas.
	* ms-formula-write.c (write_node) : ditto.
	(ms_excel_write_formula) : remove pointless malloc & free.

2001-11-25  Jody Goldberg <jody@gnome.org>

	* ms-formula-read.c : s/ParseList/ExprList/
	* ms-formula-write.c : ditto.

2001-11-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_boundsheet_data_new) : Doh!

2001-11-19  Jody Goldberg <jgoldberg@home.com>

	* Release 0.76

2001-11-16  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_dv) : read things in.  Not stored yet.
	(ms_excel_read_range) : new convenience routine.
	(ms_excel_read_mergecells) : used here.
	(ms_excel_biff_dimensions) : used here.
	(ms_excel_read_dv) : used here.
	(ms_excel_read_condfmt) : used here, fix import of multiple areas.

2001-11-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_guts) : adjust to different outline
	  scoping semantics.  We count from 0.  XL counts from 1.

	* boot.c (excel_file_open) : better error message when opening a
	  non-ole file.

2001-11-05  Jody Goldberg <jgoldberg@home.com>

	* plugin.xml.in : enable overwriting files by default.

2001-11-05  Jody Goldberg <jgoldberg@home,com>

	* Release 0.75

2001-11-04  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_cf) : Handle 'Formula' constraints in
	addition to 'Value'.
	(ms_excel_read_condfmt) : new routine.
	(ms_excel_read_dval) : fix sense of size check.
	(ms_excel_read_sheet) : cf records should only be associated
	  with condfmt.

2001-10-30  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c : Use d() debug macors to make things
	  more readable.  And use esheet in place of sheet to avoid
	  confusion with gnumeric core.
	(write_colinfo) : make xf_index an argument.
	(pre_colstyle) : new routine to gather the most common style in each col
	(gather_styles) : called from here.
	(write_mulblank) : take an array rather than a GList.
	(write_block) : only write a blank cell if it is different from the
	column default.

2001-10-30  Morten Welinder  <terra@diku.dk>

	* ms-chart.c (BC_R-ai): Plug leak.
	(BC_R-ifmt): Ditto.

2001-10-27  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_dval) : new function.
	(ms_excel_read_dv) : new function.
	(ms_excel_read_sheet) : call them here and remove warning.

2001-10-29  Jody Goldberg <jgoldberg@home.com>

	* Release 0.74

2001-10-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_xf) : Use a better default in the face
	  of errors.

	* ms-chart.c (chart_get_fmt) : new function to chain to parent.
	(ms_excel_chart) : use it here.

2001-10-29  Jody Goldberg <jgoldberg@home.com>

	* Release 0.73

2001-10-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_name_data_get_name) : adjust to signature
	  change in expr_tree_new_name.  FIXME : how does XL mark names from
	  explicit scopes.

2001-10-23  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_rowinfo) : remove duplicate code.

	* ms-excel-read.c (biff_name_data_get_name) : adjust to new named
	  expression api.

2001-10-22  Almer S. Tigelaar  <almer@gnome.org>

	* ms-excel-read.c (ms_excel_read_cf): Adjust for
	changes to style-condition.[ch]

2001-10-18  Jody Goldberg <jgoldberg@home.com>

	* Release 0.72

2001-10-18  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (BC_R(bar)) : typo.

2001-10-18  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (BC_R(dropbar)) : The docs lie.  it is ok to have
	  values > 100

	* ms-chart.c (BC_R(store_chartgroup_type)) : store the type as a
	  property rather than a child.
	(BC_R(bar)) : store the attributes as children rather than props.
	(BC_R(line)) : ditto.
	(BC_R(pie)) : ditto.
	(BC_R(pieformat)) : ditto.
	(BC_R(scatter)) : ditto.

2001-10-15  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (excel_sheet_new) : merge check_sheet into here.
	  rename according to our standards.  Only complain about being too
	  large if the content is too large, silently clip the formats.

2001-10-12  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (BC_R(legend)) : Use more guppi-ish terms for legend
	  location.

2001-10-07  Jody Goldberg <jgoldberg@home.com>

	* Release 0.71

2001-10-03  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (excel_chart_series_write_xml) : fix this for non bonobo
	  builds.

2001-09-30  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (excel_chart_series_write_xml) : Use
	  gnm_graph_series_add_dimension.
	(BC_R(seriestext)) : store constant labels as expresions.

2001-09-28  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (excel_chart_series_write_xml) : adjust to new xml
	  structure.

2001-09-27  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_object_attr_bag_lookup) : accept NULL attrBags.

	* ms-escher.c (ms_escher_read_OPT) : oops lost the blip id.

2001-09-27  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_wb_get_fmt) : renamed something
	  better than biff_format_data_lookup.

	* ms-chart.c (BC_R(ai)) : Use ms_container_get_fmt.
	(BC_R(ifmt)) : ditto.

	* ms-container.c (ms_container_get_fmt) : new function.

2001-09-27  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_map_color) : new utility.
	(ms_sheet_create_obj) : set the fill colour.

	* ms-escher.c (ms_escher_read_OPT) : generalize to make things more
	  efficient.

	* ms-obj.c (ms_object_attr_new_uint) : store a uint to facilitate
	  colors.

2001-09-26  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_parse) : call ms_escher_header_release.
	(ms_escher_read_container) : ditto.
	(ms_escher_header_release) : new to handle attrs.
	(ms_escher_header_add_attr) : ditto.
	(ms_escher_read_ClientData) : pass the attributes to the object
	  and move the blip handing to the container.

	* ms-obj.c (ms_object_attr_new_flag) : new.
	(ms_object_attr_new_int) : new.
	(ms_object_attr_new_ptr) : new.
	(ms_object_attr_destroy) : new.
	(ms_object_attr_bag_new) : ditto.
	(ms_object_attr_bag_destroy) : ditto.
	(ms_object_attr_bag_insert) : ditto.
	(ms_object_attr_bag_lookup) : ditto.

	* ms-excel-read.c (ms_excel_read_workbook) : interface change to
	  ms_read_OBJ.
	(ms_excel_read_sheet) : ditto.
	(ms_sheet_create_obj) : move the blip handing from escher to here.

2001-09-26  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : Init the inversion flags.

	* ms-escher.c (ms_escher_read_Sp) : store the inversion flags.
	(ms_escher_read_ClientData) : copy the inversion flags.
	(ms_escher_init_heade) : init the inversion flags.

2001-09-26  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-xf.h (_BiffXFData) : locked and hidden are booleans.
	* ms-excel-read.c (biff_xf_data_new) : read them that way.
	(ms_excel_get_style_from_xf) : store the protection flags.
	* ms-excel-write.c (build_xf_data) : ditto.  Add indent.

	* ms-chart.c (BC_R(seriestext)) : handle manually entered series names.

2001-09-25  Jon K Hellan  <hellan@acm.org>

	* .cvsignore: Add plugin.xml

2001-09-17  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : init the new object more completely.

2001-09-16  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c : clean up debug routines.
	(BC_R(dataformat)) : Use an extra node to handle pt vs series
	  level formating.
	(BC_R(end)) : cleanup dataformats.
	(excel_chart_series_write_xml) : just link in the new child rather
	  than creating it here.
	(BC_R(dataformat)) : handle formating pts vs entire series.
	(BC_R(markerformat)) : implement
	(BC_R(areaformat)) : implement
	(BC_R(lineformat)) : implement
	(BC_R(pieformat)) : implement
	(BC_R(color)) : tweak interface.
	(ms_excel_chart) : ignore a few more records.

2001-09-14  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (excel_chart_series_write_xml) : Use the gal routines for
	  symetry with the guppi implementation.

2001-09-09  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (BC_R(pieformat)) : store pie separation.
	(BC_R(get_chartgroup_type)) : new function.

2001-09-08  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (legend) : xml-ize and fix transposition of right & left.
	(pie) : Guppi uses radians and has 0 in a different place.

2001-09-04  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : Use ms_destroy_OBJ.

	* ms-chart.c (ms_excel_chart) : don't import the spec if we did not
	  create the graph.

2001-09-03  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_cf) : Do some guessing about how they
	  store the format information.
	(ms_excel_read_sheet) : merge in ms_excel_read_cell, and reorder the
	  records to match their biff order.  call ms_excel_read_cf.

2001-09-02  Jody Goldberg <jgoldberg@home.com>

	* biff-types.h : Add CONDFMT

2001-08-29  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (excel_chart_series_new) : init the xml node.
	(excel_chart_series_write_xml) : new.
	(BC_R(store_chartgroup_type)) : new utility.
	(BC_R(bar)) : convert to xml.
	(BC_R(line)): convert to xml.
	(BC_R(pie)) : convert to xml.
	(BC_R(scatter)) : convert to xml.
	(BC_R(chartformat)) : store the general chart group details.
	(BC_R(end)) : store the series specs associated with this chartgroup.
	(ms_excel_chart) : tweaks for xml.

2001-08-28  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : pass graphs into their parser.

	* ms-excel-read.c (ms_sheet_realize_obj) : renamed from
	  ms_sheet_obj_realize.
	(ms_sheet_create_obj) : renamed from ms_sheet_obj_create.
	  Improve the warnings for unhandled objects.
	  Pass graphs into the parser.

	* ms-container.c (ms_container_workbook) : delete.

	* ms-chart.c (ms_excel_chart) : enable some of the xml spec generation.
	  and take the GnmGraph as an argument.
	(ms_excel_read_chart) : take the graph as an argument.

2001-08-27  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_parse_expr_internal) : disable some of the
	  debugging spew.

2001-08-26  Zbigniew Chyla  <cyba@gnome.pl>

	* boot.c (excel_save):
	Remove GNUMERIC_ENABLE_XL_OVERWRITE hack. This is now supported via
	flag in plugin.xml file.

	* plugin.xml.in: s/file_overwrite/overwrite_files/

2001-08-24  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c : fix and prune includes.
	* ms-excel-write.c : ditto.
	* boot.c : ditto.

2001-08-23  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (ms_excel_chart) : only delete the series after
	  processing.  condtionalize some of the debug spew.
	  condtionalize parsing based on the existence of a graph
	  condtionalize making the graph on the debug flag (for now)
	(BC_R(sertocrt)) : store the chart group.
	(BC_R(series_impl)) : merge back into BC_R(series).
	(BC_R(vector_details)) : use the gnumeric type directly.
	(excel_chart_series_new) : new.
	(excel_chart_series_destroy) : new.

	* ms-container.c (ms_container_workbook) : new function.
	(ms_container_sheet) : ditto.

	* ms-excel-read.c (ms_wb_workbook) : new function.
	(ms_excel_workbook_new) : used here.
	(ms_sheet_workbook) : new function.
	(ms_sheet_sheet) : new function.
	(ms_excel_sheet_new) : used here.

2001-08-21  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (gnm_graph_vector_type_name) : use the version in gnumeric-graph.c
	(BC_R(vector_details)) : Use the correct index for the debug info.

	* ms-excel-read.c (ms_excel_biff_dimensions) : Use range_name.

2001-08-21  Zbigniew Chyla  <cyba@gnome.pl>

	* plugin.xml: Removed

	* plugin.xml.in: Copied from plugin.xml, prepared for localization.

	* Makefile.am: Use xml-i18n-tools to create plugin.xml (with
	translations merged from .po file).

2001-08-20  Jody Goldberg <jgoldberg@home.com>

	* Release 0.70

2001-08-20  Jody Goldberg <jgoldberg@home.com>

	* Makefile.am : Remove unused stubs for gnumeric-chart.
	* ms-chart.c : s/ExcelChart/ExcelChartReadState/g
	(BC_R(top_state)) : new function.
	(map_excel_vec_type_to_gnm) : new function.
	(BC_R(vector_details)) : new function.
	(BC_R(series_impl)) : Use vector_details.
	(BC_R(ai)) : actually handle the vector.
	(BC_R(begin)) : keep a stack of the states.
	(BC_R(series)) : keep track of the series.

	* ms-excel-read.c (ms_sheet_obj_realize) : use the correct anchor specs.
	  and use the new SheetObjectAnchor mechanism.
	(ms_sheet_obj_create) : signatue change for sheet_object_container_new.

2001-08-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_formula) : improve the debug info.
	(ms_excel_read_bof) : Doh!  We modify the sheet counter.
	(ms_excel_read_workbook) : signature changes for ms_excel_read_bof.

2001-08-11  Jody Goldberg <jgoldberg@home.com>

	* Release 0.69

2001-08-07  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_setup) : print scaling is stored as a
	  percentage in XL and in Gnumeric.  Improve the warning as long as
	  we're in here.

2001-08-03  Jody Goldberg <jgoldberg@home.com>

	Consistently refer to /ExcelSheet/ instances as esheet.
	Ensure that the BiffQuery is the first arg.
	* ms-excel-read.c (ms_excel_sheet_new) : Explicitly request a full
	  respan for the update after we load.  I had been relying on there
	  being a col/row or default col/row sizing to force it.

2001-08-02  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_blip_new) : be consistent and use #ifdef

2001-07-25  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_window2) : Tidy up a bit.

	* ms-excel-write.c (write_window2) : support frozen panes.
	(write_pane) : Implement.

2001-07-17  Jody Goldberg <jgoldberg@home.com>

	* Release 0.68

2001-07-16  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_pane) : implement.
	(ms_excel_read_window2) : store initial top left.

2001-07-12  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_pane) : new function.
	(ms_excel_read_sheet) : called from here.
	(ms_excel_read_window2) : top left spec is _zero_ based.
	  Add support for setting the frozen flag.
	(ms_excel_sheet_new) : init the freeze flag here.

2001-07-13  Lutz Müller <urc8@rz.uni-karlsruhe.de>

	* ms-escher.c (ms_escher_read_ClientData): Syntax and name of
	sheet_object_bonobo_load(_persist)_stream changed.

2001-06-28  Jody Goldberg <jgoldberg@home>

	* Release 0.67

2001-06-28  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (lookup_font_base_char_width_new) : add more safety.

	* ms-excel-write.c (formats_put_magic) : const.
	(new_sheet) : ignore spans and merges for extent calcs.

	* ms-excel-read.c (ms_excel_read_init) : new function to init the
	  locale specific date format.

	* boot.c (plugin_init) : new function.

2001-06-27  Jody Goldberg <jgoldberg@home.com>

	* Release 0.66

2001-06-21  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_read_supporting_wb): Fix trigraph
 	stuff and cut down on repeated question marks in general.

2001-06-15  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_new) : Use CellPos directly.

	* ms-formula-read.c (ms_excel_parse_formula) : some cleanup.

2001-06-11  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_setup) : new routine.
	(write_sheet_bools) : split out from here.

	* ms-excel-read.c (ms_excel_read_sheet) : split the setup parser out
	  of here into.
	(ms_excel_read_setup) : here.  and modernize it.  Read the number of
	  copies and the scaling if specified.

2001-06-12  Zbigniew Chyla  <cyba@gnome.pl>

	* boot.c (excel_save): Set up io_progress before calling ms_excel_check_write
	and ms_excel_write_workbook.

	* ms-excel-read.c
	(ms_excel_read_sheet): Added IOContext argument,
	call value_io_progress_update on every loop iteration.
	(ms_excel_read_workbook): Set up io progress message and helper.

	* ms-excel-write.c
	(pre_cell): Update io progress.
	(pre_blanks): Update io progress at every row.
	(gather_styles): Set up io progress helper.
	(write_block): Update io progress after every write_cell call.
	(ms_excel_write_workbook): Set up io progress helper.
	(ms_excel_check_write): Copy IOContext ptr into ExcelWorkbook struct.

	* ms-excel-write.h (struct _ExcelWorkbook): Added io_context.

2001-06-03 Jody Goldberg <jgoldberg@home.com>
	For Vlad Harchev <hvv@hippo.ru>

        * ms-excel-util.h ms-excel-util.c (excel_wcstombs) :
	  Some utilites to handle encoding changes that fail.

        * ms-excel-read.c : Use the utilities.

2001-06-02  Almer S. Tigelaar  <almer@gnome.org>

	* (ms_excel_read_row): Set outline using
	new functions.
	(ms_excel_read_colinfo): Idem.

2001-05-31  Karl Eichwalder  <ke@suse.de>

	* boot.c (excel_save): Add dot.

2001-05-29  Zbigniew Chyla  <cyba@gnome.pl>

	* boot.c (excel_file_probe): Added FileProbeLevel argument.

2001-05-27  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_window2) :
	  Switch the BIFF_WINDOW2 0x23e -> 0x3e
	(write_names) : fix biff type.

	* ms-excel-read.c (ms_excel_read_formula) : cleanup some old
	  inconsistentcies.  keep as many of the BIFF_* using their major
	  types.
	  Switch the BIFF_STRING 0x207 -> 0x07
	  Switch the BIFF_BOOLERR 0x205 -> 0x05
	(ms_excel_read_window2) : split this out into a neater bundle.

2001-05-26  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_sheet_bools) : Save the iteration
	  preferences too.  These are workbook level flags.  I am unclear why
	  XL saves them at the sheet level.

	* ms-excel-read.c (ms_excel_read_calccount) : new function.
	(ms_excel_read_delta) : ditto.
	(ms_excel_read_iteration) : ditto.
	(ms_excel_read_sheet) : use them here.

2001-05-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_formula) : Use cell_queue_recalc
	  to get appropriate recursion.

2001-05-17  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_formula_shared) : Use a g_warning not a
	  printf.

2001-05-21  Zbigniew Chyla  <cyba@gnome.pl>

	* boot.c (excel_file_probe, excel_file_open, excel97_file_save,
	excel95_file_save):
	s/FileOpener/GnumFileOpener/
	s/FileSaver/GnumFileSaver/

2001-05-20  Jody Goldberg <jgoldberg@home.com>

	* Release 0.65

2001-05-13  Michael Meeks  <michael@ximian.com>

	* ms-excel-write.c (write_value): commit the VALUE_EMPTY.

	* ms-biff.c (ms_biff_put_len_next),
	(ms_biff_put_var_next): add conditional debug to help catch
	similar problems - none obvious just now.

2001-05-11  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_workbook) : clear the global handle
	  after it is closed.

2001-05-11  Almer S. Tigelaar  <almer@gnome.org>

	* ms-excel-write.c (write_sheet_bools): Write dimensions as
	unsigned integers.
	(biff_put_text): Signedness.
	(write_externsheets): Signedness.
	(excel_font_to_string): Signedness.
	(fonts_free): Signedness.
	(write_formats): Signedness.
	(xf_free): Signedness.
	(pre_cell): Signedness + Unused variabele.
	(gather_styles): Signedness.
	(map_pattern_index_to_excel): Signedness.
	(write_index): Signedness.
	(write_block): Signedness.
	(write_sheet): Signedness.
	(free_workbook): Signedness.
	(write_workbook): Signedness.
	(check_sheet): Signedness.

	* ms-excel-formula-write (write_node): Cast untyped pointer.

2001-05-07  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_get_data) : suppress warnings.
	(ms_escher_read_ClientTextbox) : no side effects in precondition.

	* ms-excel-read.c (ms_excel_formula_shared) : ditto.

2001-05-06  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_boundsheet_data_new) : merge in the last of
	  the i18n patches.

2001-05-05  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_set_xf_segment) : support multiple rows.
	(ms_excel_read_row) : use here.
	(ms_excel_read_cell) : and here.
	(ms_excel_read_colinfo) : start using it here too.
	(ms_sheet_obj_create) : Add a place holder for a spinner.

	* ms-excel-write.c (pre_cell) : XL does not differentiate between
	  parse and display formats.  When exporting a cell with General that
	  has a parse format create a new XF with the parse format as the
	  display format.

2001-04-30  Morten Welinder  <terra@diku.dk>

	* ms-summary.c (sum_name_to_excel): Fix index count.  Constify.
  	Make static.
	(excel_to_gnum_mapping): Make static.

2001-04-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_window2) : Headers are in default style.
	  And grid colour is auto, not black.

2001-04-27  Chema Celorio  <chema@celorio.com>

	* boot.c (excel_save): add a message explaining that you could set
 	an env variable to enable XL overwrite. This is not the optimal
 	solution tho.

2001-04-26  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_colinfos) : Rework to simplify and use
	  colrow_equal.
	(write_colinfo) : extract the info from the ColRowInfo directly and
	  fill in the visibility, outline, and collapse states.
	(write_rowinfo) : export visibility, collapse and outline.
	(write_guts) : new function.
	(new_sheet) : Include blank cols/rows with outline properties in
	  extent calculation.

	* ms-excel-write.h (Excel{Col,Row}) : Delete unnecessary structures.

2001-04-26  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_mergecells) : new routine to save merged
	  regions.
	(write_sheet_tail) : called from here.

2001-04-23  Jon K Hellan  <hellan@acm.org>

	* ms-biff.c (ms_biff_query_next, ms_biff_query_next,
	ms_biff_query_destroy, ms_biff_put_new, ms_biff_put_commit,
	ms_biff_put_len_next): Make sure that bp->data = 0 when
	bp->data_malloced = 0 & v.v. This helps heap debugging.
	(ms_biff_put_len_next): Assert that data pointer is null. If it
	weren't the old code would have been leaking.

2001-04-23  Morten Welinder  <terra@diku.dk>

	* ms-excel-write.c (ms_excel_check_write): Avoid double free of
 	the list.

2001-04-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_wsbool) : new function.
	(ms_excel_read_sheet) : called from here.

	* ms-excel-write.c (write_wsbool) : new function.
	(write_sheet_bools) : called from here.

2001-04-19  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_window2) : sigh, when fixing the sizes I did
	  not change the offsets.  I miss C++ in situations like this.
	(ms_excel_check_write) : Free the sheet list.

2001-04-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (excel_iconv_win_codepage) : cleanup and remove
	  warnings in the C locale case.

	* ms-excel-write.c (write_sheet_tail) : split WINDOW2 code out of here
	(write_window2) : and move it here.  Then comment it up and extend the
	  logic.

2001-04-17  Jody Goldberg <jgoldberg@home.com>

	* plugin.xml : Disable the excel97 save method until it potentially
	  does more than screw up.

2001-04-15  Vlad Harchev <hvv@hippo.ru>

        * ms-excel-util.h ms-excel-util.c :
        added framework for doing portable recoding between charsets,
        and also functions for finding appropriate Windows codepage
        for current locale.

        * ms-excel-read.c ms-excel-write.c :
        Properly perform charset conversion for all textual data when doing
        export or import of .xls files.

2001-04-12  Chema Celorio  <chema@celorio.com>

	* boot.c (excel_save): add an env variable so that we can
	enable XL overwrite. the variable is named GNUMERIC_ENABLE_XL_OVERWRITE

2001-04-12  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (pre_pass) : Don't unref here.

2001-04-12  Morten Welinder  <terra@diku.dk>

	* ms-summary.c (ms_summary_write): Plug leaks.

2001-04-11  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-write.c (write_string) : a null string is not a missing
	  arg.

2001-04-04  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_externsheet) : new function split from
	(ms_excel_read_workbook) : here.

	* ms-excel-read.c (biff_name_data_new) : begin cleanup.  The
	  sheet_index is stored in different places for different biff types.
	  There also appears to be enough data about the sheet names that we
	  may not need to do this magic delayed instantiation.

2001-04-03  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (ms_excel_chart) : provide stub handlers for container
	  virtuals.

2001-04-02  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_imdata) : new routine pulled from.
	(ms_excel_read_cell) : here.

	* ms-obj.c (ms_obj_read_biff8_obj) : used here.

2001-04-04  Morten Welinder  <terra@diku.dk>

	* ms-escher.c (ms_escher_blip_destroy): Plug leak.

	* ms-excel-util.c (lookup_font_base_char_width_new): Implement
 	negative caching.

2001-04-01  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_get_data) : improve diagnostic info.

	* ms-obj.c (ms_obj_read_biff8_obj) : when reading the mystery trailing
	  IMDATA we need to handle CONTINUE.  We really need to figure out
	  what this is.

2001-04-01  Morten Welinder  <terra@diku.dk>

	* ms-chart.c (register_handlers) : Fix prototype.

	* gnumeric-chart.c (gnumeric_chart_new): Fix prototype.

	* ms-excel-write.c (get_default_mstyle): Fix prototype.

2001-04-01  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_default_palette): Fix prototype.
	(ms_excel_read_cleanup): New function.

	* ms-excel-util.c (destroy_xl_font_widths): New function.

	* boot.c (plugin_cleanup): New function.

2001-03-31  Zbigniew Chyla  <cyba@gnome.pl>

	* .cvsignore: Added *.lo and *.la.

2001-03-30  Jody Goldberg <jgoldberg@home.com>

	* ms-container.c (ms_container_init) : Take a parent container.
	(ms_container_finalize) : handle NULL blips smoothly.
	(ms_container_get_blip) : check the container if we are empty.

	* ms-escher.c (ms_escher_read_Blip) : always register a blip, even if
	  it is NULL, otherwise the index gets confused.  Move the
	  registration here.
	(ms_escher_blip_new) : from here.
	(ms_escher_read_ClientData) : replace blips we can't understand with
	  rectangles.

	* ms-chart.c (ms_excel_chart) : Pass in the charts container.

	* ms-excel-read.c (ms_excel_workbook_new) : workbook have no parents.
	(ms_excel_sheet_new) : Sheets are contained by workbooks.

2001-03-30  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : Only newer versions
	  have indents.

2001-03-30  Morten Welinder  <terra@diku.dk>

	* ms-escher.c (ms_escher_read_container): Plug leak.

2001-03-30  Jody Goldberg <jgoldberg@home.com>

	* boot.c (excel_save) : clarify message.

2001-03-29  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_read_Blip) : Fix leak plug.

2001-03-29  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_obj_read_biff8_obj) : It seems certain that the MS docs
	  are wrong about list boxes.  I hope they don't do the same thing for
	  other records too.

	* ms-escher.c : s/ms_excel_read_debug/ms_excel_escher_debug/
	(ms_escher_read_OPT) : Add missing OPT records and cleanup docs.
	(ms_escher_read_BSE) : Document the record size and don't attempt to
	  treat this as a container if its content is of size 0.

2001-03-28  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_TXO) : Fix the minor memory overrun Morten found.

2001-03-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (init_xl_font_widths) : recalculate the size of Geneva
	  for the default case of Geneva not being available.

2001-03-27  Morten Welinder  <terra@diku.dk>

	* ms-escher.c (ms_escher_read_Blip): Plug leak.

2001-03-20  Zbigniew Chyla  <cyba@gnome.pl>

	* Makefile.am:
	Building excel plugin as shared library, added plugin.xml.

	* boot.[ch]:
	xxx_debug variables from src/main.c moved here.
	Converted to real plugin with file_opener and file_saver services.

	* plugin.xml: New file.

	* gnumeric/plugins/excel/excel.h, plugins/excel/ms-chart.c,
	plugins/excel/ms-escher.c, plugins/excel/ms-excel-read.c,
	plugins/excel/ms-excel-read.h, plugins/excel/ms-excel-util.c,
	plugins/excel/ms-excel-write.c, plugins/excel/ms-excel-write.h,
	plugins/excel/ms-formula-read.c, plugins/excel/ms-formula-write.c,
	plugins/excel/ms-obj.c:
	Adjusted function signatures, don't return TRUE/FALSE if using
	IOContext (we don't need boolean value as IOContext now sets
	"error_occurred" flag).

2001-03-15  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_row) : Handle outline mode.
	(ms_excel_read_colinfo) : ditto.
	(ms_excel_read_guts) : ditto.

2001-03-17  Jody Goldberg <jgoldberg@home.com>

	* Release 0.64

2001-03-02  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (getRefV8) : rewrite to handled sign extension
	  correctly (I Hope) for the various shared/unshared states.
	(getRefV7) : ditto.

2001-02-24  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_colinfo) : work around some strange
	  widths from a test sheet.

2001-02-23  Jody Goldberg <jgoldberg@home.com>

	* Release 0.63

2001-02-19  Jon K Hellan  <hellan@acm.org>

	* boot.c (excel_load, excel_init): Change file format level to
	FILE_FL_MANUAL_REMEMBER.

2001-02-16  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-write.c (write_node) : Use some code from expr.c
	  to simplify binary/unary output and to add parens when necessary.

	* ms-excel-write.c (write_formula) : Start at paren level 0.
	(write_names) : ditto.

2001-02-16  Jody Goldberg <jgoldberg@home.com>

	* Release 0.62

2001-02-15  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_realize) : Add a missing call to
	  sheet_object_set_sheet.  Without this the objects are lost in limbo.

2001-02-11  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_create) : add option button.

2001-02-10  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_init_margins): New
	function. Initialize margins to Excel defaults.
	(ms_excel_sheet_new): Call ms_excel_init_margins.

	* ms-excel-write.c (write_sheet_bools): Write margins also for
	biff 7 (which is what we actually use).

2001-02-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_create) : don't free the object on
	  failure.

	* ms-obj.c (ms_read_OBJ) : free it here on failure.

	* ms-container.c (ms_container_finalize) : fix leak.

2001-02-06  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_default_col_width) : typo.

2001-02-06  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_default_col_width) : Init and cache
	  the default column width here directly.
	(ms_excel_read_colinfo) : Use the font associated with the specified
	  xf record to calculate the width.
	(get_base_char_width) : delete.
	(init_base_char_width_for_read) : rename base_char_width_for_read.
	(base_char_width_for_read) : take the xf index as an argument and
	  return rather than caching the results.

2001-01-30  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (new_sheet) : adjust semantics of get extent.

2001-01-30  Almer S. Tigelaar  <almer1@dds.nl>

	* ms-excel-read.c (ms_excel_read_selection):
	Rename sheet_selection_reset_only to sheet_selection_reset.

2001-01-17  Michael Meeks  <michael@helixcode.com>

	* ms-escher.c (ms_escher_read_Blip): fix eog oafiid.

2001-01-08  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_create) : remove stale debugging.

2001-01-08  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (put_mstyle) : add a ref when the style is put in
	  the table.
	(xf_free) : release the default style.

2000-12-31  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_set_xf) : remove cruft with triple styles.
	(biff_xf_data_new) : Ditto.
	(ms_excel_set_xf_segment) : Ditto.
	(biff_xf_data_destroy) : Ditto.

	* ms-excel-write.c (build_xf_data) : remove cruft with triple styles.

2001-01-01  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_window1): Take WorkbookView
	parameter. Save width, height and flags for
	show_horizontal_scrollbar, show_vertical_scrollbar and
	show_notebook_tabs
	(write_bits, write_sheet_tail): Call write_window1 with
	WorkbookView parameter.

	* ms-excel-read.c (ms_excel_read_window1): New function -
	separated out of ms_excel_read_workbook. Read BIFF WINDOW1 record.
	Fix some typos: Some fields were 32bit, should be 16 bit.
	(ms_excel_read_workbook): Separated out ms_excel_read_window1.

2000-12-20  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (BC_R(ai)) : Use ms_container_parse_expr.

	* ms-container.c (ms_container_parse_expr) : new function.

	* ms-excel-read.c (ms_sheet_parse_expr_internal) : implement parse_expr.

2000-12-17 Jody Goldberg <jgoldberg@home.com>

	* Release 0.61

2000-12-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_create) : changes to sheet object
	  constructor arguments.

2000-12-07  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : enable indent.

2000-12-7  Jody Goldberg <jgoldberg@home.com>

        * Release 0.60

2000-12-05  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_mergecells) : enable merged cells.

2000-12-05  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_read_Blip) : revert to using the old
	  non-installed image viewer.  The one in eog/viewer does not work.
	  the one in eog/bonobo does.

2000-12-04  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_create) : fix warnings.

2000-12-02  Jody Goldberg <jgoldberg@home.com>

	* ms-escher.c (ms_escher_read_Blip) : Change image viewers.  The
	  eog/bonobo viewer is no longer built or installed.

	* ms-excel-read.c (ms_excel_read_sheet) : XL docs do not mention that
	  the PROTECT record can sometimes be of size 0.
	(ms_excel_read_workbook) : Ditto.
	(ms_excel_read_PROTECT) : new function.
	(ms_excel_read_mergecells) : Correct.
	(biff_xf_data_new) : remove the warnings about merged cells.

2000-12-01  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : simplify.

	* ms-excel-write.c (write_biff7_comments) : slight reorg to handle to
	  style cell comments.

	* ms-excel-read.c (ms_excel_read_comment) : revamp for new cell
	  comment technique.

	* ms-excel-read.c (ms_sheet_obj_anchor_to_pos) : Update to the new
	  sheetObject anchor scheme.  The sheet does NOT yet support this form
	  of anchor.  We'll need to add it in the next couple of days.
	(ms_sheet_obj_create) : create the sheet objects directly.

	* ms-escher.c (ms_escher_read_ClientData) : set the picture here
	  directly.

2000-12-01  Jody Goldberg <jgoldberg@home.com>

	* ms-container.c (ms_container_get_blip) : new function.
	(ms_container_init) : Add ability to share blip lists between
	  containers.  We need to figure out the semantics of this.
	(ms_container_finalize) : Ditto.
	(ms_container_set_blips) : Ditto.

2000-11-19  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_externsheets): Make EXTERNCOUNT be the
	number of EXTERNSHEETS we actually store. This stops Excel from
	crashing. See bug #32096. We still have to figure out what to
	store as EXTERNSHEETS and when. What we're doing isn't right.

2000-11-18  Jody Goldberg <jgoldberg@home.com>

	* Release 0.59

2000-11-13  Jody Goldberg <jgoldberg@home.com>

        * Release 0.58

2000-11-13  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_get_style_from_xf): Fix some
 	style_color reference count problems.
	(ms_excel_set_xf_segment): Plug leak.

2000-11-10  Jody Goldberg <jgoldberg@home.com>

	* excel_builtin_formats : Correct long standing typos.

2000-11-10  Jody Goldberg <jgoldberg@home.com>
	Patch from Juan Pablo Mendoza <pablo_juan@yahoo.com>

         * ms-excel-write.c (write_biff7_comments): New function.
	 (write_sheet): Use it.

2000-11-07  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_name_data_get_name) : Cleanup a bit.

2000-11-02  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (ms_excel_chart) : remove check for BOF type == chart.
	  in BIFF5 it is possible to.

        * ms-excel-read.c (ms_excel_read_sheet) : If we find a CHART_unit
	  record parse the following records as if they were a chart.

2000-11-01  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_set_comment) : we do not need to set
	  the cell's value to empty.  It is created that way.
	(ms_excel_read_comment) : Ditto.
	(ms_excel_sheet_insert_val) : We have direct access to the display
	  format.  Use it rather than doing an expensive lookup.

2000-10-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c : Adjust to the signature changes for reading views
	  rather than workbooks.
	* ms-excel-write.c : ditto.
	* boot.c : ditto.

2000-10-28  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (init_xl_font_widths) : Add CG Times.

2000-10-30  Morten Welinder  <terra@diku.dk>

	* ms-biff.c (biff_getdouble, biff_setdouble): Delete.  Replace all
 	callers with gnumeric_get_le_double and gnumeric_set_le_double.

2000-10-21  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_row) : Fix bounds.
	(ms_excel_set_xf_segment) : Be more careful about bounds.

2000-10-10  Jody Goldberg <jgoldberg@home.com>

        * Release 0.57

2000-10-04  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_get_rk) : Fix ancient thinko.  Thanks to
	  heiko@hexco.de for noticing this.

2000-09-20  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (ms_excel_parse_formula) : Make the warning
	  quieter.

2000-09-10  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_sheet_obj_realize) : Adjust to new object
	  creation semantics.  First you create the object.  Then set its
	  size.

2000-09-06  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_new) : No need to call set_zoom.
	  sheet_new does that.

2000-08-24  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (put_format) : Ref formats as we add them.

2000-08-23  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (formats_put_magic) : Fixups after changes to
	  format tables.  We need to store a StyleFormat, not a string.
	(after_put_format) : unref rather than free.

2000-08-21  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (formats_init) : The format table nows stores
	  pointers to StyleFormats rather than their strings.
	(formats_get_format) : Ditto.
	(formats_free) : Ditto.
	(formats_get_index) : Ditto.
	(put_format) : Ditto.
	(write_format) : Ditto.

	* ms-excel-read.c (biff_format_data_lookup) : Number formats are
	  stored in XLS using the 'C' locale. eg a french user who sees
	  '# ##0,00' will actually save '#,##0.00'.
	(ms_excel_get_style_from_xf) : Kludge.  We need to actually set
	  non-borders so that things get over ridden.  The core model needs
	  improving before this can happen correctly.
	(ms_excel_get_style_from_xf) : Ditto.

	* ms-escher.c (ms_escher_read_Blip) : Remove gnorba.

	* ms-chart.c (ai) : Changes to the interface for StyleFormats.
	(ifmt) : Ditto.
	(ms_excel_chart) : Init the sheet.  Ignore BIFF_DIMENSION records for
	  now.  I have no idea what they represenent.

2000-08-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : No need to use
	  set_text.  Set the StyleFormat directly.

2000-08-16  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (init_xl_font_widths) : Tweak Times New Roman
	  to match observations.  It seems as if the size is non-linear :-(
	  We'll need another round of measurements to account for this.

2000-08-15  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (ms_excel_chart) : conditionalize debug info.

2000-08-14  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_set_xf) : Improve debug info.
	(ms_excel_set_xf_segment) : Ditto.
	(biff_xf_data_new) : Ditto.
	(ms_excel_get_style_from_xf) : Always apply the
	  borders.  We need to apply even in the case of no border in order to
	  over ride previously applied defaults.
	(ms_excel_read_row) : Apply default style to the entire row.

2000-08-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_biff_dimensions) : Move back from
	  ms-chart.c.  It is specific to sheets.

2000-07-26  Michael Meeks  <michael@helixcode.com>

	* README: Add some explanation of why I hate being mailed by people
	forking my code.

2000-07-24  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_sheet) : Adjust to changes in sheet_set_zoom_factor.
	(ms_excel_sheet_new) : Ditto.

2000-07-13  Jody Goldberg <jgoldberg@home.com>

	* ms-container.c : Beginings of a some support for workbooks, and charts holding objects.
	  Blips should become objects.

	* *.c : adjust to using the container abstraction.

2000-07-08  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (make_function) : Move the place holder handling
	  into the core.

2000-07-12  Michael Meeks  <michael@helixcode.com>

	* ms-escher.c (ms_escher_blip_destroy): unref not destroy bonobo object.

2000-07-06  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_OBJ) : Take an ExcelSheet.

	* ms-escher.c (ms_escher_read_ClientData) : ms_read_OBJ takes a sheet.
	* ms-excel-read.c (ms_excel_read_sheet) : Ditto.
	(ms_excel_read_workbook) : Ditto.

	* ms-chart.c (3dbarshape) : A bit of research into probable values of
	  the enum.
	(ai) : After some thought this makes more sense.  We should only see
	  an expression if we are linked to the workbook.  Similarly we should
	  only see a format if one is specified.  We really need to avoid this
	  kludge of needing a dummy sheet.
	(areaformat) : Ignore colour index, use the stored colour.  Add some
	  more debug info.
	(lineformat) : Ditto.
	(markerformat) : Ditto.
	(ms_excel_chart) : Take an optional ExcelSheet.
	  Parse BIFF_NUMBER records when they appear.
	(ms_excel_read_chart) : Take an optional ExcelSheet.

2000-07-05  Michael Meeks  <michael@helixcode.com>

	* ms-obj.c (ms_obj_realize): rename sheet_object_container constructor.

	* s/reproid/repo_id/

2000-06-27  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-write.c (write_node) : Handle new ExprFunction.

	* ms-formula-read.c (excel_formula_build_dummy_handle) : Use
	  function_lookup_by_name.

	* ms-excel-read.c (ms_excel_set_xf) : Right borders dominate left
	  borders.

2000-06-23  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_append_comment) : Add a lag variable
	  to support proper merging of comments.
	(BIFF_NOTE) : Init the lag variable.

2000-06-21  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (palette_put_defaults): Ensure that black with
	index 8 can't be swapped out.
	(fixup_fill_colors): Use index 8 instead of 0 for black in
	foreground. Excel is unable to open the cell format dialog for
	cells where foreground pattern color or border color is index 0.
	(build_xf_data): Borders: Use index 8 instead of 0 for black.

	* ms-excel-read.c (ms_excel_read_cell): Add more references to BIFF
	documentation.
	(ms_excel_read_workbook): Ditto

2000-06-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_externname) : Catch external names that
	  are OLE or DDE links.

2000-06-18  Jody Goldberg <jgoldberg@home.com>

        * Release 0.56

2000-06-19  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (excel_cell_get) : Add some invariants as
	  protection.
	(pre_cell) : Be more careful about handling cells that are potentially
	  out of bounds.

2000-06-18  Jody Goldberg <jgoldberg@home.com>

        * Release 0.55

2000-06-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_boundsheet_data_new) : Guess at some
	  undocumented behavior.  It appears that when a sheet has a NULL
	  name it is actually 'Sheet#'.

2000-06-15  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_db_cell): No longer use uninitialized
	rc_start [i]. Purify complained, although we immediately threw
	away the result.

2000-06-15  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_formula) : Incorrect offsets for formula
	  values with booleans and errors.

2000-06-14  Morten Welinder  <terra@diku.dk>

	* ms-formula-write.c (ms_excel_write_formula): Plug leak.

	* ms-excel-write.c (ms_excel_check_write): In case of error, clear
 	out the state.
	(ms_excel_write_free_state): "New" function.
	(write_workbook): Don't free workbook here.
	(ms_excel_write_workbook): Do it here and plug a leak.

	* boot.c (excel_save): Free the state.

2000-06-07  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_format_data_lookup) : FORMAT records supercede
	  the internal table.

2000-06-05  Michael Meeks  <michael@helixcode.com>

	s/eBiff_version/MsBiffVersion/g;
	s/eBiffV([0-9]*)/MS_BIFF_V\1/g;
	s/eBiffVUnknown/MS_BIFF_V_UNKNOWN/g;

	s/eBiff_filetype/MsBiffFileType/g;
	s/eBiffT/MS_BIFF_TYPE_/g;
	s/eBiff_hidden/MsBiffHidden/g;
	s/eBiffHVisible/MS_BIFF_H_VISIBLE/g;
	s/eBiffHHidden/MS_BIFF_H_HIDDEN/g;
	s/eBiffHVeryHidden/MS_BIFF_H_VERY_HIDDEN/g;
	s/eBiff_locked/MsBiffLocked/g;
	s/eBiffLLocked/MS_BIFF_L_LOCKED/g;
	s/eBiffLUnlocked/MS_BIFF_L_UNLOCKED/g;
	s/eBiff_xftype/MsBiffXfType/g;
	s/eBiffXStyle/MS_BIFF_X_STYLE/g;
	s/eBiffXCell/MS_BIFF_X_CELL/g;
	s/eBiff_format/MsBiffFormat/g;
	s/eBiffFMS/MS_BIFF_F_MS/g;
	s/eBiffFLotus/MS_BIFF_F_LOTUS/g;
	s/eBiff_eastern/MsBiffEastern/g;
	s/eBiffEContext/MS_BIFF_E_CONTEXT/g;
	s/eBiffEleftToRight/MS_BIFF_E_LEFT_TO_RIGHT/g;
	s/eBiffErightToLeft/MS_BIFF_E_RIGHT_TO_LEFT/g;
	s/eBiffFontUnderline/MsBiffFontUnderline/g;
	s/eBiffFUNone/MS_BIFF_F_U_NONE/g;
	s/eBiffFUSingleAcc/MS_BIFF_F_U_SINGLE_ACC/g;
	s/eBiffFUDoubleAcc/MS_BIFF_F_U_DOUBLE_ACC/g;
	s/eBiffFUSingle/MS_BIFF_F_U_SINGLE/g;
	s/eBiffFUDouble/MS_BIFF_F_U_DOUBLE/g;
	s/eBiffFontScript/MsBiffFontScript/g;
	s/eBiffFSNone/MS_BIFF_F_S_NONE/g;
	s/eBiffFSSub/MS_BIFF_F_S_SUB/g;
	s/eBiffFSSuper/MS_BIFF_F_S_SUPER/g;
	s/eBiffHAlign/MsBiffHAlign/g;
	s/eBiffHAGeneral/MS_BIFF_H_A_GENERAL/g;
	s/eBiffHALeft/MS_BIFF_H_A_LEFT/g;
	s/eBiffHACenter/MS_BIFF_H_A_CENTER/g;
	s/eBiffHARight/MS_BIFF_H_A_RIGHT/g;
	s/eBiffHAFill/MS_BIFF_H_A_FILL/g;
	s/eBiffHAJustify/MS_BIFF_H_A_JUSTIFTY/g;
	s/eBuffHACenterAcrossSelection/MS_BIFF_H_A_CENTER_ACROSS_SELECTION/g;
	s/eBiffVAlign/MsBiffVAlign/g;
	s/eBiffVATop/MS_BIFF_V_A_TOP/g;
	s/eBiffVACenter/MS_BIFF_V_A_CENTER/g;
	s/eBiffVABottom/MS_BIFF_V_A_BOTTOM/g;
	s/eBiffVAJustify/MS_BIFF_V_A_JUSTIFY/g;
	s/eBiffOrient/MsBiffOrient/g;
	s/eBiffOHoriz/MS_BIFF_O_HORIZ/g;
	s/eBiffOVertHorizText/MS_BIFF_O_VERT_HORIZ/g;
	s/eBiffOVertVertText/MS_BIFF_O_VERT_VERT/g;
	s/eBiffOVertVertText2/MS_BIFF_O_VERT_VERT2/g;
	s/eBiffDifferences/MsBiffDifferences/g;
	s/eBiffDFormatbit/MS_BIFF_D_FORMAT_BIT/g;
	s/eBiffDFontbit/MS_BIFF_D_FONT_BIT/g;
	s/eBiffDAlignbit/MS_BIFF_D_ALIGN_BIT/g;
	s/eBiffDBorderbit/MS_BIFF_D_BORDER_BIT/g;
	s/eBiffDFillbit/MS_BIFF_D_FILL_BIT/g;
	s/eBiffDLockbit/MS_BIFF_D_LOCK_BIT/g;
	s/BIFF_BOF_DATA/MsBiffBofData/g;
	s/eBiffMaxRows/MsBiffMaxRows/g;
	s/eBiffMaxRowsV7/MS_BIFF_MAX_ROWS_V7/g;
	s/eBiffMaxRowsV8/MS_BIFF_MAX_ROWS_V8/g;

2000-06-05  Michael Meeks  <michael@helixcode.com>

	* ms-excel-read.c (sst_bound_check): Update so we can't miss
	adjacent records and we check for continues.

2000-06-03  Michael Meeks  <michael@helixcode.com>

	* ms-obj.c (ms_read_TXO): fix memory corruption bug with continue.

	* ms-escher.c (ms_escher_read_Blip): update for Oaf.

	* ms-biff.c (ms_biff_query_new): kill merging.
	(ms_biff_merge_continues): kill forever.
	(ms_biff_query_next_merge): rename to (ms_biff_query_next): and
	clean. (ms_biff_query_unmerge): kill.

2000-06-02  Michael Meeks  <michael@helixcode.com>

	* ms-excel-read.c (biff_get_text): hack nasty auto-header
	detection. (read_sst): split from (ms_excel_read_workbook).
	(get_xtn_lens): split from (biff_get_text).
	(get_utf8_chars, get_string, sst_boundcheck): implement.

2000-01-31  Michael Meeks  <mmeeks@gnu.org>

	* ms-obj.c (ms_read_TXO): re-implement to swallow CONTINUEs &
	make safer.

	* ms-biff.c (ms_biff_query_next_merge): hack do_merge = FALSE
	for now; big clean possible later.

	* ms-escher.c (ms_escher_read_Blip): always use image-generic;
	it works, disable writing image files unless debugging.
	(write_file): conditional compile out.
	(ms_escher_get_data): add BIFF_CONTINUE.

2000-01-30  Michael Meeks  <michael@mejm2.dow.cam.ac.uk>

	* ms-excel-read.c (ms_excel_read_sheet): kill blank_sheet_pos.

2000-05-30  Michael Meeks  <michael@helixcode.com>

	* Makefile.am (INCLUDES): kill explicit libole2 include.

2000-05-20  Jody Goldberg <jgoldberg@home.com>

        * Release 0.54

2000-05-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_mergecells) : Produce a warning.

2000-05-11  Michael Meeks  <michael@helixcode.com>

	* boot.c (excel_load): add basic hooks.

	* excel.h: ditto.

2000-05-16  Michael Meeks  <michael@helixcode.com>

	* Makefile.am (INCLUDES): add libole2 include.

2000-05-11  Michael Meeks  <michael@helixcode.com>

	* *.[ch]: update libole2 includes.

	* Makefile.am (INCLUDES): kill libole2 kludge.

2000-05-09  Jody Goldberg <jgoldberg@home.com>

	* Release 0.53

2000-05-05  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (ms_excel_parse_formula) : Improve warning when we
	  encounter unknown ptgAttr flags.

2000-05-03  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c : Include eval.h to suppress warning.

2000-05-03  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c (write_cell) : Use parse_pos_init_cell.

	* ms-excel-read.c (ms_excel_read_formula) : No need to manually
	  cleanout the old value.  The various assignment routines take care
	  of that.
	  Honour the recalc flags for expressions.  Array expressions are
	  still unconditionally recalced, but the common case is handled
	  correctly.

2000-04-24  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c : format police.

2000-04-21  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_insert) : Use cell_set_value
	  rather than cell_set_text to avoid attempting to parse the string.

2000-04-20  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_sheet_insert) : formats are no longer
	  associated with individual cells.  Only create a cell if it has
	  content.
	(ms_excel_formula_shared) : Rework to return the expression.  Only set
	  it if it is an array.
	(ms_excel_read_formula) : Use error values for problems not strings.
	  Use cell_set_expr_and_value when possible.
	(ms_excel_read_workbook) : Disable optimization that was culling blank
	  sheets.  It was causing a complete recalc of all loaded books for
	  eavy deleted sheet.

2000-04-20  Dan Winship  <danw@helixcode.com>

	* ms-escher.c (ms_escher_blip_new): update for changes to bonobo

2000-04-09  Morten Welinder  <terra@diku.dk>

	* ms-excel-read.c (ms_excel_sheet_append_comment): Constify.
	(ms_excel_sheet_set_comment): Ditto.
	(ms_excel_read_sheet): Plug leak.

2000-04-08  Jon K Hellan  <hellan@acm.org>

	* ms-excel-read.c (ms_excel_set_xf, ms_excel_read_formula,
	ms_excel_read_sheet):  Use
	gnum_sheet->name_unquoted instead of gnum_sheet->name in debug
	output.
	(ms_excel_read_workbook): Remove unused variable to silence
	warning.

	* ms-excel-write.c (write_externsheets): Output
	gnum_sheet->name_quoted instead of gnum_sheet->name. FIXME: Is
	this correct?
	(write_sheet): Use gnum_sheet->name_unquoted instead of
	gnum_sheet->name in debug output.
	(write_workbook): Output gnum_sheet->name_unquoted instead of
	gnum_sheet->name.

	* ms-formula-read.c (ms_excel_parse_formula): Use
	gnum_sheet->name_unquoted instead of gnum_sheet->name in debug
	output.

	* ms-obj.c (object_anchor_to_position): Ditto.

2000-04-06  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_workbook) : Move deep freeze/thaw to
	  a higher level.

2000-04-06  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (ms_excel_parse_formula) : Adjust to change in
	  value_new_range.

2000-04-04  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_obj_read_biff8_obj) : Be more careful about when to
	  dump debug info when the stated record size disagrees with the
	  actual.

2000-03-24  Jody Goldberg <jgoldberg@home.com>

	* *.[ch] : Update copywrite years.

	* ms-obj.c (ms_read_OBJ) : improve debug output.
	(ms_obj_read_biff8_obj) : Try a new heuristic for dealing with trailing IMDATA.

2000-03-23  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_xf_data_new) : Support horizontal alignment
	  center_across_selection.

	* ms-excel-write.c (halign_to_excel) : Ditto.

	* ms-obj.c (object_anchor_to_position) : remove some debug code.

2000-03-23  Jon K Hellan  <hellan@acm.org>

	* boot.c (excel_load): No longer add ".gnumeric" to filename. Set
	save info. Tag filename as MANUAL. We could make it AUTO soon.
	(excel_init): Tag saver as MANUAL.

2000-03-22  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_xf_data_new) : Add some warnings for
	  unsupported rotated text.

2000-03-21  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.c (init_xl_font_widths) : Add Geneva.

	* ms-excel-read.c (biff_xf_data_new) : Have the horizontal alignment
	  type center_across_selection default to 'center' instead.
	(ms_excel_read_workbook) : Be more explicit about NOT supporting 1904
	  dates as yet.

2000-03-14  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_xf_data_new) : Remove warning about parent
	  styles not == 0.  I finally understand what the semantics of this
	  are.  Style 0 is 'Normal' this test was doing nothing accept
	  discriminating agains 'Comma' and its friends.  We need to extend
	  the gnumeric notion of styles to include the limited form of
	  inheritance embodied by XL.

	* ms-obj.c (object_anchor_to_position) : Be VERY careful.

2000-03-13  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (object_anchor_to_position) : Be more careful handling out
	  of bounds conditions.  Part of bug 7312.

2000-03-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : Tweak colour
	  selection for contrasting colours.  FIXME : We really need to find
	  something more definative than this guess work.

	* ms-excel-read.c (ms_excel_read_selection) : Do not reset the
	  edit cursor.  It needs more work to be correct.

2000-03-09  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-util.[ch] (lookup_font_base_char_width) : Delete.

	* ms-excel-read.c (ms_excel_get_style_from_xf) : Adjust bottom and
	  right borders to be top & left of neighbouring cells.
	(ms_excel_set_xf) : Ditto.
	(ms_excel_set_xf_segment) : Ditto.

2000-03-05  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (lookup_base_char_width_for_write): Rename to
	init_base_char_width_for_write. Init width and default width.
	(get_base_char_width): Add is_default parameter.
	(write_colinfo, write_default_col_width): Use it.

	* ms-excel-write.h (struct _ExcelSheet): Add base_char_width_default.

	* ms-excel-write.c (excel_font_to_string, excel_font_new,
	excel_font_hash, excel_font_equal, write_font): Handle underline,
	strikethrough.

	* ms-excel-write.h (struct _ExcelFont): Ditto

2000-03-05  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : enable strikethrough.

2000-03-01  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (biff_font_data_new) : Fix old typo.

2000-02-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : Add support for
	  importing underlines.

2000-02-18  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_get_style_from_xf) : Hard code 'auto'
	  border colours to black for now.  We are not guessing well.

2000-02-15  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (object_anchor_to_position) : Improve debug output.

	* ms-excel-read.c (ms_excel_sheet_new) : Add new member base_char_width_default.
	(print_font_mapping_debug_info) : Delete.
	(lookup_base_char_width_for_read) : Rename init_base_char_width_for_read,
	  and use lookup_font_base_char_width_new to init the width and the
	  default_width.
	(get_base_char_width) : Adjust.
	(ms_excel_read_colinfo) : Width is different from default_width...  Idiots!
	(ms_excel_read_default_col_width) : Ditto.

	* ms-excel-util.c : Add lookup tables for various standard widths of
	  MS fonts.  Use a quick and dirty linear scaling to calculate the
	  widths of arbitrary font sizes.

2000-02-14  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_row) : heights are specified
	  including margins and 1 grid line.  Do not use get_units_net_of_margins.
	(get_units_net_of_margins) : Delete.

2000-02-13  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_workbook) : Adjust WINDOW size
	  measurements from points to pixels.

2000-02-12  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_default_col_width) : Margins are
	  internal now.
	(ms_excel_read_default_row_height) : Ditto.
	(ms_excel_read_colinfo) : Ditto.
	(ms_excel_read_row) : Adjust to changes in margins and step closer to
	  handling think margins.

	* ms-excel-write.c (write_rowinfo) : Use the size_pts member directly.
	(write_colinfos) : ditto.

	* ms-obj.c (object_anchor_to_position) : Adjust to name and semantic
	  changes of size_pixels.  Denominate things in pixels.

2000-02-06  Michael Meeks  <michael@helixcode.com>

	* ms-excel-read.c (ms_excel_read_workbook): Move failed sheet removal
	here + add pristine culling instead of 0 byte in sheet header, may
	introduce bugs but will help fix sheet_is_pristine. Fix potential
	sheet object leak. (ms_excel_read_sheet): do not detach in error case.

2000-01-30  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_sheet): Correct the max no. of rows check.

2000-01-29  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_workbook) : Correct the error
	  handling.

2000-01-29  Jon K Hellan  <hellan@acm.org>

	Megacommit.

	The purpose of the changeset is twofold:

	1. Use CommandContexts for error reporting for file read/save.
	2. This allows us to let FileFormatOpen return 0 on success, -1 on
	   failure, same as FileFormatSave. The convention to return NULL
	   on success was highly ideosyncratic.

	* excel.h (ms_excel_read_workbook, ms_excel_write_workbook) Add
	CommandContext. Return int.

	* ms-excel-read.c (ms_excel_read_workbook): Add
	CommandContext. Return 0 on success, -1 on failure. Use
	gnumeric_error_read to display messages.

	* ms-excel-write.c (write_sheet): Check max no. of rows for the
	format.
	(new_sheet): Return the ExcelSheet. Let caller add it to
	wb->sheets.
	(pre_pass): Add CommandContext.
	(free_workbook): New function, previously in write_workbook.
	(write_workbook): Change parameter from Workbook to ExcelWorkbook.
	Move deallocation to free_workbook.
	(check_sheet): New function. Check if we are able to save the
	sheet.
	(ms_excel_check_write): New function. Check if we are able to save
	to the file. Do initialization previously in
	ms_excel_write_workbook.
	(ms_excel_write_workbook): Add CommandContext. Add state. Change
	wb from Workbook to ExcelWorkbook. Use gnumeric_error_save to
	report problems. Return 0 on success, -1 on failure.

	* ms-excel-biff.h: Define enum for max no. of rows. Fix typo.

	* boot.c (excel_load, excel_save, excel_save_98, excel_save_95):
	Add CommandContext.
	(excel_load): Return 0 on success, -1 on failure.
	Use gnumeric_error_read to display messages. Remove "Opening .. "
	message on stdout.
	(excel_probe_write): New function. Check if we are able to save to
	the file.
	(excel_save): Use gnumeric_error_save to display messages.
	Return 0 on success, -1 on failure.

2000-01-18  Jody Goldberg <jgoldberg@home.com>

	* ms-formula-read.c (ms_excel_parse_formula) : Add OPER_UNARY_PLUS.

	* ms-formula-write.c (write_node) : Ditto.

	* ms-excel-read.c (get_units_net_of_margins) : Return 1 when faced
	  with < 0 sized things.
	(ms_excel_read_row) : Support hidden rows.
	(ms_excel_read_colinfo) : Support hidden columns.

2000-01-17  Frank Chiulli  <fc-linux@home.com>

	* ms-summary.c (ms_summary_write): Turn on writing out the
	  DocumentSummaryInformation stream.

2000-01-17  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-write.c : Remove unused xml includes.

2000-01-17  Jody Goldberg <jgoldberg@home.com>

	* ms-chart.c (ms_excel_chart) : Apparently BIFF_NUMBER records show up
	  in charts.

	* ms-excel-read.c (ms_excel_read_workbook) : Improve sizing of
	  window, Use the support for some of the new preferences
	  hiding scrollbars, and notebooktabs.

	* ms-excel-read.c (ms_excel_read_sheet) : Use support for
	  hidden grid lines, hidden formulas, hidden zeros, hidden
	  row/col headers.  Use the information on where the upper left
	  corner is.

2000-01-14  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.h: (ExcelWorkbook): Make
	sheet->cells an array of arrays.

	* ms-excel-write.c (excel_cell_get): Make inline.
	(excel_cell_get, new_sheet, new_sheet, free_sheet): Make
	sheet->cells an array of arrays.

2000-01-13  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_workbook) : Move magic scale hack
	  into a single #define.  Use workbook_view_set_size.

2000-01-10  Jody Goldberg <jgoldberg@home.com>

	* ms-obj.c (ms_read_TXO) : Return the string generated rather than
	  leaking it.
	(ms_read_OBJ) : Don't warn about comments, they are not sheet objects
	  which breaks the whole function of this routine but they are not
	  unexpected.  If we can figur eout how to store the string associated
	  with the TXO nearby with this object and get that cleaned up on
	  time and referencable by obj-ID then we can fix comment import.

	* ms-excel-read.c (ms_excel_read_sheet) : Improve handling for
	  WINDOW1 and warn about more unsupported cases.  Tweak zoom factor
	  by 1.4 to be less ugly. (ICK !  HACK!)
	(ms_excel_read_workbook) : WINDOW2 is a sheet level
	  descriptor.  Add handle for WINDOW1.
	(ms_excel_sheet_new) : ICK!  hard code a scale
	  factor of 1.4 to get things to be less ugly.

2000-01-05  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_colinfos): Fix off by one error.
	(write_sheet_bools): Ditto.

2000-01-03  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_read_sheet) : extend support for WINDOW2.
	(ms_excel_read_selection) : Remove hack to set visible location.

1999-12-30  Jody Goldberg <jgoldberg@home.com>

	* ms-excel-read.c (ms_excel_workbook_new) : Return error messages.
	(ms_excel_read_workbook) : If a file is password protected do NOT
	  attempt to read it.

	* boot.c (excel_load) : return error messages.

1999-12-23  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_bits): Use "The Free Software
	Foundation" as name.

	* excel.h (WRITEACCESS_LEN): Define it.

1999-12-21  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (write_index, write_db_cell, write_block,
	write_sheet): Write row info records in blocks of 32. Excel was
	unable to read files we made if they were over 517 rows. Limit is
	now pushed to 16544.
	(write_index): Assertion no longer true - removed it. Refer to
	Excel doc page.
	(write_db_cell): Write offsets for all rows in block in single
	record. Add number of rows parameter.
	(write_block): New function. Write a block of rows. Previously
	part of write_sheet, but changed for blocked row info.
	(write_sheet): Move inner loop to write_block.
	(new_sheet): Initialize sheet->cells to 0.

	* excel.h (ROW_BLOCK_MAX_LEN): Define.

1999-12-21  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (fixup_fill_colors): Fix minor bug.

1999-12-17  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.h (struct _ExcelCol ): define it
	(struct _ExcelSheet): Add base_char_width

	* ms-excel-write.c (log_put_color, palette_get_index,
	gather_palette, write_palette, excel_font_new, excel_font_hash,
	excel_font_equal, after_put_format, map_pattern_index_to_excel,
	halign_to_excel, valign_to_excel, fixup_fill_colors,
	get_xf_differences, log_xf_data, build_xf_data,
	write_xf_magic_record, write_value, write_formula, write_cell,
	write_mulblank, pre_pass): Cosmetics
	(write_font, write_fonts, write_format, write_formats,
	write_xf_record, write_xf, write_workbook): Conform to
	conventional parameter order
	(orientation_to_excel, border_type_to_excel): Make inline
	(write_default_row_height): New function. Write default row
	height.
	(lookup_base_char_width_for_write): New function. Locate font for
	measuring base char width, and call measuring function.
	(get_base_char_width): New function: Return base char width for
	column sizing.
	(write_default_col_width): New function. Write default col width.
	(write_colinfo): New function. Write column info for a run of
	identical columns
	(write_colinfos): New function. Write column info for all columns.
	(write_sheet_bools): Use write_default_row_height,
	write_default_col_width, write_colinfos.
	(write_sheet_bools):
	(write_rowinfo): Write true row height. Add sheet to signature.
	(write_sheet): Add sheet to write_rowinfo call.
	(new_sheet): Initialize base_char_width.

	* ms-excel-util.h: #include <sheet.h>
	(EXCEL_DEFAULT_CHAR_WIDTH): Move here from ms-excel-read.h
	(lookup_font_base_char_width): Declare it.

	* ms-excel-util.c (lookup_font_base_char_width): New
	function. Measure "base character width" of font. Previously in
	lookup_base_char_width in ms-excel-read.c

	* ms-excel-read.c: #include ms-excel-util.h
	(lookup_base_char_width_for_read): Renamed from
	lookup_base_char_width because of similar, but different function
	in ms-excel-write.c. Split in two. Font locating stays here. Font
	measuring moved to new function lookup_font_base_char_width in
	ms-excel-util.c
	(get_base_char_width): Use lookup_base_char_width_for_read.
	(ms_excel_read_default_row_height): Refer to Excel doc page.
	(ms_excel_read_default_col_width): Ditto

1999-12-14  Jon K Hellan  <hellan@acm.org>

        * ms-excel-write.h (XF_MAGIC, PALETTE_ALSO_BLACK, FILL_MAGIC,
        BORDER_MAGIC): define
        (PALETTE_WHITE, PALETTE_BLACK): Fix typo, they were switched around.

        * ms-excel-write.c (put_colors): Include border colors.
        (excel_font_new): Newline to conform to coding style.
        (fonts_get_font): New function. Get font, given index.
        (fonts_free, write_fonts): Use it.
        (write_font): Fix boldstyle typo.
        (formats_get_format): New function. Get format, given index.
        (formats_free, write_format): Use it.
        (xf_get_mstyle): New function. Get mstyle, given index.
        (xf_free): Use it.
        (halign_to_excel):
        New function. Map horizontal alignment to Excel bitfield
        (valign_to_excel):
        New function. Map vertical alignment to Excel bitfield.
        (orientation_to_excel):
        New function. Map text orientation to Excel bitfield.
        (border_type_to_excel):
        New function. Map border type to Excel bitfield.
        (fixup_fill_colors):
        New function. Kluge fill foreground and background colors.
        (get_xf_differences): Fill out map of differences to parent style.
        (log_xf_data):
        New function. Log XF data for a record about to be written. Pulled
        out of write_xf_record.
        (build_xf_data): New function. Build XF data for a style. Pulled
        out of write_xf_record, but uses BiffXFData struct. Add support
        for borders, alignments, wrap, rotation. Change some
        local variable names for consistency with import code.
        (write_xf_magic_record): Comment magic color value.
        (write_xf_record): Change signature, take BiffXFData instead of
        mstyle. Simplify by moving out logging and marshaling. Make more
        complex by writing borders, alignment, wrap, rotation.
        (write_xf): Use xf_get_mstyle, build_xf_data, log_xf_data.

        * ms-excel-util.h: Fix typo.

        * ms-excel-xf.h: New file for BiffXFData struct def.

        * ms-excel-read.c: Move BiffXFData struct def to
        ms-excel-xf.h. Include ms-excel-xf.h. Remove include "border.h" -
        ms-excel-xf.h includes it.
        (ms_excel_get_style_from_xf): Express some bewilderment.

        * ms-excel-biff.h: Define enums for horizontal alignment, vertical
        alignment, text orientation, difference bits

1999-12-11  Frank Chiulli  <fchiulli@home.com>

	* ms-summary.c (ms_summary_write): comment out DocumentSummary.

	* boot.c (excel_save): re-enable summary write.

1999-12-14 Valerie A Henson  <val@nmt.edu>

	* ms-obj.c: s/dump/ms_ole_dump/

	* ms-biff.c: s/dump/ms_ole_dump/

	* ms-formula-read.c: s/dump/ms_ole_dump/

	* ms-excel-read.c: s/dump/ms_ole_dump/

1999-12-09  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c (excel_font_hash, excel_font_equal, excel_font_free):
	fixup pointer bits.

1999-12-08  Jon K Hellan  <hellan@acm.org>

	* ms-excel-write.c: (palette_color_to_int): New function. Convert
	EXCEL_PALETTE_ENTRY to guint.
	(style_color_to_int): New function. Convert StyleColor to guint.
	(log_put_color): New function. Debug log when color added to
	palette
	(palette_put_defaults): New function. Put Excel default colors to
	palette.
	(palette_init): New function. Initialize palette table.
	(palette_free): New function. Free palette table.
	(palette_get_index): New function. Get color index.
	(put_color): New function. Add color to palette.
	(put_colors): New function. Add colors in MStyle to palette
	(gather_palette): New function. Add all colors in workbook to
	palette.
	(write_palette): Use color info from styles. Make void.
	(excel_font_to_string): New function. Return string desc. of font
	(excel_font_new): New function. Make an ExcelFont (font + color).
	(excel_font_free): New function. Free an ExcelFont.
	(excel_font_hash): New function. Hash function for ExcelFonts.
	(excel_font_equal): New function. Compare ExcelFonts.
	(fonts_init): New function. Initialize font table
	(fonts_free): New function. Free font table.
	(fonts_get_index): New function. Get index of ExcelFont
	(after_put_font): New function. Debug log when font is added to
	table.
	(put_font): New function. Add font to table.
	(gather_fonts): New function. Add all fonts in workbook to table.
	(write_font): New function. Write a font to file. Essentially,
	inner loop of the old version of write_fonts.
	(write_fonts): Rewritten. Make void
	(after_put_format): New function. Debug log when format is added
	to table.
	(formats_put_magic): New function. Add builit-in formats to table.
